type token =
  | TUnknown of (Ast_c.info)
  | TCommentSpace of (Ast_c.info)
  | TCommentNewline of (Ast_c.info)
  | TComment of (Ast_c.info)
  | TInt of ((string * (Ast_c.sign * Ast_c.base)) * Ast_c.info)
  | TFloat of ((string * Ast_c.floatType) * Ast_c.info)
  | TChar of ((string * Ast_c.isWchar) * Ast_c.info)
  | TString of ((string * Ast_c.isWchar) * Ast_c.info)
  | TQuote of ((string * Ast_c.isWchar) * Ast_c.info)
  | TPct of (Ast_c.info)
  | TFormat of (string * Ast_c.info)
  | TSubString of (string * Ast_c.info)
  | TDecimal of ((string * string (*n*) * string (*p*)) * Ast_c.info)
  | TIdent of (string * Ast_c.info)
  | TKRParam of (string * Ast_c.info)
  | Tconstructorname of (string * Ast_c.info)
  | TypedefIdent of (string * Ast_c.info)
  | TOPar of (Ast_c.info)
  | TCPar of (Ast_c.info)
  | TOBrace of (Ast_c.info)
  | TCBrace of (Ast_c.info)
  | TOCro of (Ast_c.info)
  | TCCro of (Ast_c.info)
  | TDot of (Ast_c.info)
  | TComma of (Ast_c.info)
  | TPtrOp of (Ast_c.info)
  | TInc of (Ast_c.info)
  | TDec of (Ast_c.info)
  | TAssign of (Ast_c.assignOp)
  | TEq of (Ast_c.info)
  | TWhy of (Ast_c.info)
  | TTilde of (Ast_c.info)
  | TBang of (Ast_c.info)
  | TEllipsis of (Ast_c.info)
  | TDotDot of (Ast_c.info)
  | TPtVirg of (Ast_c.info)
  | TOrLog of (Ast_c.info)
  | TAndLog of (Ast_c.info)
  | TOr of (Ast_c.info)
  | TXor of (Ast_c.info)
  | TAnd of (Ast_c.info)
  | TEqEq of (Ast_c.info)
  | TNotEq of (Ast_c.info)
  | TInf of (Ast_c.info)
  | TSup of (Ast_c.info)
  | TInfEq of (Ast_c.info)
  | TSupEq of (Ast_c.info)
  | TShl of (Ast_c.info)
  | TShr of (Ast_c.info)
  | TPlus of (Ast_c.info)
  | TMinus of (Ast_c.info)
  | TMul of (Ast_c.info)
  | TDiv of (Ast_c.info)
  | TMod of (Ast_c.info)
  | TMax of (Ast_c.info)
  | TMin of (Ast_c.info)
  | Tchar of (Ast_c.info)
  | Tshort of (Ast_c.info)
  | Tint of (Ast_c.info)
  | Tdouble of (Ast_c.info)
  | Tfloat of (Ast_c.info)
  | Tlong of (Ast_c.info)
  | Tunsigned of (Ast_c.info)
  | Tsigned of (Ast_c.info)
  | Tvoid of (Ast_c.info)
  | Tsize_t of (Ast_c.info)
  | Tssize_t of (Ast_c.info)
  | Tptrdiff_t of (Ast_c.info)
  | Tauto of (Ast_c.info)
  | Tregister of (Ast_c.info)
  | Textern of (Ast_c.info)
  | Tstatic of (Ast_c.info)
  | Ttypedef of (Ast_c.info)
  | Tconst of (Ast_c.info)
  | Tvolatile of (Ast_c.info)
  | Tstruct of (Ast_c.info)
  | Tunion of (Ast_c.info)
  | Tenum of (Ast_c.info)
  | Tdecimal of (Ast_c.info)
  | Texec of (Ast_c.info)
  | Tbreak of (Ast_c.info)
  | Telse of (Ast_c.info)
  | Tswitch of (Ast_c.info)
  | Tcase of (Ast_c.info)
  | Tcontinue of (Ast_c.info)
  | Tfor of (Ast_c.info)
  | Tdo of (Ast_c.info)
  | Tif of (Ast_c.info)
  | Twhile of (Ast_c.info)
  | Treturn of (Ast_c.info)
  | Tgoto of (Ast_c.info)
  | Tdefault of (Ast_c.info)
  | Tsizeof of (Ast_c.info)
  | Tnew of (Ast_c.info)
  | Tdelete of (Ast_c.info)
  | Tdefined of (Ast_c.info)
  | TOParCplusplusInit of (Ast_c.info)
  | Tnamespace of (Ast_c.info)
  | Trestrict of (Ast_c.info)
  | Tasm of (Ast_c.info)
  | Tattribute of (Ast_c.info)
  | TattributeNoarg of (Ast_c.info)
  | Tinline of (Ast_c.info)
  | Ttypeof of (Ast_c.info)
  | TDefine of (Ast_c.info)
  | TDefParamVariadic of ((string * Ast_c.info))
  | TCppEscapedNewline of (Ast_c.info)
  | TCppConcatOp of (Ast_c.info)
  | TOParDefine of (Ast_c.info)
  | TOBraceDefineInit of (Ast_c.info)
  | TIdentDefine of ((string * Ast_c.info))
  | TDefEOL of (Ast_c.info)
  | TInclude of ((string * string * bool ref * Ast_c.info))
  | TIncludeStart of ((Ast_c.info * bool ref))
  | TIncludeFilename of ((string * Ast_c.info))
  | TIfdef of ((Ast_c.ifdef_guard * (int * int) option ref * Ast_c.info))
  | TIfdefelif of ((Ast_c.ifdef_guard * (int * int) option ref * Ast_c.info))
  | TIfdefelse of (((int * int) option ref * Ast_c.info))
  | TEndif of (((int * int) option ref * Ast_c.info))
  | TIfdefBool of ((bool * (int * int) option ref * Ast_c.info))
  | TIfdefMisc of ((bool * (int * int) option ref * Ast_c.info))
  | TIfdefVersion of ((bool * (int * int) option ref * Ast_c.info))
  | TUifdef of (Ast_c.info)
  | TUelseif of (Ast_c.info)
  | TUendif of (Ast_c.info)
  | TUndef of (Ast_c.info)
  | TPragma of (Ast_c.info)
  | TCppDirectiveOther of (Ast_c.info)
  | TMacroAttr of ((string * Ast_c.info))
  | TMacroStmt of ((string * Ast_c.info))
  | TMacroIdentBuilder of ((string * Ast_c.info))
  | TMacroString of ((string * Ast_c.info))
  | TMacroDecl of ((string * Ast_c.info))
  | TMacroDeclConst of (Ast_c.info)
  | TMacroIterator of ((string * Ast_c.info))
  | TMacroAttrStorage of ((string * Ast_c.info))
  | TCommentSkipTagStart of (Ast_c.info)
  | TCommentSkipTagEnd of (Ast_c.info)
  | TCParEOL of (Ast_c.info)
  | TAction of (Ast_c.info)
  | TCommentMisc of (Ast_c.info)
  | TCommentCpp of ((Token_c.cppcommentkind * Ast_c.info))
  | EOF of (Ast_c.info)

open Parsing;;
let _ = parse_error;;
# 2 "parser_c.mly"
(* Yoann Padioleau
 *
 * Copyright (C) 2002, 2006, 2007, 2008, 2009 Yoann Padioleau
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License (GPL)
 * version 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * file license.txt for more details.
 *)
open Common

open Ast_c

module LP = Lexer_parser
open Lexer_parser (* for the fields *)

open Semantic_c (* Semantic exn *)
module T = Token_c

(*****************************************************************************)
(* Wrappers *)
(*****************************************************************************)
let warning s v =
  if !Flag_parsing_c.verbose_parsing
  then Common.warning ("PARSING: " ^ s) v
  else v

let pr2, pr2_once = Common.mk_pr2_wrappers Flag_parsing_c.verbose_parsing

(*****************************************************************************)
(* Parse helpers functions *)
(*****************************************************************************)

(*-------------------------------------------------------------------------- *)
(* Type related *)
(*-------------------------------------------------------------------------- *)

type shortLong      = Short  | Long | LongLong

type decl = {
  storageD: storagebis wrap;
  typeD: ((sign option) * (shortLong option) * (typeCbis option)) wrap;
  qualifD: typeQualifierbis wrap;
  inlineD: bool             wrap;
  (* note: have a full_info: parse_info list; to remember ordering
   * between storage, qualifier, type ? well this info is already in
   * the Ast_c.info, just have to sort them to get good order *)
}

let nullDecl = {
  storageD = NoSto, [];
  typeD = (None, None, None), [];
  qualifD = nullQualif;
  inlineD = false, [];
}
let fake_pi = Common.fake_parse_info

let addStorageD  = function
  | ((x,ii), ({storageD = (NoSto,[])} as v)) -> { v with storageD = (x, [ii]) }
  | ((x,ii), ({storageD = (y, ii2)} as v)) ->
      if x = y then warning "duplicate storage classes" v
      else raise (Semantic ("multiple storage classes", fake_pi))

let addInlineD  = function
  | ((true,ii), ({inlineD = (false,[])} as v)) -> { v with inlineD=(true,[ii])}
  | ((true,ii), ({inlineD = (true, ii2)} as v)) -> warning "duplicate inline" v
  | _ -> raise (Impossible 86)


let addTypeD     = function
  | ((Left3 Signed,ii)   ,({typeD = ((Some Signed,  b,c),ii2)} as v)) ->
      warning "duplicate 'signed'"   v
  | ((Left3 UnSigned,ii) ,({typeD = ((Some UnSigned,b,c),ii2)} as v)) ->
      warning "duplicate 'unsigned'" v
  | ((Left3 _,ii),        ({typeD = ((Some _,b,c),ii2)} as _v)) ->
      raise (Semantic ("both signed and unsigned specified", fake_pi))
  | ((Left3 x,ii),        ({typeD = ((None,b,c),ii2)} as v))   ->
      {v with typeD = (Some x,b,c),ii @ ii2}

  | ((Middle3 Short,ii),  ({typeD = ((a,Some Short,c),ii2)} as v)) ->
      warning "duplicate 'short'" v


  (* gccext: long long allowed *)
  | ((Middle3 Long,ii),   ({typeD = ((a,Some Long ,c),ii2)} as v)) ->
      { v with typeD = (a, Some LongLong, c),ii @ ii2 }
  | ((Middle3 Long,ii),   ({typeD = ((a,Some LongLong ,c),ii2)} as v)) ->
      warning "triplicate 'long'" v


  | ((Middle3 _,ii),      ({typeD = ((a,Some _,c),ii2)} as _v)) ->
      raise (Semantic ("both long and short specified", fake_pi))
  | ((Middle3 x,ii),      ({typeD = ((a,None,c),ii2)} as v))  ->
      {v with typeD = (a, Some x,c),ii @ ii2}

  | ((Right3 t,ii),       ({typeD = ((a,b,Some x),ii2)} as _v)) ->
      raise (Semantic ((Printf.sprintf "two or more data types: t %s ii %s\ntypeD %s ii2 %s\n" (Dumper.dump t) (Dumper.dump ii) (Dumper.dump x) (Dumper.dump ii2)), fake_pi))
  | ((Right3 t,ii),       ({typeD = ((a,b,None),ii2)} as v))   ->
      {v with typeD = (a,b, Some t),ii @ ii2}


let addQualif = function
  | ({const=true},   ({const=true} as x)) ->   warning "duplicate 'const'" x
  | ({volatile=true},({volatile=true} as x))-> warning "duplicate 'volatile'" x
  | ({const=true},    v) -> {v with const=true}
  | ({volatile=true}, v) -> {v with volatile=true}
  | _ ->
      internal_error "there is no noconst or novolatile keyword"

let addQualifD ((qu,ii), ({qualifD = (v,ii2)} as x)) =
  { x with qualifD = (addQualif (qu, v),ii::ii2) }


(*-------------------------------------------------------------------------- *)
(* Declaration/Function related *)
(*-------------------------------------------------------------------------- *)


(* stdC: type section, basic integer types (and ritchie)
 * To understand the code, just look at the result (right part of the PM)
 * and go back.
 *)
let (fixDeclSpecForDecl: decl -> (fullType * (storage wrap)))  = function
 {storageD = (st,iist);
  qualifD = (qu,iiq);
  typeD = (ty,iit);
  inlineD = (inline,iinl);
  } ->
   let ty',iit' =
   (match ty with
 | (None,None,None)       ->
     (* generate fake_info, otherwise type_annotater can crash in
      * offset.
      *)
     warning "type defaults to 'int'" (defaultInt, [fakeInfo fake_pi])
 | (None, None, Some t)   -> (t, iit)

 | (Some sign,   None, (None| Some (BaseType (IntType (Si (_,CInt))))))  ->
     BaseType(IntType (Si (sign, CInt))), iit
 | ((None|Some Signed),Some x,(None|Some(BaseType(IntType (Si (_,CInt)))))) ->
     BaseType(IntType (Si (Signed, [Short,CShort; Long, CLong; LongLong, CLongLong] +> List.assoc x))), iit
 | (Some UnSigned, Some x, (None| Some (BaseType (IntType (Si (_,CInt))))))->
     BaseType(IntType (Si (UnSigned, [Short,CShort; Long, CLong; LongLong, CLongLong] +> List.assoc x))), iit
 | (Some sign,   None, (Some (BaseType (IntType CChar))))   ->
     BaseType(IntType (Si (sign, CChar2))), iit
 | (None, Some Long,(Some(BaseType(FloatType CDouble))))    ->
     BaseType (FloatType (CLongDouble)), iit

 | (Some _,_, Some _) ->
     (*mine*)
     raise (Semantic ("signed, unsigned valid only for char and int", fake_pi))
 | (_,Some _,(Some(BaseType(FloatType (CFloat|CLongDouble))))) ->
     raise (Semantic ("long or short specified with floating type", fake_pi))
 | (_,Some Short,(Some(BaseType(FloatType CDouble)))) ->
     raise (Semantic ("the only valid combination is long double", fake_pi))

 | (_, Some _, Some _) ->
     (* mine *)
     raise (Semantic ("long, short valid only for int or float", fake_pi))

     (* if do short uint i, then gcc say parse error, strange ? it is
      * not a parse error, it is just that we dont allow with typedef
      * either short/long or signed/unsigned. In fact, with
      * parse_typedef_fix2 (with et() and dt()) now I say too parse
      * error so this code is executed only when do short struct
      * {....} and never with a typedef cos now we parse short uint i
      * as short ident ident => parse error (cos after first short i
      * pass in dt() mode) *)

   )
   in
   ((qu, iiq),
   (ty', iit'))
     ,((st, inline),iist @ iinl)


let fixDeclSpecForParam = function ({storageD = (st,iist)} as r) ->
  let ((qu,ty) as v,_st) = fixDeclSpecForDecl r in
  match st with
  | (Sto Register) -> (v, true), iist
  | NoSto -> (v, false), iist
  | _ ->
      raise
        (Semantic ("storage class specified for parameter of function",
                  fake_pi))

let fixDeclSpecForMacro = function ({storageD = (st,iist)} as r) ->
  let ((qu,ty) as v,_st) = fixDeclSpecForDecl r in
  match st with
  | NoSto -> v
  | _ ->
      raise
        (Semantic ("storage class specified for macro type decl",
                  fake_pi))


let fixDeclSpecForFuncDef x =
  let (returnType,storage) = fixDeclSpecForDecl x in
  (match fst (unwrap storage) with
  | StoTypedef ->
      raise (Semantic ("function definition declared 'typedef'", fake_pi))
  | _ -> (returnType, storage)
  )


(* parameter: (this is the context where we give parameter only when
 * in func DEFINITION not in funct DECLARATION) We must have a name.
 * This function ensure that we give only parameterTypeDecl with well
 * formed Classic constructor todo?: do we accept other declaration
 * in ? so I must add them to the compound of the deffunc. I dont
 * have to handle typedef pb here cos C forbid to do VF f { ... }
 * with VF a typedef of func cos here we dont see the name of the
 * argument (in the typedef)
 *)
let (fixOldCDecl: fullType -> fullType) = fun ty ->
  match Ast_c.unwrap_typeC ty with
  | FunctionType (fullt, (params, (b, iib))) ->

      (* stdC: If the prototype declaration declares a parameter for a
       * function that you are defining (it is part of a function
       * definition), then you must write a name within the declarator.
       * Otherwise, you can omit the name. *)
      (match params with
      | [{p_namei = None; p_type = ty2},_] ->
          (match Ast_c.unwrap_typeC ty2 with
          | BaseType Void ->
              ty
          | _ ->
              pr2_once ("SEMANTIC:parameter name omitted, but I continue");
              ty
          )

      | params ->
          (params +> List.iter (fun (param,_) ->
            match param with
            | {p_namei = None} ->
              (* if majuscule, then certainly macro-parameter *)
                pr2_once ("SEMANTIC:parameter name omitted, but I continue");
	    | _ -> ()
          ));
          ty
      )

        (* todo? can we declare prototype in the decl or structdef,
           ... => length <> but good kan meme *)
  | _ ->
      (* gcc say parse error but dont see why *)
      raise (Semantic ("seems this is not a function", fake_pi))


let fixFunc (typ, compound, old_style_opt) =
  let (cp,iicp) = compound in

  let (name, ty,   (st,iist),  attrs) = typ in

  let (qu, tybis) = ty in

  match Ast_c.unwrap_typeC ty with
  | FunctionType (fullt, (params,abool)) ->
      let iifunc = Ast_c.get_ii_typeC_take_care tybis in

      let iistart = Ast_c.fakeInfo () in
      assert (qu = nullQualif);

      (match params with
      | [{p_namei= None; p_type = ty2}, _] ->
          (match Ast_c.unwrap_typeC ty2 with
          | BaseType Void ->  ()
          | _ ->
                (* failwith "internal errror: fixOldCDecl not good" *)
              ()
          )
      | params ->
          params +> List.iter (function
          | ({p_namei = Some s}, _) -> ()
	  | _ -> ()
                (* failwith "internal errror: fixOldCDecl not good" *)
          )
      );
      (* bugfix: cf tests_c/function_pointer4.c.
       * Apparemment en C on peut syntaxiquement ecrire ca:
       *
       *   void a(int)(int x);
       * mais apres gcc gueule au niveau semantique avec:
       *   xxx.c:1: error: 'a' declared as function returning a function
       * Je ne faisais pas cette verif. Sur du code comme
       *   void METH(foo)(int x) { ...} , le parser croit (a tort) que foo
       * est un typedef, et donc c'est parsé comme l'exemple precedent,
       * ce qui ensuite confuse l'unparser qui n'est pas habitué
       * a avoir dans le returnType un FunctionType et qui donc
       * pr_elem les ii dans le mauvais sens ce qui genere au final
       * une exception. Hence this fix to at least detect the error
       * at parsing time (not unparsing time).
       *)
      (match Ast_c.unwrap_typeC fullt with
      | FunctionType _ ->
          let s = Ast_c.str_of_name name in
          let iis = Ast_c.info_of_name name in
          pr2 (spf "WEIRD: %s declared as function returning a function." s);
          pr2 (spf "This is probably because of a macro. Extend standard.h");
          raise (Semantic (spf "error: %s " s, Ast_c.parse_info_of_info iis))
      | _ -> ()
      );

      (* it must be nullQualif,cos parser construct only this*)
      {f_name = name;
       f_type = (fullt, (params, abool));
       f_storage = st;
       f_body =
	if !Flag_parsing_c.parsing_header_for_types
	then []
	else cp;
       f_attr = attrs;
       f_old_c_style = old_style_opt;
      },
      (iifunc @ iicp @ [iistart] @ iist)
  | _ ->
      raise
        (Semantic
            ("you are trying to do a function definition but you dont give " ^
             "any parameter", fake_pi))


(*-------------------------------------------------------------------------- *)
(* parse_typedef_fix2 *)
(*-------------------------------------------------------------------------- *)

let dt s () =
  if !Flag_parsing_c.debug_etdt then pr2 ("<" ^ s);
  LP.disable_typedef ()

let et s () =
  if !Flag_parsing_c.debug_etdt then pr2 (">" ^ s);
  LP.enable_typedef ()


let fix_add_params_ident x =
  let (s, ty, st, _attrs) = x in
  match Ast_c.unwrap_typeC ty with
  | FunctionType (fullt, (params, bool)) ->

      (match params with
      | [{p_namei=None; p_type=ty2}, _] ->
          (match Ast_c.unwrap_typeC ty2 with
          | BaseType Void -> ()
          | _ ->
              (* failwith "internal errror: fixOldCDecl not good" *)
              ()
          )
      | params ->
          params +> List.iter (function
          | ({p_namei= Some name}, _) ->
              LP.add_ident (Ast_c.str_of_name s)
	  | _ ->
              ()
                (* failwith "internal errror: fixOldCDecl not good" *)
          )
      )
  | _ -> ()

(*-------------------------------------------------------------------------- *)
(* shortcuts *)
(*-------------------------------------------------------------------------- *)

let mk_e e ii = Ast_c.mk_e e ii

let mk_string_wrap (s,info) = (s, [info])

(*-------------------------------------------------------------------------- *)
(* support for functions with no return type *)
(*-------------------------------------------------------------------------- *)

let args_are_params l =
  match l with
    [Right (ArgAction(ActMisc [x])), ii] when Ast_c.is_fake x -> true
  | _ -> List.for_all (function Right (ArgType x), ii -> true | _ -> false) l
let args_to_params l pb =
  let pi =
    match pb with Some pb -> Ast_c.parse_info_of_info pb | None -> fake_pi in
  match l with
    [(Right (ArgAction(ActMisc [x])), ii)] when Ast_c.is_fake x -> []
  | l ->
      List.map
	(function
	    Right (ArgType x), ii -> x, ii
	  | x ->
	      raise
		(Semantic
		   ("function with no return type must have types in param list",
		    pi)))
	l

# 546 "parser_c.ml"
let yytransl_const = [|
    0|]

let yytransl_block = [|
  257 (* TUnknown *);
  258 (* TCommentSpace *);
  259 (* TCommentNewline *);
  260 (* TComment *);
  261 (* TInt *);
  262 (* TFloat *);
  263 (* TChar *);
  264 (* TString *);
  265 (* TQuote *);
  266 (* TPct *);
  267 (* TFormat *);
  268 (* TSubString *);
  269 (* TDecimal *);
  270 (* TIdent *);
  271 (* TKRParam *);
  272 (* Tconstructorname *);
  273 (* TypedefIdent *);
  274 (* TOPar *);
  275 (* TCPar *);
  276 (* TOBrace *);
  277 (* TCBrace *);
  278 (* TOCro *);
  279 (* TCCro *);
  280 (* TDot *);
  281 (* TComma *);
  282 (* TPtrOp *);
  283 (* TInc *);
  284 (* TDec *);
  285 (* TAssign *);
  286 (* TEq *);
  287 (* TWhy *);
  288 (* TTilde *);
  289 (* TBang *);
  290 (* TEllipsis *);
  291 (* TDotDot *);
  292 (* TPtVirg *);
  293 (* TOrLog *);
  294 (* TAndLog *);
  295 (* TOr *);
  296 (* TXor *);
  297 (* TAnd *);
  298 (* TEqEq *);
  299 (* TNotEq *);
  300 (* TInf *);
  301 (* TSup *);
  302 (* TInfEq *);
  303 (* TSupEq *);
  304 (* TShl *);
  305 (* TShr *);
  306 (* TPlus *);
  307 (* TMinus *);
  308 (* TMul *);
  309 (* TDiv *);
  310 (* TMod *);
  311 (* TMax *);
  312 (* TMin *);
  313 (* Tchar *);
  314 (* Tshort *);
  315 (* Tint *);
  316 (* Tdouble *);
  317 (* Tfloat *);
  318 (* Tlong *);
  319 (* Tunsigned *);
  320 (* Tsigned *);
  321 (* Tvoid *);
  322 (* Tsize_t *);
  323 (* Tssize_t *);
  324 (* Tptrdiff_t *);
  325 (* Tauto *);
  326 (* Tregister *);
  327 (* Textern *);
  328 (* Tstatic *);
  329 (* Ttypedef *);
  330 (* Tconst *);
  331 (* Tvolatile *);
  332 (* Tstruct *);
  333 (* Tunion *);
  334 (* Tenum *);
  335 (* Tdecimal *);
  336 (* Texec *);
  337 (* Tbreak *);
  338 (* Telse *);
  339 (* Tswitch *);
  340 (* Tcase *);
  341 (* Tcontinue *);
  342 (* Tfor *);
  343 (* Tdo *);
  344 (* Tif *);
  345 (* Twhile *);
  346 (* Treturn *);
  347 (* Tgoto *);
  348 (* Tdefault *);
  349 (* Tsizeof *);
  350 (* Tnew *);
  351 (* Tdelete *);
  352 (* Tdefined *);
  353 (* TOParCplusplusInit *);
  354 (* Tnamespace *);
  355 (* Trestrict *);
  356 (* Tasm *);
  357 (* Tattribute *);
  358 (* TattributeNoarg *);
  359 (* Tinline *);
  360 (* Ttypeof *);
  361 (* TDefine *);
  362 (* TDefParamVariadic *);
  363 (* TCppEscapedNewline *);
  364 (* TCppConcatOp *);
  365 (* TOParDefine *);
  366 (* TOBraceDefineInit *);
  367 (* TIdentDefine *);
  368 (* TDefEOL *);
  369 (* TInclude *);
  370 (* TIncludeStart *);
  371 (* TIncludeFilename *);
  372 (* TIfdef *);
  373 (* TIfdefelif *);
  374 (* TIfdefelse *);
  375 (* TEndif *);
  376 (* TIfdefBool *);
  377 (* TIfdefMisc *);
  378 (* TIfdefVersion *);
  379 (* TUifdef *);
  380 (* TUelseif *);
  381 (* TUendif *);
  382 (* TUndef *);
  383 (* TPragma *);
  384 (* TCppDirectiveOther *);
  385 (* TMacroAttr *);
  386 (* TMacroStmt *);
  387 (* TMacroIdentBuilder *);
  388 (* TMacroString *);
  389 (* TMacroDecl *);
  390 (* TMacroDeclConst *);
  391 (* TMacroIterator *);
  392 (* TMacroAttrStorage *);
  393 (* TCommentSkipTagStart *);
  394 (* TCommentSkipTagEnd *);
  395 (* TCParEOL *);
  396 (* TAction *);
  397 (* TCommentMisc *);
  398 (* TCommentCpp *);
    0 (* EOF *);
    0|]

let yylhs = "\255\255\
\001\000\006\000\006\000\006\000\008\000\008\000\009\000\010\000\
\010\000\012\000\012\000\012\000\011\000\011\000\011\000\013\000\
\013\000\004\000\004\000\015\000\015\000\015\000\016\000\016\000\
\018\000\018\000\018\000\018\000\018\000\018\000\018\000\018\000\
\018\000\018\000\018\000\018\000\018\000\018\000\018\000\018\000\
\018\000\018\000\018\000\018\000\018\000\017\000\017\000\020\000\
\020\000\020\000\020\000\020\000\020\000\020\000\020\000\020\000\
\020\000\020\000\025\000\025\000\025\000\025\000\025\000\025\000\
\024\000\024\000\024\000\024\000\024\000\024\000\024\000\023\000\
\023\000\023\000\023\000\023\000\023\000\023\000\023\000\023\000\
\023\000\028\000\028\000\028\000\028\000\028\000\028\000\028\000\
\028\000\028\000\028\000\028\000\031\000\031\000\035\000\035\000\
\036\000\037\000\037\000\037\000\040\000\040\000\040\000\039\000\
\041\000\044\000\021\000\022\000\003\000\045\000\045\000\045\000\
\045\000\045\000\045\000\045\000\045\000\045\000\045\000\046\000\
\046\000\046\000\046\000\053\000\053\000\055\000\055\000\055\000\
\034\000\057\000\057\000\059\000\059\000\059\000\060\000\060\000\
\060\000\060\000\060\000\047\000\047\000\048\000\048\000\048\000\
\048\000\048\000\049\000\049\000\049\000\049\000\049\000\049\000\
\049\000\049\000\050\000\050\000\050\000\050\000\050\000\050\000\
\032\000\032\000\051\000\051\000\065\000\067\000\067\000\067\000\
\067\000\067\000\052\000\052\000\052\000\052\000\069\000\069\000\
\069\000\069\000\070\000\070\000\068\000\071\000\071\000\071\000\
\071\000\071\000\071\000\071\000\071\000\071\000\071\000\071\000\
\071\000\071\000\071\000\071\000\071\000\071\000\071\000\071\000\
\071\000\071\000\071\000\071\000\071\000\071\000\071\000\071\000\
\071\000\071\000\071\000\071\000\071\000\071\000\071\000\071\000\
\071\000\071\000\071\000\072\000\072\000\072\000\072\000\072\000\
\072\000\072\000\072\000\072\000\072\000\072\000\072\000\072\000\
\072\000\072\000\072\000\072\000\072\000\072\000\027\000\075\000\
\075\000\075\000\076\000\076\000\077\000\078\000\078\000\079\000\
\079\000\080\000\080\000\080\000\080\000\082\000\082\000\081\000\
\081\000\081\000\081\000\081\000\081\000\084\000\085\000\089\000\
\089\000\089\000\090\000\090\000\090\000\090\000\090\000\090\000\
\090\000\090\000\090\000\088\000\088\000\092\000\092\000\092\000\
\092\000\038\000\038\000\094\000\094\000\094\000\095\000\095\000\
\097\000\097\000\097\000\097\000\098\000\083\000\083\000\005\000\
\005\000\099\000\099\000\100\000\100\000\100\000\100\000\102\000\
\102\000\102\000\107\000\107\000\107\000\107\000\107\000\107\000\
\107\000\107\000\106\000\106\000\106\000\106\000\109\000\109\000\
\108\000\108\000\054\000\093\000\111\000\111\000\111\000\104\000\
\113\000\112\000\112\000\112\000\112\000\114\000\114\000\105\000\
\105\000\105\000\029\000\029\000\117\000\117\000\117\000\117\000\
\117\000\119\000\119\000\119\000\030\000\030\000\120\000\120\000\
\120\000\125\000\125\000\125\000\125\000\126\000\126\000\126\000\
\126\000\126\000\127\000\127\000\129\000\129\000\129\000\130\000\
\130\000\130\000\073\000\121\000\133\000\131\000\132\000\123\000\
\123\000\074\000\074\000\074\000\138\000\138\000\139\000\061\000\
\141\000\141\000\142\000\142\000\140\000\140\000\140\000\143\000\
\144\000\144\000\146\000\146\000\145\000\145\000\145\000\062\000\
\062\000\062\000\062\000\062\000\062\000\148\000\148\000\148\000\
\147\000\147\000\147\000\147\000\147\000\147\000\147\000\147\000\
\147\000\147\000\147\000\147\000\147\000\151\000\151\000\151\000\
\151\000\151\000\063\000\063\000\063\000\063\000\063\000\063\000\
\063\000\152\000\152\000\152\000\152\000\007\000\007\000\002\000\
\002\000\002\000\002\000\002\000\002\000\002\000\002\000\056\000\
\058\000\135\000\137\000\115\000\116\000\122\000\124\000\086\000\
\087\000\033\000\033\000\064\000\064\000\066\000\066\000\026\000\
\026\000\103\000\103\000\149\000\149\000\134\000\134\000\128\000\
\128\000\136\000\136\000\101\000\101\000\091\000\091\000\042\000\
\042\000\043\000\043\000\014\000\014\000\014\000\118\000\118\000\
\153\000\153\000\110\000\110\000\096\000\150\000\150\000\019\000\
\019\000\000\000\000\000\000\000\000\000\000\000"

let yylen = "\002\000\
\002\000\000\000\002\000\006\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\003\000\002\000\004\000\001\000\
\003\000\001\000\003\000\001\000\003\000\003\000\001\000\005\000\
\001\000\003\000\003\000\003\000\003\000\003\000\003\000\003\000\
\003\000\003\000\003\000\003\000\003\000\003\000\003\000\003\000\
\003\000\003\000\003\000\003\000\003\000\001\000\004\000\001\000\
\002\000\002\000\002\000\002\000\004\000\002\000\005\000\002\000\
\002\000\004\000\004\000\003\000\004\000\003\000\001\000\004\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\004\000\004\000\003\000\003\000\003\000\002\000\002\000\005\000\
\007\000\001\000\001\000\001\000\001\000\003\000\001\000\001\000\
\003\000\001\000\002\000\003\000\000\000\002\000\002\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\002\000\005\000\006\000\001\000\004\000\003\000\
\004\000\006\000\003\000\001\000\001\000\002\000\003\000\002\000\
\003\000\000\000\001\000\001\000\001\000\002\000\001\000\001\000\
\001\000\001\000\001\000\001\000\002\000\005\000\007\000\005\000\
\009\000\011\000\005\000\007\000\006\000\007\000\006\000\007\000\
\005\000\004\000\002\000\001\000\001\000\001\000\002\000\003\000\
\001\000\001\000\002\000\001\000\002\000\001\000\004\000\007\000\
\001\000\000\000\000\000\004\000\003\000\002\000\000\000\003\000\
\003\000\004\000\000\000\003\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\006\000\004\000\001\000\004\000\004\000\001\000\001\000\
\001\000\001\000\003\000\001\000\001\000\001\000\001\000\002\000\
\001\000\001\000\002\000\002\000\003\000\001\000\001\000\001\000\
\003\000\003\000\004\000\003\000\004\000\001\000\001\000\001\000\
\001\000\002\000\003\000\002\000\003\000\003\000\004\000\002\000\
\003\000\003\000\004\000\001\000\003\000\001\000\002\000\002\000\
\001\000\001\000\002\000\001\000\002\000\002\000\001\000\002\000\
\001\000\001\000\002\000\002\000\001\000\001\000\002\000\001\000\
\002\000\001\000\002\000\002\000\003\000\006\000\008\000\002\000\
\001\000\000\000\001\000\001\000\001\000\001\000\002\000\002\000\
\002\000\002\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\002\000\001\000\001\000\001\000\003\000\004\000\001\000\
\001\000\001\000\002\000\002\000\002\000\004\000\005\000\001\000\
\004\000\002\000\001\000\003\000\001\000\004\000\002\000\003\000\
\003\000\002\000\003\000\005\000\001\000\000\000\005\000\004\000\
\002\000\001\000\001\000\002\000\002\000\001\000\001\000\005\000\
\001\000\001\000\003\000\002\000\001\000\002\000\003\000\001\000\
\002\000\002\000\001\000\001\000\001\000\001\000\001\000\001\000\
\000\000\005\000\006\000\002\000\001\000\003\000\001\000\001\000\
\001\000\002\000\001\000\002\000\002\000\003\000\003\000\001\000\
\002\000\001\000\003\000\004\000\001\000\002\000\002\000\002\000\
\004\000\007\000\003\000\004\000\001\000\003\000\002\000\001\000\
\001\000\001\000\001\000\001\000\002\000\002\000\001\000\005\000\
\006\000\004\000\005\000\001\000\000\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\005\000\005\000\004\000\002\000\001\000\001\000\005\000\
\001\000\001\000\001\000\001\000\005\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\002\000\001\000\002\000\001\000\003\000\001\000\
\003\000\001\000\003\000\001\000\002\000\001\000\002\000\001\000\
\003\000\001\000\003\000\001\000\003\000\001\000\003\000\001\000\
\002\000\000\000\002\000\000\000\001\000\003\000\001\000\002\000\
\001\000\002\000\001\000\002\000\001\000\001\000\000\000\001\000\
\000\000\002\000\002\000\002\000\002\000\002\000"

let yydefred = "\000\000\
\002\000\000\000\000\000\000\000\000\000\000\000\242\001\000\000\
\007\000\000\000\236\000\190\001\221\000\228\000\222\000\224\000\
\223\000\229\000\231\000\230\000\220\000\225\000\226\000\227\000\
\061\001\062\001\060\001\059\001\064\001\240\000\241\000\000\000\
\000\000\000\000\000\000\000\000\242\000\000\000\000\000\000\000\
\000\000\000\000\171\001\173\001\172\001\174\001\175\001\176\001\
\177\001\000\000\000\000\149\001\191\001\243\001\185\001\000\000\
\000\000\183\001\182\001\186\001\188\001\239\000\232\000\233\000\
\000\000\000\000\067\001\000\000\000\000\068\001\000\000\000\000\
\115\001\000\000\116\001\128\001\000\000\136\001\138\001\187\001\
\083\000\084\000\087\000\000\000\000\000\088\000\000\000\011\000\
\000\000\192\001\000\000\000\000\069\000\070\000\140\000\071\000\
\065\000\067\000\068\000\066\000\000\000\157\000\000\000\000\000\
\156\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\118\000\
\000\000\000\000\000\000\244\001\000\000\082\000\000\000\000\000\
\018\000\020\000\000\000\000\000\046\000\000\000\000\000\000\000\
\072\000\000\000\111\000\109\000\110\000\112\000\113\000\114\000\
\000\000\000\000\000\000\000\000\009\000\246\001\000\000\000\000\
\037\001\000\000\000\000\001\000\003\000\200\001\000\000\000\000\
\244\000\233\001\100\001\000\000\101\001\005\000\006\000\194\001\
\000\000\000\000\000\000\000\000\000\000\063\001\058\001\000\000\
\000\000\144\001\000\000\000\000\000\000\181\001\056\001\057\001\
\000\000\044\001\255\000\254\000\000\001\000\000\000\000\000\000\
\000\000\000\000\000\000\073\001\000\000\220\001\137\001\000\000\
\048\001\055\001\245\000\235\001\000\000\198\001\000\000\000\000\
\133\001\129\001\131\001\000\000\000\000\000\000\000\000\096\000\
\000\000\000\000\000\000\000\000\000\000\049\000\000\000\050\000\
\000\000\000\000\106\000\025\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\012\000\155\000\000\000\052\000\
\000\000\000\000\000\000\000\000\000\000\063\000\056\000\000\000\
\057\000\000\000\000\000\014\000\000\000\000\000\000\000\000\000\
\141\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\078\000\079\000\
\051\000\161\000\162\000\202\001\000\000\115\000\000\000\000\000\
\000\000\136\000\000\000\135\000\133\000\000\000\131\000\000\000\
\137\000\138\000\139\000\035\001\036\001\000\000\000\000\000\000\
\000\000\042\001\000\000\000\000\041\001\000\000\022\001\201\001\
\222\001\139\001\000\000\000\000\026\001\000\000\000\000\000\000\
\234\001\000\000\127\001\000\000\218\001\000\000\000\000\002\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\164\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\147\001\000\000\212\001\000\000\000\000\000\000\101\000\102\000\
\210\001\103\000\105\000\000\000\000\000\000\000\000\000\075\001\
\000\000\006\001\000\000\000\000\247\000\246\000\038\001\251\000\
\000\000\000\000\000\000\045\001\072\001\000\000\000\000\000\000\
\236\001\000\000\103\001\000\000\105\001\106\001\000\000\000\000\
\117\001\102\001\214\001\000\000\000\000\000\000\135\001\130\001\
\134\001\132\001\097\000\095\000\086\000\094\000\016\000\000\000\
\089\000\092\000\000\000\216\000\217\000\219\000\218\000\000\000\
\213\000\208\000\209\000\206\000\207\000\212\000\189\000\190\000\
\192\000\191\000\210\000\211\000\000\000\200\000\199\000\204\000\
\205\000\203\000\193\000\194\000\198\000\197\000\196\000\195\000\
\202\000\201\000\182\000\183\000\184\000\185\000\186\000\188\000\
\187\000\215\000\214\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\125\000\123\000\
\124\000\000\000\000\000\000\000\000\000\098\000\000\000\208\001\
\099\000\100\000\104\000\000\000\000\000\000\000\000\000\000\000\
\166\001\167\001\169\001\170\001\168\001\000\000\229\001\000\000\
\000\000\019\000\120\000\021\000\022\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\026\000\027\000\
\030\000\029\000\028\000\108\000\000\000\075\000\000\000\000\000\
\076\000\077\000\203\001\000\000\000\000\000\000\193\001\129\000\
\134\000\016\001\000\000\012\001\000\000\000\000\000\000\000\000\
\000\000\043\001\002\000\140\001\000\000\000\000\000\000\000\000\
\031\001\023\001\024\001\000\000\027\001\243\000\000\000\000\000\
\000\000\000\000\235\000\000\000\000\000\000\000\000\000\204\001\
\000\000\238\000\237\000\000\000\000\000\000\000\000\000\000\000\
\196\001\000\000\000\000\000\000\085\001\000\000\000\000\083\001\
\000\000\231\001\158\001\157\001\145\001\151\001\000\000\148\001\
\213\001\227\001\000\000\000\000\180\001\001\001\000\000\000\000\
\007\001\000\000\002\001\004\001\000\000\039\001\253\000\221\001\
\000\000\080\001\070\001\000\000\000\000\000\000\000\000\118\001\
\108\001\000\000\000\000\000\000\216\001\000\000\000\000\199\001\
\096\001\215\001\077\001\076\001\000\000\000\000\000\000\000\000\
\000\000\119\000\174\000\000\000\000\000\121\000\000\000\000\000\
\000\000\000\000\000\000\000\000\060\000\000\000\062\000\000\000\
\225\001\000\000\000\000\000\000\058\000\000\000\000\000\000\000\
\015\000\000\000\154\000\000\000\000\000\000\000\047\000\074\000\
\073\000\000\000\011\001\013\001\017\001\014\001\000\000\018\001\
\000\000\000\000\021\001\223\001\030\001\029\001\032\001\000\000\
\219\001\195\001\122\001\126\001\000\000\184\001\000\000\000\000\
\169\000\000\000\206\001\205\001\189\001\000\000\000\000\000\000\
\000\000\000\000\090\001\000\000\000\000\000\000\197\001\000\000\
\087\001\000\000\232\001\150\001\178\001\179\001\211\001\000\000\
\000\000\003\001\005\001\071\001\000\000\082\001\000\000\095\001\
\000\000\114\001\113\001\000\000\107\001\000\000\119\001\110\001\
\017\000\000\000\173\000\000\000\000\000\000\000\000\000\144\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\147\000\
\059\000\061\000\000\000\209\001\064\000\116\000\000\000\000\000\
\230\001\153\000\024\000\080\000\000\000\015\001\019\001\004\000\
\123\001\234\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\091\001\000\000\089\001\084\001\000\000\000\000\088\001\
\078\001\000\000\000\000\046\001\000\000\000\000\217\001\111\001\
\180\000\000\000\000\000\000\000\172\000\122\000\149\000\000\000\
\151\000\000\000\000\000\000\000\117\000\000\000\000\000\181\000\
\000\000\000\000\207\001\000\000\000\000\146\001\000\000\238\001\
\160\001\086\001\079\001\081\001\000\000\104\001\000\000\176\000\
\177\000\150\000\152\000\148\000\143\000\000\000\081\000\167\000\
\000\000\000\000\092\001\047\001\178\000\000\000\000\000\000\000\
\000\000\145\000\000\000\000\000\168\000\146\000"

let yydgoto = "\006\000\
\007\000\054\000\207\001\125\000\150\000\008\000\157\000\060\002\
\132\001\126\000\149\000\128\000\152\001\230\001\129\000\130\000\
\131\000\132\000\239\001\133\000\134\000\005\002\135\000\136\000\
\245\000\215\001\057\000\137\000\062\002\041\002\217\000\138\000\
\081\001\139\000\218\000\148\001\216\001\104\001\218\001\105\001\
\106\001\219\001\107\001\207\002\140\000\141\000\142\000\143\000\
\144\000\145\000\082\001\196\001\208\001\209\001\045\001\146\000\
\046\001\016\002\047\001\048\001\059\000\050\001\051\001\047\002\
\048\002\170\002\171\002\025\003\215\002\112\002\197\001\062\000\
\063\000\064\000\065\000\162\000\204\000\119\001\190\000\191\000\
\192\000\193\000\121\001\115\001\083\002\057\001\066\001\067\001\
\019\002\059\001\068\001\069\001\070\001\034\002\035\002\071\001\
\153\000\154\000\061\001\067\000\195\000\068\000\108\001\127\001\
\091\002\174\000\070\000\071\000\072\000\205\000\196\000\197\000\
\198\000\112\001\063\002\185\002\064\002\065\002\066\002\073\000\
\074\000\208\000\136\001\105\002\075\000\137\001\138\001\100\002\
\101\002\102\002\103\002\208\002\139\001\140\001\170\000\076\001\
\163\002\077\001\078\001\076\000\213\000\214\000\077\000\078\000\
\199\000\079\000\096\001\100\001\101\001\033\003\231\001\080\000\
\164\000"

let yysindex = "\094\003\
\000\000\124\009\132\016\181\020\063\028\000\000\000\000\198\009\
\000\000\089\255\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\226\254\
\226\254\172\000\115\255\124\255\000\000\178\255\000\028\191\255\
\111\255\188\255\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\159\255\194\255\000\000\000\000\000\000\000\000\085\255\
\000\028\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\028\038\009\000\000\192\255\220\255\000\000\000\028\235\255\
\000\000\233\000\000\000\000\000\057\026\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\075\000\000\000\248\255\000\000\
\115\018\000\000\181\020\181\020\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\093\000\000\000\110\000\181\020\
\000\000\127\000\132\016\130\000\155\000\181\020\046\255\100\000\
\181\020\193\020\181\020\105\000\071\255\163\000\103\000\000\000\
\180\000\000\000\183\000\000\000\025\255\000\000\000\000\168\000\
\000\000\000\000\001\000\202\005\000\000\063\028\007\001\181\020\
\000\000\036\255\000\000\000\000\000\000\000\000\000\000\000\000\
\170\000\137\015\248\255\193\000\000\000\000\000\063\028\063\028\
\000\000\042\000\208\000\000\000\000\000\000\000\021\025\213\000\
\000\000\000\000\000\000\226\254\000\000\000\000\000\000\000\000\
\220\000\100\255\181\020\240\000\036\255\000\000\000\000\093\017\
\250\012\000\000\186\000\076\255\038\012\000\000\000\000\000\000\
\169\000\000\000\000\000\000\000\000\000\251\254\111\000\075\255\
\005\000\169\000\169\255\000\000\015\255\000\000\000\000\028\001\
\000\000\000\000\000\000\000\000\235\255\000\000\030\001\205\024\
\000\000\000\000\000\000\038\009\193\027\245\000\048\001\000\000\
\055\001\075\000\069\001\201\000\083\001\000\000\063\028\000\000\
\059\029\181\020\000\000\000\000\027\001\243\016\255\000\181\020\
\181\020\193\000\248\255\181\020\000\000\000\000\012\016\000\000\
\063\028\072\001\096\001\144\012\101\001\000\000\000\000\022\255\
\000\000\036\255\120\001\000\000\122\001\006\001\020\010\181\020\
\000\000\012\016\181\020\181\020\181\020\181\020\181\020\181\020\
\181\020\181\020\181\020\181\020\181\020\181\020\181\020\181\020\
\181\020\181\020\181\020\181\020\181\020\181\020\181\020\181\020\
\181\020\116\001\126\010\181\020\100\255\100\255\000\000\000\000\
\000\000\000\000\000\000\000\000\036\255\000\000\000\000\181\020\
\119\001\000\000\124\001\000\000\000\000\131\001\000\000\137\015\
\000\000\000\000\000\000\000\000\000\000\181\001\207\018\107\255\
\167\025\000\000\205\255\034\001\000\000\142\001\000\000\000\000\
\000\000\000\000\156\001\151\001\000\000\047\009\000\027\165\001\
\000\000\100\255\000\000\164\001\000\000\171\001\230\000\000\000\
\027\255\187\001\189\001\199\001\132\016\088\255\006\001\075\018\
\000\000\000\000\025\255\000\000\137\015\000\000\001\009\111\001\
\000\000\232\010\000\000\115\001\121\001\090\001\000\000\000\000\
\000\000\000\000\000\000\045\255\216\001\123\255\000\000\000\000\
\075\255\000\000\247\018\021\025\000\000\000\000\000\000\000\000\
\005\000\000\000\137\016\000\000\000\000\038\012\083\019\038\012\
\000\000\205\024\000\000\224\001\000\000\000\000\018\002\218\001\
\000\000\000\000\000\000\205\024\251\254\169\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\154\001\
\000\000\000\000\116\001\000\000\000\000\000\000\000\000\226\001\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\022\255\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\236\001\059\029\232\000\181\020\012\016\
\123\019\123\019\234\001\250\000\003\001\193\000\000\000\000\000\
\000\000\116\001\082\011\188\011\134\001\000\000\005\001\000\000\
\000\000\000\000\000\000\181\020\000\002\002\002\036\255\181\020\
\000\000\000\000\000\000\000\000\000\000\013\001\000\000\132\016\
\035\001\000\000\000\000\000\000\000\000\193\000\244\001\152\016\
\082\005\214\004\091\004\061\004\059\005\059\005\188\003\188\003\
\188\003\188\003\037\002\037\002\056\002\056\002\000\000\000\000\
\000\000\000\000\000\000\000\000\215\019\000\000\059\001\033\255\
\000\000\000\000\000\000\138\001\012\016\012\016\000\000\000\000\
\000\000\000\000\016\002\000\000\015\002\205\255\156\001\255\019\
\021\025\000\000\000\000\000\000\094\025\101\009\226\254\108\000\
\000\000\000\000\000\000\104\255\000\000\000\000\164\001\100\255\
\034\002\181\020\000\000\181\020\066\027\051\255\023\002\000\000\
\026\002\000\000\000\000\231\001\036\255\045\002\073\001\248\255\
\000\000\181\020\155\255\030\002\000\000\042\002\199\017\000\000\
\110\255\000\000\000\000\000\000\000\000\000\000\099\001\000\000\
\000\000\000\000\227\255\038\012\000\000\000\000\036\255\053\002\
\000\000\049\002\000\000\000\000\156\001\000\000\000\000\000\000\
\102\001\000\000\000\000\199\017\117\001\218\001\038\012\000\000\
\000\000\226\254\169\000\254\255\000\000\038\002\181\020\000\000\
\000\000\000\000\000\000\000\000\061\002\059\002\062\002\059\029\
\172\001\000\000\000\000\132\016\046\002\000\000\070\020\110\020\
\181\020\132\016\132\016\059\002\000\000\126\001\000\000\136\001\
\000\000\233\026\038\012\113\000\000\000\044\002\063\002\144\001\
\000\000\006\001\000\000\132\016\181\020\239\017\000\000\000\000\
\000\000\012\016\000\000\000\000\000\000\000\000\077\002\000\000\
\156\001\130\027\000\000\000\000\000\000\000\000\000\000\034\002\
\000\000\000\000\000\000\000\000\065\002\000\000\067\002\093\000\
\000\000\080\002\000\000\000\000\000\000\084\002\087\002\036\255\
\125\013\032\000\000\000\075\018\075\018\093\002\000\000\042\002\
\000\000\075\018\000\000\000\000\000\000\000\000\000\000\096\002\
\036\255\000\000\000\000\000\000\042\002\000\000\155\001\000\000\
\209\001\000\000\000\000\112\001\000\000\181\020\000\000\000\000\
\000\000\226\001\000\000\181\020\102\002\103\002\059\029\000\000\
\012\016\132\016\212\001\132\016\221\001\235\001\039\002\000\000\
\000\000\000\000\101\001\000\000\000\000\000\000\088\002\132\016\
\000\000\000\000\000\000\000\000\042\002\000\000\000\000\000\000\
\000\000\000\000\181\020\097\002\051\255\181\020\044\002\104\002\
\013\002\000\000\181\020\000\000\000\000\105\002\106\002\000\000\
\000\000\109\002\106\002\000\000\083\019\095\002\000\000\000\000\
\000\000\147\000\172\001\172\001\000\000\000\000\000\000\132\016\
\000\000\132\016\098\002\132\016\000\000\047\002\111\002\000\000\
\116\002\128\002\000\000\238\001\088\002\000\000\114\002\000\000\
\000\000\000\000\000\000\000\000\107\002\000\000\172\001\000\000\
\000\000\000\000\000\000\000\000\000\000\231\000\000\000\000\000\
\120\002\098\002\000\000\000\000\000\000\132\016\132\016\181\020\
\017\002\000\000\121\002\132\016\000\000\000\000"

let yyrindex = "\000\000\
\000\000\008\002\000\000\000\000\000\000\000\000\000\000\008\002\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\060\001\
\065\001\000\000\000\000\000\000\000\000\000\000\044\020\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\004\022\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\013\022\000\000\000\000\000\000\067\023\000\000\039\022\102\021\
\000\000\000\000\000\000\000\000\008\002\000\000\000\000\000\000\
\000\000\000\000\000\000\141\004\135\002\000\000\151\026\000\000\
\115\028\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\110\002\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\007\005\000\000\000\000\000\000\000\000\190\026\000\000\
\000\000\000\000\078\006\133\003\000\000\000\000\173\005\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\006\255\160\002\150\003\000\000\000\000\087\008\048\009\
\000\000\019\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\009\021\000\000\000\000\000\000\000\000\
\156\003\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\043\255\000\000\000\000\000\000\047\255\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\222\023\000\000\129\022\
\139\002\000\000\000\000\000\000\038\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\194\021\000\000\019\004\130\002\
\000\000\000\000\000\000\000\000\008\002\000\000\000\000\000\000\
\000\000\135\002\000\000\000\000\000\000\000\000\000\000\000\000\
\118\002\000\000\000\000\000\000\000\000\008\002\000\000\000\000\
\000\000\119\002\183\004\000\000\000\000\000\000\008\002\000\000\
\000\000\000\000\126\005\000\000\252\005\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\251\001\000\000\000\000\
\000\000\008\002\000\000\000\000\117\002\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\046\005\000\000\147\023\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\080\255\
\000\000\000\000\000\000\000\000\000\000\240\025\000\000\021\000\
\000\000\000\000\037\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\140\002\000\000\049\255\000\000\000\000\
\000\000\000\000\000\000\141\002\000\000\112\000\000\000\000\000\
\144\002\000\000\000\000\000\000\000\000\000\000\251\001\000\000\
\000\000\000\014\048\002\131\014\008\002\006\015\057\002\000\000\
\000\000\000\000\000\000\000\000\058\002\047\255\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\047\024\000\000\
\229\022\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\072\008\128\024\000\000\000\000\000\000\009\002\000\000\009\002\
\000\000\130\002\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\150\002\106\255\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\033\003\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\203\028\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\118\002\000\000\000\000\008\002\
\000\000\000\000\000\000\000\000\000\000\136\002\000\000\000\000\
\000\000\000\000\000\000\000\000\031\002\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\157\002\000\000\246\003\
\230\001\032\001\032\008\070\001\006\002\004\008\102\007\137\007\
\181\007\219\007\022\007\055\007\199\006\232\006\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\095\255\209\255\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\084\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\240\025\058\255\032\255\
\000\000\000\000\000\000\000\000\000\000\000\000\141\002\154\002\
\000\000\000\000\000\000\000\000\008\002\242\255\221\002\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\111\029\
\000\000\000\000\000\000\000\000\000\000\141\002\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\047\255\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\009\002\000\000\
\000\000\106\000\000\000\000\000\000\000\056\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\118\002\
\003\029\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\040\006\000\000\000\000\000\000\000\000\
\000\000\000\000\009\002\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\216\255\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\008\002\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\192\000\000\000\
\000\000\246\255\000\000\000\000\000\000\000\000\000\000\000\000\
\043\255\000\000\000\000\000\000\154\002\000\000\000\000\141\002\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\141\002\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\203\028\000\000\000\000\000\000\000\000\118\002\000\000\
\008\002\000\000\000\000\000\000\000\000\000\000\169\008\000\000\
\000\000\000\000\120\006\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\141\002\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\242\255\000\000\064\002\000\000\
\000\000\000\000\000\000\000\000\000\000\129\002\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\003\029\003\029\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\131\002\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\003\029\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\132\002\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000"

let yygindex = "\000\000\
\000\000\000\000\006\000\013\000\208\255\199\254\243\003\224\255\
\255\255\222\255\253\255\221\255\000\000\162\002\117\000\153\000\
\144\000\185\006\000\000\129\000\143\001\155\254\000\000\000\000\
\123\001\120\255\048\000\000\000\028\254\007\254\032\003\121\255\
\114\003\207\255\000\000\000\000\000\000\108\008\000\000\235\253\
\000\000\041\002\153\002\170\255\000\000\000\000\074\255\000\000\
\000\000\000\000\031\255\089\254\029\255\003\000\000\000\000\000\
\000\000\000\000\255\254\086\255\118\255\050\000\065\000\000\000\
\211\001\000\000\011\001\206\000\170\254\056\001\000\000\000\000\
\000\000\000\000\184\008\103\003\063\003\148\002\149\255\071\001\
\079\255\000\000\000\000\000\000\191\001\014\000\215\254\228\254\
\007\000\220\254\000\000\200\002\002\000\000\000\000\000\239\255\
\000\000\138\255\000\000\000\000\000\000\000\000\171\254\077\001\
\016\001\004\000\075\001\000\000\000\000\000\000\000\000\000\000\
\156\002\000\000\142\254\186\253\024\000\000\000\215\001\000\000\
\000\000\074\003\152\002\190\001\000\000\000\000\000\000\000\000\
\079\001\000\000\183\001\084\001\151\002\000\000\123\003\224\002\
\140\001\005\002\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\125\001\000\000\000\000\000\000\166\001\000\000\
\000\000"

let yytablesize = 7847
let yytable = "\127\000\
\056\000\169\000\036\001\066\000\058\000\069\000\093\001\049\001\
\124\000\066\000\058\000\069\000\092\002\113\001\163\000\165\000\
\148\000\229\000\040\001\022\002\008\001\198\002\045\002\159\000\
\222\001\028\002\130\000\209\000\023\002\115\002\235\001\189\000\
\052\001\053\001\034\001\147\000\009\001\036\001\094\001\221\000\
\089\002\207\000\093\002\034\001\125\001\160\002\017\002\201\001\
\194\000\000\001\008\001\060\000\151\000\110\002\191\002\145\002\
\008\001\000\001\167\002\235\000\001\001\046\002\088\000\075\002\
\009\000\226\001\061\000\025\001\182\002\076\002\160\000\226\001\
\168\002\025\001\084\002\238\000\028\001\109\001\212\000\210\000\
\069\000\249\000\028\001\010\001\079\001\026\001\122\001\085\002\
\250\000\135\001\184\002\067\002\158\000\098\001\110\001\160\000\
\114\001\236\000\161\000\225\000\132\000\220\000\181\000\127\000\
\141\001\053\002\158\000\237\000\124\002\228\002\043\001\126\001\
\231\000\235\000\036\001\128\000\088\000\147\000\233\001\197\002\
\182\000\030\002\234\000\161\000\054\001\055\001\211\000\083\001\
\055\001\118\000\074\001\058\002\171\000\059\002\075\001\074\001\
\060\001\172\000\050\001\186\002\079\002\074\001\127\000\008\001\
\187\000\251\000\007\002\066\000\044\001\069\000\189\000\042\001\
\121\000\118\000\165\001\188\000\189\000\011\002\035\001\189\000\
\058\001\246\000\054\002\143\001\145\001\049\001\237\000\035\001\
\166\000\237\002\008\001\167\000\111\001\127\000\155\001\050\001\
\121\000\189\000\095\001\092\001\069\000\151\000\090\001\077\002\
\034\003\226\001\099\001\025\001\036\003\091\001\255\002\132\000\
\210\001\123\001\142\001\173\000\028\001\080\002\151\000\151\000\
\211\002\011\002\074\001\003\003\124\001\116\001\128\000\118\000\
\176\000\012\002\049\001\118\000\050\001\221\001\212\000\144\001\
\069\000\071\002\031\002\222\000\224\000\177\000\158\000\151\000\
\021\002\154\002\024\002\050\001\118\002\126\000\121\000\212\000\
\202\001\069\000\121\000\127\000\127\000\149\002\198\001\152\002\
\212\000\240\000\069\000\023\003\204\001\205\001\090\000\228\000\
\206\001\009\002\010\002\022\002\153\002\135\002\127\000\151\000\
\227\000\133\001\247\000\212\000\170\000\069\000\189\002\146\001\
\165\000\201\002\170\000\135\001\043\001\179\000\151\000\141\001\
\134\001\238\001\119\002\120\002\170\000\135\001\204\002\033\001\
\165\000\237\000\237\000\098\002\082\002\003\001\004\001\042\000\
\151\000\205\002\108\002\189\000\084\001\040\001\075\001\008\001\
\008\002\103\001\235\001\195\002\127\000\187\000\178\000\013\003\
\180\000\066\000\044\001\069\000\036\002\042\001\250\002\009\001\
\188\000\043\001\228\000\054\001\189\000\009\001\069\001\055\001\
\126\000\251\002\026\002\227\000\200\000\041\000\237\000\127\000\
\025\002\069\001\126\002\128\002\033\002\194\000\030\000\031\000\
\109\001\127\000\187\000\175\002\215\000\050\001\216\000\036\001\
\189\000\127\000\052\002\109\001\050\001\188\000\066\000\044\001\
\069\000\201\000\042\001\219\000\189\000\068\002\010\001\037\000\
\214\001\142\001\009\000\189\000\010\001\192\002\113\001\239\002\
\117\002\175\000\203\000\214\001\234\001\099\002\147\000\236\001\
\237\001\147\000\248\000\107\002\147\000\030\002\116\001\226\000\
\185\000\055\001\112\001\183\000\125\001\117\001\239\000\229\002\
\125\001\000\001\113\002\184\000\112\001\112\001\160\000\214\001\
\230\000\202\000\092\002\232\000\009\001\228\000\228\000\228\000\
\228\000\228\000\228\000\228\000\228\000\228\000\228\000\228\000\
\228\000\228\000\228\000\228\000\228\000\228\000\228\000\228\000\
\228\000\039\003\161\000\000\001\233\000\036\001\118\002\009\001\
\252\000\151\000\109\001\133\001\040\003\041\003\147\000\228\000\
\158\002\166\000\185\000\151\000\167\000\133\001\253\000\168\000\
\227\000\151\002\134\001\010\001\127\000\254\000\228\000\036\001\
\255\000\212\000\002\001\069\000\134\001\038\001\248\002\227\000\
\053\003\187\000\166\000\164\002\118\000\165\002\214\001\118\000\
\166\000\000\001\118\000\153\001\188\000\062\001\010\001\002\003\
\056\001\000\001\166\000\178\002\127\000\044\000\072\001\228\000\
\132\002\223\000\223\000\121\000\136\002\139\002\121\000\168\000\
\061\002\121\000\103\001\090\002\103\001\014\003\166\000\203\002\
\043\002\167\000\116\002\189\000\206\000\189\000\044\002\241\000\
\000\001\189\000\228\000\080\001\075\001\039\000\093\001\120\001\
\090\000\127\000\127\000\227\000\122\002\157\002\212\000\212\000\
\069\000\069\000\000\001\225\001\118\000\123\002\226\001\130\002\
\027\001\190\002\179\002\000\001\028\001\131\002\029\001\137\002\
\030\001\031\001\032\001\025\002\237\000\138\002\094\001\227\001\
\036\001\097\001\159\002\121\000\169\002\128\001\066\000\058\000\
\069\000\206\000\042\000\054\001\042\000\140\002\042\000\055\001\
\042\000\036\001\147\001\131\002\199\001\200\001\042\000\149\001\
\189\000\042\000\042\000\042\000\042\000\042\000\042\000\214\001\
\214\001\098\001\187\000\228\001\098\001\144\002\099\001\098\001\
\202\002\099\001\151\001\131\002\099\001\188\000\228\000\203\001\
\041\000\211\001\041\000\177\002\041\000\041\000\041\000\227\000\
\098\002\138\002\054\003\055\003\041\000\154\001\042\000\041\000\
\041\000\041\000\041\000\041\000\041\000\041\000\041\000\229\001\
\127\000\212\001\050\000\051\000\052\000\188\002\127\000\127\000\
\196\002\216\002\220\001\131\002\056\001\147\000\076\002\223\002\
\224\002\185\000\056\001\219\002\221\002\222\002\004\002\199\002\
\127\000\223\001\250\000\224\001\032\002\076\002\127\000\042\000\
\225\002\234\002\096\002\212\000\143\002\069\000\131\002\015\002\
\187\000\013\002\226\002\066\000\058\000\069\000\014\002\008\000\
\131\002\027\002\232\002\188\000\031\003\032\002\244\002\228\000\
\000\001\189\000\042\000\199\001\146\002\127\000\064\001\029\002\
\227\000\246\000\095\001\092\001\069\000\041\000\090\001\038\002\
\125\001\228\000\099\002\228\000\040\002\091\001\004\003\087\002\
\103\001\212\002\227\000\213\002\227\000\214\002\054\001\018\002\
\042\002\228\000\055\001\252\002\253\002\049\002\228\000\050\002\
\041\000\000\003\227\000\103\001\160\000\127\000\127\000\061\002\
\127\000\051\002\212\000\118\000\069\000\187\000\069\002\015\003\
\010\003\017\003\072\002\006\003\127\000\102\001\016\003\073\002\
\188\000\076\002\078\002\228\000\000\001\022\003\104\002\018\003\
\161\000\095\002\121\000\169\002\061\002\000\001\228\000\103\001\
\044\000\111\002\044\000\121\002\044\000\019\003\044\000\227\000\
\050\003\235\002\028\003\000\001\044\000\109\002\000\001\044\000\
\044\000\044\000\044\000\044\000\127\000\228\001\127\000\114\002\
\127\000\213\001\133\002\228\001\134\002\042\003\141\002\043\003\
\039\000\045\003\039\000\226\001\039\000\228\000\039\000\147\000\
\013\000\226\001\147\002\185\000\039\000\148\002\061\002\039\000\
\039\000\039\000\039\000\039\000\039\000\039\000\039\000\039\000\
\039\000\224\001\127\000\127\000\096\002\097\002\162\002\224\001\
\127\000\046\002\187\000\057\003\058\003\173\002\176\002\174\002\
\180\002\062\003\181\002\228\000\228\000\188\000\193\002\081\002\
\096\002\228\000\209\002\210\002\061\002\061\002\142\002\230\002\
\217\002\231\002\061\002\242\002\243\002\044\000\019\001\020\001\
\021\001\022\001\023\001\024\001\025\001\228\000\001\000\002\000\
\003\000\004\000\005\000\238\002\032\002\246\002\227\000\024\003\
\245\002\247\002\032\002\021\001\022\001\023\001\024\001\025\001\
\044\000\254\002\001\003\011\003\012\003\039\000\160\000\026\003\
\020\003\090\002\029\003\021\003\030\003\118\000\183\002\035\003\
\046\003\032\003\038\003\047\003\023\000\044\003\048\003\049\003\
\051\003\056\003\228\000\061\003\050\001\060\003\052\003\093\000\
\039\000\158\000\161\000\227\000\121\000\245\001\121\001\241\001\
\250\000\171\000\159\000\124\001\250\000\250\000\020\001\153\001\
\250\000\094\001\164\000\250\000\008\000\008\000\008\000\008\000\
\156\001\152\001\120\001\160\000\024\003\008\000\093\001\162\001\
\008\000\008\000\008\000\008\000\008\000\008\000\008\000\008\000\
\008\000\008\000\008\000\008\000\008\000\008\000\008\000\240\001\
\008\000\008\000\008\000\008\000\008\000\008\000\008\000\008\000\
\008\000\008\000\008\000\008\000\008\000\008\000\008\000\008\000\
\008\000\008\000\008\000\008\000\008\000\008\000\008\000\008\000\
\008\000\008\000\008\000\008\000\008\000\008\000\008\000\008\000\
\008\000\008\000\008\000\008\000\008\000\008\000\008\000\008\000\
\008\000\008\000\008\000\008\000\008\000\008\000\008\000\163\000\
\239\001\008\000\163\001\161\001\055\000\045\000\250\000\008\000\
\055\002\150\001\250\000\037\001\227\002\129\002\074\002\027\003\
\008\000\172\002\008\000\008\000\008\000\059\003\008\000\008\000\
\008\000\009\003\073\001\129\001\086\002\250\000\037\002\008\000\
\194\002\008\000\097\001\005\003\037\003\250\000\088\002\187\002\
\130\001\094\002\007\003\200\002\206\002\008\000\008\000\008\000\
\008\000\008\003\106\002\074\001\008\000\013\000\013\000\013\000\
\013\000\039\002\008\000\241\002\161\002\249\002\013\000\233\002\
\000\000\013\000\013\000\013\000\013\000\013\000\013\000\013\000\
\013\000\013\000\013\000\013\000\013\000\013\000\013\000\013\000\
\000\000\013\000\013\000\013\000\013\000\013\000\013\000\013\000\
\013\000\013\000\013\000\013\000\013\000\013\000\013\000\013\000\
\013\000\013\000\013\000\013\000\013\000\013\000\013\000\013\000\
\013\000\013\000\013\000\013\000\013\000\013\000\013\000\013\000\
\013\000\013\000\013\000\013\000\013\000\013\000\013\000\013\000\
\013\000\013\000\013\000\013\000\013\000\013\000\013\000\013\000\
\000\000\000\000\013\000\000\000\000\000\000\000\000\000\000\000\
\013\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\013\000\000\000\013\000\013\000\013\000\000\000\013\000\
\013\000\013\000\000\000\000\000\085\000\000\000\000\000\000\000\
\013\000\000\000\013\000\000\000\000\000\000\000\000\000\023\000\
\000\000\023\000\000\000\023\000\000\000\023\000\013\000\013\000\
\013\000\013\000\000\000\000\000\000\000\013\000\023\000\023\000\
\023\000\124\001\000\000\013\000\124\001\124\001\124\001\000\000\
\124\001\124\001\124\001\000\000\124\001\000\000\010\000\000\000\
\124\001\124\001\124\001\000\000\000\000\124\001\124\001\124\001\
\124\001\124\001\124\001\124\001\124\001\124\001\124\001\124\001\
\124\001\124\001\124\001\124\001\124\001\124\001\124\001\124\001\
\124\001\124\001\124\001\124\001\124\001\124\001\124\001\124\001\
\124\001\124\001\124\001\124\001\124\001\124\001\124\001\124\001\
\124\001\124\001\124\001\124\001\124\001\124\001\124\001\124\001\
\124\001\124\001\124\001\017\001\018\001\019\001\020\001\021\001\
\022\001\023\001\024\001\025\001\023\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\124\001\000\000\
\124\001\000\000\124\001\124\001\000\000\000\000\090\000\124\001\
\045\000\000\000\045\000\124\001\045\000\000\000\045\000\023\000\
\000\000\000\000\000\000\000\000\045\000\000\000\000\000\045\000\
\045\000\045\000\045\000\000\000\124\001\000\000\124\001\000\000\
\097\001\000\000\000\000\097\001\097\001\097\001\124\001\097\001\
\097\001\097\001\000\000\097\001\000\000\091\000\000\000\097\001\
\097\001\097\001\000\000\000\000\097\001\097\001\097\001\097\001\
\097\001\097\001\097\001\097\001\097\001\097\001\097\001\097\001\
\097\001\097\001\097\001\097\001\097\001\097\001\097\001\097\001\
\097\001\097\001\097\001\097\001\097\001\097\001\097\001\097\001\
\097\001\097\001\097\001\097\001\097\001\097\001\097\001\097\001\
\097\001\097\001\097\001\097\001\097\001\097\001\097\001\097\001\
\097\001\097\001\000\000\000\000\000\000\045\000\011\001\012\001\
\013\001\014\001\015\001\016\001\017\001\018\001\019\001\020\001\
\021\001\022\001\023\001\024\001\025\001\097\001\000\000\097\001\
\000\000\097\001\097\001\000\000\000\000\236\000\097\001\000\000\
\045\000\000\000\097\001\010\001\011\001\012\001\013\001\014\001\
\015\001\016\001\017\001\018\001\019\001\020\001\021\001\022\001\
\023\001\024\001\025\001\097\001\161\000\097\001\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\097\001\085\000\085\000\
\000\000\085\000\085\000\085\000\085\000\085\000\085\000\085\000\
\085\000\085\000\085\000\085\000\048\000\000\000\085\000\085\000\
\085\000\085\000\085\000\085\000\085\000\085\000\085\000\085\000\
\085\000\085\000\085\000\085\000\085\000\085\000\085\000\085\000\
\085\000\085\000\085\000\085\000\085\000\000\000\000\000\000\000\
\010\000\010\000\000\000\010\000\010\000\010\000\010\000\010\000\
\010\000\010\000\010\000\010\000\010\000\010\000\000\000\000\000\
\010\000\010\000\010\000\010\000\010\000\010\000\010\000\010\000\
\010\000\010\000\010\000\010\000\010\000\010\000\010\000\010\000\
\010\000\010\000\010\000\010\000\010\000\010\000\010\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\054\000\085\000\009\001\010\001\011\001\
\012\001\013\001\014\001\015\001\016\001\017\001\018\001\019\001\
\020\001\021\001\022\001\023\001\024\001\025\001\162\000\000\000\
\161\000\000\000\000\000\000\000\000\000\000\000\000\000\085\000\
\090\000\090\000\000\000\090\000\090\000\090\000\090\000\090\000\
\090\000\090\000\090\000\090\000\090\000\090\000\010\000\053\000\
\090\000\090\000\090\000\090\000\090\000\090\000\090\000\090\000\
\090\000\090\000\090\000\090\000\090\000\090\000\090\000\090\000\
\090\000\090\000\090\000\090\000\090\000\090\000\090\000\091\000\
\091\000\010\000\091\000\091\000\091\000\091\000\091\000\091\000\
\091\000\091\000\091\000\091\000\091\000\025\000\000\000\091\000\
\091\000\091\000\091\000\091\000\091\000\091\000\091\000\091\000\
\091\000\091\000\091\000\091\000\091\000\091\000\091\000\091\000\
\091\000\091\000\091\000\091\000\091\000\091\000\013\001\014\001\
\015\001\016\001\017\001\018\001\019\001\020\001\021\001\022\001\
\023\001\024\001\025\001\000\000\000\000\000\000\090\000\055\000\
\008\001\009\001\010\001\011\001\012\001\013\001\014\001\015\001\
\016\001\017\001\018\001\019\001\020\001\021\001\022\001\023\001\
\024\001\025\001\162\000\000\000\000\000\000\000\000\000\000\000\
\236\000\090\000\236\000\236\000\236\000\000\000\236\000\000\000\
\000\000\000\000\236\000\236\000\236\000\091\000\000\000\236\000\
\236\000\236\000\236\000\236\000\236\000\236\000\236\000\236\000\
\236\000\236\000\236\000\236\000\236\000\236\000\236\000\236\000\
\236\000\236\000\236\000\236\000\236\000\236\000\000\000\000\000\
\091\000\000\000\000\000\000\000\000\000\000\000\000\000\048\000\
\000\000\048\000\000\000\048\000\000\000\048\000\031\000\000\000\
\000\000\048\000\048\000\048\000\000\000\000\000\048\000\048\000\
\048\000\048\000\048\000\048\000\048\000\048\000\048\000\048\000\
\048\000\048\000\048\000\048\000\048\000\048\000\048\000\048\000\
\048\000\048\000\048\000\048\000\048\000\000\000\000\000\032\000\
\005\001\000\000\000\000\000\000\000\000\236\000\006\001\007\001\
\008\001\009\001\010\001\011\001\012\001\013\001\014\001\015\001\
\016\001\017\001\018\001\019\001\020\001\021\001\022\001\023\001\
\024\001\025\001\000\000\000\000\000\000\000\000\000\000\000\000\
\236\000\000\000\000\000\000\000\000\000\000\000\054\000\000\000\
\054\000\000\000\054\000\000\000\054\000\033\000\000\000\000\000\
\054\000\054\000\054\000\000\000\048\000\054\000\054\000\054\000\
\054\000\054\000\054\000\054\000\054\000\054\000\054\000\054\000\
\054\000\054\000\054\000\054\000\054\000\054\000\054\000\054\000\
\054\000\054\000\054\000\054\000\000\000\000\000\034\000\048\000\
\000\000\000\000\053\000\000\000\053\000\000\000\053\000\000\000\
\053\000\000\000\000\000\000\000\053\000\053\000\053\000\000\000\
\000\000\053\000\053\000\053\000\053\000\053\000\053\000\053\000\
\053\000\053\000\053\000\053\000\053\000\053\000\053\000\053\000\
\053\000\053\000\053\000\053\000\053\000\053\000\053\000\053\000\
\025\000\000\000\025\000\000\000\025\000\035\000\025\000\000\000\
\000\000\000\000\000\000\054\000\025\000\000\000\000\000\025\000\
\025\000\025\000\025\000\025\000\025\000\025\000\025\000\025\000\
\025\000\025\000\025\000\025\000\025\000\025\000\025\000\025\000\
\025\000\025\000\025\000\025\000\025\000\025\000\054\000\000\000\
\036\000\000\000\055\000\000\000\055\000\000\000\055\000\000\000\
\055\000\000\000\000\000\000\000\055\000\055\000\055\000\053\000\
\000\000\055\000\055\000\055\000\055\000\055\000\055\000\055\000\
\055\000\055\000\055\000\055\000\055\000\055\000\055\000\055\000\
\055\000\055\000\055\000\055\000\055\000\055\000\055\000\055\000\
\000\000\000\000\053\000\000\000\037\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\025\000\240\001\241\001\
\242\001\243\001\244\001\245\001\246\001\247\001\248\001\249\001\
\250\001\251\001\252\001\253\001\254\001\255\001\000\002\001\002\
\002\002\003\002\000\000\000\000\000\000\000\000\000\000\000\000\
\025\000\031\000\038\000\031\000\000\000\031\000\000\000\031\000\
\000\000\000\000\000\000\000\000\000\000\031\000\000\000\055\000\
\031\000\031\000\031\000\031\000\031\000\031\000\031\000\031\000\
\031\000\031\000\031\000\031\000\031\000\031\000\031\000\031\000\
\031\000\031\000\032\000\000\000\032\000\000\000\032\000\000\000\
\032\000\000\000\055\000\040\000\000\000\000\000\032\000\000\000\
\000\000\032\000\032\000\032\000\032\000\032\000\032\000\032\000\
\032\000\032\000\032\000\032\000\032\000\032\000\032\000\032\000\
\032\000\032\000\032\000\000\000\000\000\000\000\000\000\043\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\033\000\000\000\033\000\000\000\033\000\000\000\033\000\000\000\
\000\000\000\000\000\000\000\000\033\000\000\000\031\000\033\000\
\033\000\033\000\033\000\033\000\033\000\033\000\033\000\033\000\
\033\000\033\000\033\000\033\000\033\000\033\000\033\000\252\000\
\000\000\034\000\000\000\034\000\000\000\034\000\000\000\034\000\
\000\000\031\000\000\000\000\000\000\000\034\000\033\001\032\000\
\034\000\034\000\034\000\034\000\034\000\034\000\034\000\034\000\
\034\000\034\000\034\000\034\000\034\000\034\000\034\000\034\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\032\000\000\000\000\000\000\000\000\000\000\000\
\035\000\000\000\035\000\000\000\035\000\000\000\035\000\000\000\
\000\000\000\000\000\000\000\000\035\000\033\000\000\000\035\000\
\035\000\035\000\035\000\035\000\035\000\035\000\035\000\035\000\
\035\000\035\000\035\000\035\000\035\000\000\000\000\000\000\000\
\000\000\000\000\000\000\036\000\000\000\036\000\000\000\036\000\
\033\000\036\000\000\000\000\000\000\000\000\000\034\000\036\000\
\142\000\000\000\036\000\036\000\036\000\036\000\036\000\036\000\
\036\000\036\000\036\000\036\000\036\000\036\000\036\000\036\000\
\000\000\000\000\000\000\000\000\152\000\000\000\000\000\000\000\
\000\000\034\000\000\000\000\000\000\000\000\000\000\000\037\000\
\000\000\037\000\000\000\037\000\000\000\037\000\000\000\000\000\
\000\000\000\000\000\000\037\000\000\000\035\000\037\000\037\000\
\037\000\037\000\037\000\037\000\037\000\037\000\037\000\037\000\
\037\000\037\000\037\000\037\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\038\000\000\000\038\000\
\035\000\038\000\000\000\038\000\000\000\000\000\000\000\000\000\
\036\000\038\000\000\000\000\000\038\000\038\000\038\000\038\000\
\038\000\038\000\038\000\038\000\038\000\038\000\038\000\038\000\
\038\000\038\000\065\001\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\036\000\000\000\000\000\040\000\000\000\
\040\000\000\000\040\000\000\000\040\000\000\000\000\000\000\000\
\000\000\000\000\040\000\000\000\037\000\040\000\040\000\040\000\
\040\000\040\000\040\000\040\000\040\000\040\000\040\000\034\001\
\000\000\000\000\043\000\000\000\043\000\000\000\043\000\000\000\
\043\000\000\000\000\000\000\000\000\000\152\000\043\000\037\000\
\000\000\043\000\043\000\043\000\043\000\043\000\043\000\043\000\
\000\000\000\000\038\000\000\000\000\000\000\000\152\000\152\000\
\000\000\000\000\000\000\000\000\000\000\252\000\000\000\000\000\
\000\000\252\000\252\000\000\000\000\000\252\000\000\000\217\001\
\252\000\000\000\000\000\000\000\033\001\038\000\000\000\152\000\
\033\001\033\001\217\001\000\000\033\001\000\000\000\000\000\000\
\000\000\000\000\000\000\040\000\000\000\000\000\000\000\000\000\
\118\001\033\001\033\001\053\000\000\000\000\000\000\000\033\001\
\000\000\000\000\000\000\000\000\000\000\000\000\217\001\152\000\
\000\000\000\000\033\001\000\000\000\000\000\000\040\000\043\000\
\000\000\000\000\000\000\000\000\000\000\000\000\152\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\065\001\000\000\000\000\000\000\
\152\000\000\000\043\000\000\000\000\000\142\000\142\000\142\000\
\142\000\142\000\000\000\252\000\000\000\142\000\142\000\252\000\
\142\000\142\000\142\000\033\001\142\000\142\000\000\000\000\000\
\000\000\000\000\033\001\142\000\142\000\156\000\000\000\000\000\
\142\000\142\000\252\000\000\000\142\000\217\001\142\000\000\000\
\000\000\142\000\252\000\000\000\000\000\000\000\000\000\033\001\
\000\000\033\001\142\000\142\000\142\000\000\000\000\000\065\001\
\000\000\142\000\142\000\142\000\142\000\142\000\142\000\142\000\
\142\000\142\000\142\000\142\000\142\000\142\000\142\000\142\000\
\142\000\142\000\142\000\142\000\142\000\142\000\142\000\142\000\
\142\000\142\000\000\000\142\000\142\000\142\000\142\000\142\000\
\142\000\142\000\142\000\142\000\142\000\142\000\142\000\142\000\
\142\000\000\000\000\000\142\000\142\000\000\000\147\000\142\000\
\142\000\142\000\030\002\000\000\142\000\000\000\055\001\000\000\
\142\000\000\000\142\000\000\000\142\000\142\000\142\000\142\000\
\142\000\142\000\142\000\142\000\186\000\142\000\142\000\142\000\
\142\000\187\000\142\000\142\000\142\000\142\000\000\000\142\000\
\118\001\000\000\000\000\147\000\188\000\000\000\000\000\185\000\
\000\000\152\000\000\000\000\000\147\000\034\001\217\001\217\001\
\030\002\034\001\034\001\152\000\055\001\034\001\000\000\000\000\
\000\000\186\000\000\000\000\000\000\000\000\000\187\000\000\000\
\000\000\000\000\034\001\034\001\000\000\000\000\000\000\187\000\
\034\001\188\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\188\000\034\001\000\000\160\000\000\000\000\000\
\000\000\000\000\000\000\000\000\118\000\000\000\000\000\000\000\
\000\000\000\000\147\000\000\000\000\000\000\000\030\002\018\002\
\000\000\000\000\055\001\000\000\000\000\000\000\000\000\000\000\
\000\000\161\000\000\000\121\000\065\001\000\000\000\000\000\000\
\156\002\009\000\160\000\010\000\011\000\187\000\000\000\000\000\
\000\000\118\000\000\000\160\000\034\001\000\000\000\000\000\000\
\188\000\000\000\118\000\034\001\000\000\000\000\000\000\012\000\
\000\000\000\000\000\000\000\000\000\000\000\000\161\000\000\000\
\121\000\000\000\000\000\000\000\000\000\000\000\000\000\161\000\
\034\001\121\000\034\001\000\000\013\000\014\000\015\000\016\000\
\017\000\018\000\019\000\020\000\021\000\022\000\023\000\024\000\
\025\000\026\000\027\000\028\000\029\000\030\000\031\000\032\000\
\033\000\034\000\035\000\000\000\000\000\000\000\000\000\000\000\
\118\000\000\000\000\000\000\000\000\000\010\000\011\000\000\000\
\000\000\000\000\000\000\000\000\000\000\036\000\037\000\038\000\
\000\000\000\000\039\000\040\000\041\000\000\000\000\000\121\000\
\000\000\000\000\000\000\000\000\000\000\042\000\000\000\043\000\
\044\000\045\000\046\000\047\000\048\000\049\000\000\000\000\000\
\000\000\050\000\051\000\052\000\000\000\000\000\013\000\014\000\
\015\000\016\000\017\000\018\000\019\000\020\000\021\000\022\000\
\023\000\024\000\025\000\026\000\027\000\028\000\029\000\030\000\
\031\000\032\000\033\000\034\000\035\000\000\000\000\000\000\000\
\081\000\082\000\083\000\084\000\085\000\000\000\000\000\000\000\
\086\000\147\000\063\001\000\000\011\000\089\000\232\001\155\000\
\037\000\000\000\000\000\000\000\039\000\040\000\091\000\092\000\
\000\000\000\000\000\000\093\000\094\000\000\000\000\000\000\000\
\000\000\096\000\000\000\000\000\097\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\098\000\099\000\100\000\
\000\000\000\000\000\000\000\000\013\000\014\000\015\000\016\000\
\017\000\018\000\019\000\020\000\021\000\022\000\023\000\024\000\
\025\000\026\000\027\000\028\000\029\000\030\000\031\000\032\000\
\033\000\034\000\035\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\113\000\114\000\115\000\116\000\000\000\000\000\037\000\000\000\
\160\000\000\000\039\000\040\000\000\000\000\000\000\000\118\000\
\000\000\000\000\081\000\082\000\083\000\084\000\085\000\000\000\
\000\000\000\000\086\000\147\000\063\001\000\000\011\000\089\000\
\006\002\000\000\000\000\000\000\161\000\000\000\121\000\122\000\
\091\000\092\000\000\000\000\000\000\000\093\000\094\000\213\001\
\000\000\000\000\000\000\096\000\000\000\000\000\097\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\098\000\
\099\000\100\000\000\000\000\000\000\000\000\000\013\000\014\000\
\015\000\016\000\017\000\018\000\019\000\020\000\021\000\022\000\
\023\000\024\000\025\000\026\000\027\000\028\000\029\000\030\000\
\031\000\032\000\033\000\034\000\035\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\113\000\114\000\115\000\116\000\000\000\000\000\
\037\000\000\000\160\000\000\000\039\000\040\000\000\000\000\000\
\000\000\118\000\000\000\000\000\081\000\082\000\083\000\084\000\
\085\000\000\000\000\000\000\000\086\000\147\000\063\001\000\000\
\011\000\089\000\070\002\000\000\000\000\000\000\161\000\000\000\
\121\000\122\000\091\000\092\000\000\000\000\000\000\000\093\000\
\094\000\213\001\000\000\000\000\000\000\096\000\000\000\000\000\
\097\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\098\000\099\000\100\000\000\000\000\000\000\000\000\000\
\013\000\014\000\015\000\016\000\017\000\018\000\019\000\020\000\
\021\000\022\000\023\000\024\000\025\000\026\000\027\000\028\000\
\029\000\030\000\031\000\032\000\033\000\034\000\035\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\113\000\114\000\115\000\116\000\
\000\000\000\000\037\000\000\000\160\000\000\000\039\000\040\000\
\000\000\000\000\000\000\118\000\000\000\000\000\081\000\082\000\
\083\000\084\000\085\000\000\000\000\000\000\000\086\000\147\000\
\063\001\000\000\011\000\089\000\125\002\000\000\000\000\000\000\
\161\000\000\000\121\000\122\000\091\000\092\000\000\000\000\000\
\000\000\093\000\094\000\213\001\000\000\000\000\000\000\096\000\
\000\000\000\000\097\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\098\000\099\000\100\000\000\000\000\000\
\000\000\000\000\013\000\014\000\015\000\016\000\017\000\018\000\
\019\000\020\000\021\000\022\000\023\000\024\000\025\000\026\000\
\027\000\028\000\029\000\030\000\031\000\032\000\033\000\034\000\
\035\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\113\000\114\000\
\115\000\116\000\000\000\000\000\037\000\000\000\160\000\000\000\
\039\000\040\000\000\000\000\000\000\000\118\000\000\000\000\000\
\081\000\082\000\083\000\084\000\085\000\000\000\000\000\000\000\
\086\000\147\000\063\001\000\000\011\000\089\000\127\002\000\000\
\000\000\000\000\161\000\000\000\121\000\122\000\091\000\092\000\
\000\000\000\000\000\000\093\000\094\000\213\001\000\000\000\000\
\000\000\096\000\000\000\000\000\097\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\098\000\099\000\100\000\
\000\000\000\000\000\000\000\000\013\000\014\000\015\000\016\000\
\017\000\018\000\019\000\020\000\021\000\022\000\023\000\024\000\
\025\000\026\000\027\000\028\000\029\000\030\000\031\000\032\000\
\033\000\034\000\035\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\113\000\114\000\115\000\116\000\000\000\000\000\037\000\000\000\
\160\000\000\000\039\000\040\000\000\000\000\000\000\000\118\000\
\000\000\000\000\081\000\082\000\083\000\084\000\085\000\000\000\
\000\000\000\000\086\000\147\000\063\001\000\000\011\000\089\000\
\000\000\000\000\000\000\000\000\161\000\000\000\121\000\122\000\
\091\000\092\000\000\000\000\000\000\000\093\000\094\000\213\001\
\000\000\000\000\000\000\096\000\000\000\000\000\097\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\098\000\
\099\000\100\000\000\000\000\000\000\000\000\000\013\000\014\000\
\015\000\016\000\017\000\018\000\019\000\020\000\021\000\022\000\
\023\000\024\000\025\000\026\000\027\000\028\000\029\000\030\000\
\031\000\032\000\033\000\034\000\035\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\113\000\114\000\115\000\116\000\000\000\000\000\
\037\000\000\000\160\000\000\000\039\000\040\000\000\000\000\000\
\000\000\118\000\000\000\000\000\081\000\082\000\083\000\084\000\
\085\000\000\000\000\000\000\000\086\000\147\000\063\001\000\000\
\011\000\089\000\000\000\000\000\000\000\000\000\161\000\000\000\
\121\000\122\000\091\000\092\000\000\000\000\000\000\000\093\000\
\094\000\102\001\000\000\000\000\000\000\096\000\000\000\000\000\
\097\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\098\000\099\000\100\000\000\000\000\000\000\000\000\000\
\013\000\014\000\015\000\016\000\017\000\018\000\019\000\020\000\
\021\000\022\000\023\000\024\000\025\000\026\000\027\000\028\000\
\029\000\030\000\031\000\032\000\033\000\034\000\035\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\113\000\114\000\115\000\116\000\
\000\000\000\000\037\000\000\000\160\000\000\000\039\000\040\000\
\000\000\000\000\000\000\118\000\000\000\000\000\081\000\082\000\
\083\000\084\000\085\000\000\000\000\000\000\000\086\000\087\000\
\000\000\010\000\039\001\089\000\000\000\090\000\000\000\000\000\
\161\000\000\000\121\000\122\000\091\000\092\000\000\000\000\000\
\000\000\093\000\094\000\213\001\000\000\095\000\000\000\096\000\
\000\000\000\000\097\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\098\000\099\000\100\000\000\000\000\000\
\000\000\000\000\013\000\014\000\015\000\016\000\017\000\018\000\
\019\000\020\000\021\000\022\000\023\000\024\000\025\000\026\000\
\027\000\028\000\029\000\030\000\031\000\032\000\033\000\034\000\
\035\000\101\000\102\000\000\000\103\000\104\000\105\000\106\000\
\085\001\108\000\109\000\110\000\111\000\112\000\113\000\114\000\
\115\000\116\000\000\000\000\000\037\000\086\001\000\000\000\000\
\039\000\040\000\041\000\000\000\000\000\118\000\087\001\088\001\
\000\000\000\000\000\000\042\000\000\000\043\000\044\000\045\000\
\046\000\047\000\048\000\049\000\119\000\000\000\000\000\050\000\
\051\000\052\000\089\001\120\000\121\000\122\000\000\000\000\000\
\123\000\081\000\082\000\083\000\084\000\085\000\000\000\000\000\
\000\000\086\000\087\000\000\000\010\000\039\001\089\000\000\000\
\090\000\000\000\000\000\000\000\000\000\000\000\000\000\091\000\
\092\000\000\000\000\000\000\000\093\000\094\000\000\000\000\000\
\095\000\000\000\096\000\000\000\000\000\097\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\098\000\099\000\
\100\000\000\000\000\000\000\000\000\000\013\000\014\000\015\000\
\016\000\017\000\018\000\019\000\020\000\021\000\022\000\023\000\
\024\000\025\000\026\000\027\000\028\000\029\000\030\000\031\000\
\032\000\033\000\034\000\035\000\101\000\102\000\000\000\103\000\
\104\000\105\000\106\000\085\001\108\000\109\000\110\000\111\000\
\112\000\113\000\114\000\115\000\116\000\000\000\000\000\037\000\
\086\001\000\000\000\000\039\000\040\000\041\000\000\000\000\000\
\118\000\000\000\088\001\000\000\000\000\000\000\042\000\000\000\
\043\000\044\000\045\000\046\000\047\000\048\000\049\000\119\000\
\000\000\000\000\050\000\051\000\052\000\089\001\120\000\121\000\
\122\000\000\000\000\000\123\000\136\000\136\000\136\000\136\000\
\136\000\000\000\000\000\000\000\136\000\136\000\000\000\136\000\
\136\000\136\000\000\000\136\000\000\000\000\000\000\000\000\000\
\000\000\000\000\136\000\136\000\000\000\000\000\000\000\136\000\
\136\000\000\000\000\000\136\000\000\000\136\000\000\000\000\000\
\136\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\136\000\136\000\136\000\000\000\000\000\000\000\000\000\
\136\000\136\000\136\000\136\000\136\000\136\000\136\000\136\000\
\136\000\136\000\136\000\136\000\136\000\136\000\136\000\136\000\
\136\000\136\000\136\000\136\000\136\000\136\000\136\000\136\000\
\136\000\000\000\136\000\136\000\136\000\136\000\136\000\136\000\
\136\000\136\000\136\000\136\000\136\000\136\000\136\000\136\000\
\000\000\000\000\136\000\136\000\000\000\000\000\136\000\136\000\
\136\000\000\000\000\000\136\000\000\000\000\000\000\000\154\001\
\000\000\136\000\000\000\136\000\136\000\136\000\136\000\136\000\
\136\000\136\000\136\000\000\000\000\000\136\000\136\000\136\000\
\000\000\136\000\136\000\136\000\136\000\000\000\136\000\135\000\
\135\000\135\000\135\000\135\000\000\000\000\000\000\000\135\000\
\135\000\000\000\135\000\135\000\135\000\000\000\135\000\000\000\
\000\000\000\000\000\000\000\000\000\000\135\000\135\000\000\000\
\000\000\000\000\135\000\135\000\000\000\000\000\135\000\000\000\
\135\000\000\000\000\000\135\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\135\000\135\000\135\000\000\000\
\000\000\000\000\000\000\135\000\135\000\135\000\135\000\135\000\
\135\000\135\000\135\000\135\000\135\000\135\000\135\000\135\000\
\135\000\135\000\135\000\135\000\135\000\135\000\135\000\135\000\
\135\000\135\000\135\000\135\000\000\000\135\000\135\000\135\000\
\135\000\135\000\135\000\135\000\135\000\135\000\135\000\135\000\
\135\000\135\000\135\000\000\000\000\000\135\000\135\000\000\000\
\000\000\135\000\135\000\135\000\000\000\000\000\135\000\000\000\
\000\000\000\000\155\001\000\000\135\000\000\000\135\000\135\000\
\135\000\135\000\135\000\135\000\135\000\135\000\000\000\000\000\
\135\000\135\000\135\000\000\000\135\000\135\000\135\000\135\000\
\000\000\135\000\137\000\137\000\137\000\137\000\137\000\000\000\
\000\000\000\000\137\000\137\000\000\000\137\000\137\000\137\000\
\000\000\137\000\000\000\000\000\000\000\000\000\000\000\000\000\
\137\000\137\000\000\000\000\000\000\000\137\000\137\000\000\000\
\000\000\137\000\000\000\137\000\000\000\000\000\137\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\137\000\
\137\000\137\000\000\000\000\000\000\000\000\000\137\000\137\000\
\137\000\137\000\137\000\137\000\137\000\137\000\137\000\137\000\
\137\000\137\000\137\000\137\000\137\000\137\000\137\000\137\000\
\137\000\137\000\137\000\137\000\137\000\137\000\137\000\000\000\
\137\000\137\000\137\000\137\000\137\000\137\000\137\000\137\000\
\137\000\137\000\137\000\137\000\137\000\137\000\000\000\000\000\
\137\000\137\000\000\000\000\000\137\000\137\000\137\000\000\000\
\000\000\137\000\000\000\000\000\000\000\159\001\000\000\137\000\
\000\000\137\000\137\000\137\000\137\000\137\000\137\000\137\000\
\137\000\000\000\000\000\137\000\137\000\137\000\000\000\137\000\
\137\000\137\000\137\000\000\000\137\000\081\000\082\000\083\000\
\084\000\085\000\000\000\000\000\000\000\086\000\087\000\000\000\
\010\000\039\001\089\000\000\000\090\000\000\000\000\000\000\000\
\000\000\000\000\000\000\091\000\092\000\000\000\000\000\000\000\
\093\000\094\000\000\000\000\000\095\000\000\000\096\000\000\000\
\000\000\097\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\098\000\099\000\100\000\000\000\000\000\000\000\
\000\000\013\000\014\000\015\000\016\000\017\000\018\000\019\000\
\020\000\021\000\022\000\023\000\024\000\025\000\026\000\027\000\
\028\000\029\000\030\000\031\000\032\000\033\000\034\000\035\000\
\101\000\102\000\000\000\103\000\040\001\105\000\106\000\107\000\
\108\000\109\000\110\000\111\000\041\001\113\000\114\000\115\000\
\116\000\000\000\000\000\037\000\117\000\000\000\000\000\039\000\
\040\000\041\000\000\000\000\000\118\000\000\000\000\000\000\000\
\000\000\000\000\042\000\000\000\043\000\044\000\045\000\046\000\
\047\000\048\000\049\000\119\000\000\000\000\000\050\000\051\000\
\052\000\000\000\120\000\121\000\122\000\000\000\000\000\123\000\
\081\000\082\000\083\000\084\000\085\000\000\000\000\000\000\000\
\086\000\087\000\000\000\000\000\039\001\089\000\000\000\090\000\
\000\000\000\000\000\000\000\000\000\000\000\000\091\000\092\000\
\000\000\000\000\000\000\093\000\094\000\000\000\000\000\095\000\
\000\000\096\000\000\000\000\000\097\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\098\000\099\000\100\000\
\000\000\000\000\000\000\000\000\013\000\014\000\015\000\016\000\
\017\000\018\000\019\000\020\000\021\000\022\000\023\000\024\000\
\025\000\026\000\027\000\028\000\029\000\030\000\031\000\032\000\
\033\000\034\000\035\000\101\000\102\000\000\000\103\000\104\000\
\105\000\106\000\107\000\108\000\109\000\110\000\111\000\112\000\
\113\000\114\000\115\000\116\000\000\000\000\000\037\000\117\000\
\000\000\000\000\039\000\040\000\000\000\000\000\000\000\118\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\119\000\000\000\
\081\000\082\000\083\000\084\000\085\000\120\000\121\000\122\000\
\086\000\087\000\123\000\000\000\088\000\089\000\147\000\090\000\
\000\000\000\000\185\000\000\000\000\000\000\000\091\000\092\000\
\000\000\000\000\000\000\093\000\094\000\000\000\000\000\095\000\
\000\000\096\000\000\000\000\000\097\000\000\000\000\000\000\000\
\000\000\187\000\000\000\000\000\000\000\098\000\099\000\100\000\
\000\000\000\000\000\000\000\000\188\000\007\001\008\001\009\001\
\010\001\011\001\012\001\013\001\014\001\015\001\016\001\017\001\
\018\001\019\001\020\001\021\001\022\001\023\001\024\001\025\001\
\000\000\000\000\000\000\101\000\102\000\000\000\103\000\104\000\
\105\000\106\000\107\000\108\000\109\000\110\000\111\000\112\000\
\113\000\114\000\115\000\116\000\000\000\000\000\000\000\117\000\
\000\000\000\000\000\000\000\000\000\000\160\000\000\000\118\000\
\000\000\000\000\000\000\000\000\118\000\000\000\000\000\081\000\
\082\000\083\000\084\000\085\000\000\000\000\000\119\000\086\000\
\147\000\000\000\000\000\011\000\089\000\120\000\121\000\122\000\
\000\000\161\000\123\000\121\000\000\000\091\000\092\000\000\000\
\000\000\000\000\093\000\094\000\000\000\000\000\095\000\000\000\
\096\000\000\000\000\000\097\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\098\000\099\000\100\000\000\000\
\000\000\000\000\000\000\013\000\014\000\015\000\016\000\017\000\
\018\000\019\000\020\000\021\000\022\000\023\000\024\000\025\000\
\026\000\027\000\028\000\029\000\030\000\031\000\032\000\033\000\
\034\000\035\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\113\000\
\114\000\115\000\116\000\000\000\000\000\037\000\000\000\000\000\
\000\000\039\000\040\000\000\000\000\000\000\000\118\000\000\000\
\000\000\081\000\082\000\083\000\084\000\085\000\000\000\000\000\
\000\000\086\000\147\000\000\000\000\000\011\000\089\000\000\000\
\000\000\000\000\000\000\000\000\000\000\121\000\122\000\091\000\
\092\000\000\000\000\000\000\000\093\000\094\000\000\000\000\000\
\000\000\000\000\096\000\000\000\000\000\097\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\098\000\099\000\
\100\000\000\000\000\000\000\000\000\000\013\000\014\000\015\000\
\016\000\017\000\018\000\019\000\020\000\021\000\022\000\023\000\
\024\000\000\000\000\000\000\000\000\000\000\000\030\000\031\000\
\032\000\033\000\034\000\035\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\113\000\114\000\115\000\116\000\000\000\000\000\037\000\
\000\000\000\000\000\000\000\000\040\000\000\000\000\000\000\000\
\118\000\000\000\000\000\081\000\082\000\083\000\084\000\085\000\
\000\000\000\000\000\000\086\000\056\002\000\000\000\000\167\000\
\089\000\000\000\057\002\183\002\058\002\000\000\059\002\121\000\
\122\000\091\000\092\000\000\000\000\000\000\000\093\000\094\000\
\000\000\000\000\000\000\000\000\096\000\000\000\000\000\097\000\
\000\000\000\000\000\000\081\000\082\000\083\000\084\000\085\000\
\098\000\099\000\100\000\086\000\056\002\000\000\000\000\167\000\
\089\000\000\000\057\002\236\002\058\002\000\000\059\002\000\000\
\000\000\091\000\092\000\000\000\000\000\000\000\093\000\094\000\
\000\000\000\000\000\000\000\000\096\000\000\000\000\000\097\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\098\000\099\000\100\000\113\000\114\000\115\000\116\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\118\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\121\000\122\000\113\000\114\000\115\000\116\000\081\000\
\082\000\083\000\084\000\085\000\000\000\000\000\000\000\086\000\
\056\002\000\000\118\000\167\000\089\000\000\000\057\002\000\000\
\058\002\000\000\059\002\000\000\000\000\091\000\092\000\000\000\
\000\000\000\000\093\000\094\000\000\000\000\000\000\000\000\000\
\096\000\121\000\122\000\097\000\000\000\000\000\000\000\081\000\
\082\000\083\000\084\000\085\000\098\000\099\000\100\000\086\000\
\147\000\000\000\000\000\000\000\089\000\000\000\090\000\000\000\
\000\000\000\000\000\000\000\000\000\000\091\000\092\000\000\000\
\000\000\000\000\093\000\094\000\000\000\000\000\000\000\000\000\
\096\000\000\000\000\000\097\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\098\000\099\000\100\000\113\000\
\114\000\115\000\116\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\118\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\121\000\122\000\113\000\
\114\000\115\000\116\000\081\000\082\000\083\000\084\000\085\000\
\000\000\000\000\000\000\086\000\147\000\000\000\118\000\000\000\
\089\000\000\000\000\000\000\000\000\000\020\002\000\000\000\000\
\000\000\091\000\092\000\000\000\000\000\000\000\093\000\094\000\
\000\000\000\000\000\000\000\000\096\000\121\000\122\000\097\000\
\000\000\000\000\000\000\081\000\082\000\083\000\084\000\085\000\
\098\000\099\000\100\000\086\000\147\000\000\000\000\000\000\000\
\089\000\000\000\000\000\000\000\000\000\081\002\000\000\000\000\
\000\000\091\000\092\000\000\000\000\000\000\000\093\000\094\000\
\000\000\000\000\000\000\000\000\096\000\000\000\000\000\097\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\098\000\099\000\100\000\113\000\114\000\115\000\116\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\118\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\121\000\122\000\113\000\114\000\115\000\116\000\081\000\
\082\000\083\000\084\000\085\000\000\000\000\000\000\000\086\000\
\147\000\000\000\118\000\000\000\089\000\000\000\057\002\000\000\
\000\000\000\000\000\000\000\000\000\000\091\000\092\000\000\000\
\000\000\000\000\093\000\094\000\000\000\000\000\000\000\000\000\
\096\000\121\000\122\000\097\000\000\000\000\000\000\000\081\000\
\082\000\083\000\084\000\085\000\098\000\099\000\100\000\086\000\
\147\000\000\000\000\000\000\000\089\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\091\000\092\000\000\000\
\000\000\000\000\093\000\094\000\000\000\000\000\095\000\000\000\
\096\000\000\000\000\000\097\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\098\000\099\000\100\000\113\000\
\114\000\115\000\116\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\118\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\121\000\122\000\113\000\
\114\000\115\000\116\000\081\000\082\000\083\000\084\000\085\000\
\000\000\000\000\000\000\086\000\147\000\000\000\118\000\000\000\
\089\000\000\000\142\002\000\000\000\000\000\000\000\000\000\000\
\000\000\091\000\092\000\000\000\000\000\000\000\093\000\094\000\
\000\000\000\000\000\000\000\000\096\000\121\000\122\000\097\000\
\000\000\000\000\000\000\081\000\082\000\083\000\084\000\085\000\
\098\000\099\000\100\000\086\000\147\000\000\000\000\000\000\000\
\089\000\000\000\000\000\000\000\000\000\150\002\000\000\000\000\
\000\000\091\000\092\000\000\000\000\000\000\000\093\000\094\000\
\000\000\000\000\000\000\000\000\096\000\000\000\000\000\097\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\098\000\099\000\100\000\113\000\114\000\115\000\116\000\000\000\
\000\000\054\001\000\000\000\000\000\000\054\001\054\001\000\000\
\000\000\054\001\118\000\000\000\054\001\000\000\000\000\000\000\
\000\000\000\000\081\000\082\000\083\000\084\000\085\000\054\001\
\000\000\000\000\086\000\147\000\054\001\000\000\000\000\089\000\
\218\002\121\000\122\000\113\000\114\000\115\000\116\000\054\001\
\091\000\092\000\000\000\000\000\000\000\093\000\094\000\000\000\
\000\000\000\000\118\000\096\000\000\000\000\000\097\000\000\000\
\000\000\000\000\081\000\082\000\083\000\084\000\085\000\098\000\
\099\000\100\000\086\000\147\000\000\000\000\000\000\000\089\000\
\220\002\121\000\122\000\000\000\000\000\000\000\000\000\000\000\
\091\000\092\000\000\000\000\000\000\000\093\000\094\000\000\000\
\054\001\000\000\000\000\096\000\000\000\000\000\097\000\054\001\
\000\000\000\000\000\000\054\001\000\000\000\000\000\000\098\000\
\099\000\100\000\113\000\114\000\115\000\116\000\000\000\000\000\
\000\000\000\000\000\000\000\000\054\001\000\000\054\001\000\000\
\000\000\118\000\000\000\000\000\000\000\000\000\054\001\000\000\
\000\000\081\000\082\000\083\000\084\000\085\000\000\000\000\000\
\000\000\086\000\147\000\000\000\000\000\000\000\089\000\000\000\
\121\000\122\000\113\000\114\000\115\000\116\000\242\000\091\000\
\092\000\243\000\244\000\000\000\093\000\094\000\000\000\000\000\
\000\000\118\000\096\000\000\000\000\000\097\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\098\000\099\000\
\100\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\121\000\122\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\013\000\014\000\015\000\016\000\017\000\018\000\019\000\
\020\000\021\000\022\000\023\000\024\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\032\000\033\000\034\000\035\000\
\000\000\113\000\114\000\115\000\116\000\000\000\237\001\237\001\
\000\000\237\001\237\001\237\001\237\001\000\000\237\001\000\000\
\118\000\237\001\000\000\000\000\000\000\000\000\237\001\000\000\
\040\000\000\000\000\000\237\001\237\001\000\000\000\000\000\000\
\000\000\237\001\000\000\000\000\000\000\000\000\000\000\121\000\
\122\000\000\000\000\000\000\000\237\001\000\000\000\000\000\000\
\000\000\237\001\237\001\237\001\237\001\237\001\237\001\237\001\
\237\001\237\001\237\001\237\001\237\001\237\001\237\001\237\001\
\237\001\237\001\237\001\237\001\237\001\237\001\237\001\237\001\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\237\001\000\000\237\001\000\000\000\000\000\000\237\001\
\237\001\237\001\000\000\065\001\237\001\000\000\065\001\065\001\
\065\001\000\000\237\001\065\001\000\000\000\000\065\001\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\237\001\237\001\
\237\001\065\001\000\000\237\001\000\000\237\001\065\001\000\000\
\000\000\000\000\000\000\237\001\000\000\000\000\000\000\000\000\
\000\000\065\001\000\000\000\000\000\000\000\000\065\001\065\001\
\065\001\065\001\065\001\065\001\065\001\065\001\065\001\065\001\
\065\001\065\001\065\001\065\001\065\001\065\001\065\001\065\001\
\065\001\065\001\065\001\065\001\065\001\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\065\001\000\000\065\001\000\000\065\001\065\001\000\000\066\001\
\000\000\065\001\066\001\066\001\066\001\065\001\000\000\066\001\
\000\000\000\000\066\001\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\066\001\065\001\000\000\
\065\001\000\000\066\001\000\000\000\000\000\000\000\000\000\000\
\065\001\000\000\000\000\000\000\000\000\066\001\000\000\000\000\
\000\000\000\000\066\001\066\001\066\001\066\001\066\001\066\001\
\066\001\066\001\066\001\066\001\066\001\066\001\066\001\066\001\
\066\001\066\001\066\001\066\001\066\001\066\001\066\001\066\001\
\066\001\052\001\000\000\000\000\000\000\052\001\052\001\000\000\
\000\000\052\001\053\001\000\000\052\001\000\000\053\001\053\001\
\000\000\000\000\053\001\000\000\066\001\053\001\066\001\052\001\
\066\001\066\001\000\000\000\000\052\001\066\001\000\000\000\000\
\053\001\066\001\000\000\000\000\051\001\053\001\000\000\052\001\
\051\001\051\001\000\000\000\000\051\001\000\000\000\000\051\001\
\053\001\000\000\066\001\000\000\066\001\000\000\000\000\000\000\
\000\000\000\000\051\001\000\000\066\001\000\000\000\000\051\001\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\051\001\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\052\001\000\000\000\000\000\000\000\000\000\000\000\000\052\001\
\000\000\053\001\000\000\052\001\000\000\000\000\000\000\000\000\
\053\001\000\000\000\000\000\000\053\001\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\052\001\000\000\052\001\000\000\
\000\000\000\000\000\000\051\001\000\000\053\001\052\001\053\001\
\000\000\249\000\051\001\249\000\249\000\000\000\051\001\053\001\
\000\000\249\000\000\000\000\000\000\000\000\000\249\000\000\000\
\000\000\000\000\000\000\249\000\249\000\000\000\000\000\051\001\
\000\000\051\001\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\051\001\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\249\000\249\000\249\000\249\000\249\000\249\000\249\000\
\249\000\249\000\249\000\249\000\249\000\249\000\249\000\249\000\
\249\000\249\000\249\000\249\000\249\000\249\000\249\000\249\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\249\000\000\000\249\000\249\000\249\000\000\000\249\000\
\249\000\249\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\249\000\000\000\000\000\248\000\000\000\248\000\
\248\000\000\000\000\000\000\000\000\000\248\000\249\000\249\000\
\249\000\249\000\248\000\000\000\000\000\249\000\000\000\248\000\
\248\000\000\000\000\000\249\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\248\000\248\000\248\000\
\248\000\248\000\248\000\248\000\248\000\248\000\248\000\248\000\
\248\000\248\000\248\000\248\000\248\000\248\000\248\000\248\000\
\248\000\248\000\248\000\248\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\248\000\000\000\248\000\
\248\000\248\000\000\000\248\000\248\000\248\000\000\000\000\000\
\063\001\000\000\000\000\063\001\063\001\000\000\248\000\000\000\
\063\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\248\000\248\000\248\000\248\000\063\001\000\000\
\000\000\248\000\000\000\063\001\000\000\000\000\000\000\248\000\
\000\000\000\000\000\000\000\000\000\000\000\000\063\001\000\000\
\000\000\000\000\000\000\063\001\063\001\063\001\063\001\063\001\
\063\001\063\001\063\001\063\001\063\001\063\001\063\001\063\001\
\063\001\063\001\063\001\063\001\063\001\063\001\063\001\063\001\
\063\001\063\001\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\236\000\000\000\000\000\236\000\236\000\063\001\000\000\063\001\
\236\000\063\001\063\001\000\000\000\000\000\000\063\001\000\000\
\000\000\000\000\063\001\000\000\000\000\011\000\236\000\000\000\
\000\000\000\000\000\000\236\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\063\001\000\000\063\001\236\000\049\001\
\000\000\000\000\063\001\236\000\236\000\236\000\236\000\236\000\
\236\000\236\000\236\000\236\000\236\000\236\000\236\000\236\000\
\236\000\236\000\236\000\236\000\236\000\236\000\236\000\236\000\
\236\000\236\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\141\001\000\000\
\000\000\141\001\000\000\000\000\000\000\236\000\074\001\236\000\
\000\000\236\000\236\000\074\001\000\000\000\000\236\000\000\000\
\000\000\074\001\236\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\236\000\000\000\236\000\141\001\141\001\
\141\001\141\001\141\001\141\001\141\001\141\001\141\001\141\001\
\141\001\141\001\141\001\141\001\141\001\141\001\141\001\141\001\
\141\001\141\001\141\001\141\001\141\001\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\074\001\143\001\
\141\001\000\000\143\001\000\000\141\001\141\001\141\001\077\001\
\000\000\000\000\000\000\000\000\077\001\000\000\000\000\141\001\
\000\000\000\000\077\001\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\141\001\141\001\141\001\000\000\000\000\
\000\000\000\000\141\001\000\000\000\000\000\000\000\000\143\001\
\143\001\143\001\143\001\143\001\143\001\143\001\143\001\143\001\
\143\001\143\001\143\001\143\001\143\001\143\001\143\001\143\001\
\143\001\143\001\143\001\143\001\143\001\143\001\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\077\001\
\142\001\143\001\000\000\142\001\000\000\143\001\143\001\143\001\
\076\001\000\000\000\000\000\000\000\000\076\001\000\000\000\000\
\143\001\000\000\000\000\076\001\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\143\001\143\001\143\001\000\000\
\000\000\000\000\000\000\143\001\000\000\000\000\000\000\000\000\
\142\001\142\001\142\001\142\001\142\001\142\001\142\001\142\001\
\142\001\142\001\142\001\142\001\142\001\142\001\142\001\142\001\
\142\001\142\001\142\001\142\001\142\001\142\001\142\001\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\009\000\000\000\000\000\011\000\000\000\000\000\
\076\001\000\000\142\001\000\000\000\000\000\000\142\001\142\001\
\142\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\131\001\142\001\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\142\001\142\001\142\001\
\000\000\000\000\000\000\000\000\142\001\013\000\014\000\015\000\
\016\000\017\000\018\000\019\000\020\000\021\000\022\000\023\000\
\024\000\000\000\000\000\000\000\000\000\000\000\030\000\031\000\
\032\000\033\000\034\000\035\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\063\001\000\000\011\000\000\000\064\001\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\037\000\
\000\000\000\000\000\000\000\000\040\000\041\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\042\000\000\000\
\043\000\044\000\045\000\046\000\047\000\048\000\049\000\000\000\
\000\000\000\000\050\000\051\000\052\000\013\000\014\000\015\000\
\016\000\017\000\018\000\019\000\020\000\021\000\022\000\023\000\
\024\000\025\000\026\000\027\000\028\000\029\000\030\000\031\000\
\032\000\033\000\034\000\035\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\063\001\000\000\011\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\037\000\
\000\000\160\000\000\000\039\000\040\000\000\000\000\000\155\002\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\161\000\013\000\014\000\
\015\000\016\000\017\000\018\000\019\000\020\000\021\000\022\000\
\023\000\024\000\025\000\026\000\027\000\028\000\029\000\030\000\
\031\000\032\000\033\000\034\000\035\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\063\001\000\000\011\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\037\000\000\000\160\000\000\000\039\000\040\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\161\000\013\000\
\014\000\015\000\016\000\017\000\018\000\019\000\020\000\021\000\
\022\000\023\000\024\000\025\000\026\000\027\000\028\000\029\000\
\030\000\031\000\032\000\033\000\034\000\035\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\200\001\000\000\
\200\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\037\000\000\000\160\000\000\000\039\000\040\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\161\000\
\200\001\200\001\200\001\200\001\200\001\200\001\200\001\200\001\
\200\001\200\001\200\001\200\001\200\001\200\001\200\001\200\001\
\200\001\200\001\200\001\200\001\200\001\200\001\200\001\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\011\000\000\000\000\000\090\000\000\000\000\000\000\000\
\000\000\000\000\200\001\000\000\200\001\000\000\200\001\200\001\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\200\001\013\000\014\000\015\000\016\000\017\000\018\000\019\000\
\020\000\021\000\022\000\023\000\024\000\025\000\026\000\027\000\
\028\000\029\000\030\000\031\000\032\000\033\000\034\000\035\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\037\000\000\000\000\000\000\000\039\000\
\040\000\041\000\000\000\000\000\000\000\000\000\000\000\000\000\
\008\000\000\000\042\000\000\000\008\000\000\000\008\000\008\000\
\008\000\008\000\008\000\008\000\008\000\008\000\050\000\051\000\
\052\000\010\000\008\000\008\000\008\000\008\000\008\000\008\000\
\008\000\008\000\008\000\008\000\008\000\008\000\008\000\008\000\
\008\000\008\000\008\000\008\000\008\000\008\000\008\000\009\000\
\000\000\000\000\000\000\009\000\000\000\009\000\009\000\009\000\
\009\000\009\000\009\000\009\000\009\000\000\000\000\000\000\000\
\012\000\009\000\009\000\009\000\009\000\009\000\009\000\009\000\
\009\000\009\000\009\000\009\000\009\000\009\000\009\000\009\000\
\009\000\009\000\009\000\009\000\009\000\009\000\242\000\000\000\
\000\000\243\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\008\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\063\001\000\000\
\011\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\013\000\014\000\015\000\016\000\017\000\018\000\019\000\
\020\000\021\000\022\000\023\000\024\000\009\000\000\000\000\000\
\000\000\000\000\000\000\000\000\032\000\033\000\034\000\035\000\
\013\000\014\000\015\000\016\000\017\000\018\000\019\000\020\000\
\021\000\022\000\023\000\024\000\025\000\026\000\027\000\028\000\
\029\000\030\000\031\000\032\000\033\000\034\000\035\000\000\000\
\040\000\010\000\011\000\000\000\000\000\000\000\166\002\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\037\000\000\000\000\000\000\000\039\000\040\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\013\000\014\000\015\000\016\000\017\000\018\000\
\019\000\020\000\021\000\022\000\023\000\024\000\025\000\026\000\
\027\000\028\000\029\000\030\000\031\000\032\000\033\000\034\000\
\035\000\010\000\011\000\000\000\000\000\000\000\240\002\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\155\000\037\000\000\000\000\000\000\000\
\039\000\040\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\013\000\014\000\015\000\016\000\017\000\018\000\
\019\000\020\000\021\000\022\000\023\000\024\000\025\000\026\000\
\027\000\028\000\029\000\030\000\031\000\032\000\033\000\034\000\
\035\000\011\000\000\000\000\000\090\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\155\000\037\000\000\000\000\000\000\000\
\039\000\040\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\013\000\014\000\015\000\016\000\017\000\018\000\019\000\
\020\000\021\000\022\000\023\000\024\000\025\000\026\000\027\000\
\028\000\029\000\030\000\031\000\032\000\033\000\034\000\035\000\
\011\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\037\000\000\000\000\000\000\000\039\000\
\040\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\013\000\014\000\015\000\016\000\017\000\018\000\019\000\020\000\
\021\000\022\000\023\000\024\000\025\000\026\000\027\000\028\000\
\029\000\030\000\031\000\032\000\033\000\034\000\035\000\011\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\037\000\000\000\000\000\000\000\039\000\040\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\013\000\
\014\000\015\000\016\000\017\000\018\000\019\000\020\000\021\000\
\022\000\023\000\024\000\107\000\000\000\000\000\000\000\000\000\
\030\000\031\000\032\000\033\000\034\000\035\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\037\000\000\000\000\000\000\000\000\000\040\000\000\000\
\000\000\000\000\000\000\107\000\107\000\107\000\107\000\107\000\
\107\000\107\000\107\000\107\000\107\000\107\000\107\000\000\000\
\000\000\000\000\000\000\000\000\107\000\107\000\107\000\107\000\
\107\000\107\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\179\000\
\179\000\179\000\179\000\000\000\000\000\107\000\000\000\000\000\
\179\000\000\000\107\000\179\000\179\000\179\000\179\000\179\000\
\000\000\000\000\000\000\179\000\000\000\179\000\179\000\179\000\
\179\000\179\000\000\000\179\000\000\000\179\000\179\000\179\000\
\179\000\179\000\179\000\179\000\179\000\179\000\179\000\179\000\
\179\000\179\000\179\000\179\000\179\000\179\000\179\000\179\000\
\179\000\179\000\179\000\000\000\000\000\000\000\000\000\175\000\
\175\000\175\000\175\000\000\000\000\000\000\000\000\000\000\000\
\175\000\000\000\000\000\175\000\175\000\175\000\175\000\175\000\
\000\000\000\000\000\000\175\000\179\000\175\000\175\000\175\000\
\175\000\175\000\179\000\175\000\000\000\175\000\175\000\175\000\
\175\000\175\000\175\000\175\000\175\000\175\000\175\000\175\000\
\175\000\175\000\175\000\175\000\175\000\175\000\175\000\175\000\
\175\000\175\000\175\000\000\000\000\000\000\000\000\000\156\001\
\157\001\158\001\159\001\000\000\000\000\000\000\000\000\000\000\
\160\001\000\000\000\000\161\001\162\001\163\001\164\001\165\001\
\000\000\000\000\000\000\166\001\175\000\167\001\168\001\169\001\
\170\001\171\001\175\000\172\001\000\000\173\001\000\000\174\001\
\175\001\176\001\177\001\178\001\179\001\180\001\181\001\182\001\
\183\001\184\001\185\001\186\001\187\001\188\001\189\001\190\001\
\191\001\192\001\193\001\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\008\000\000\000\000\000\008\000\008\000\000\000\008\000\008\000\
\008\000\008\000\008\000\000\000\194\001\008\000\000\000\000\000\
\000\000\005\000\195\001\008\000\008\000\008\000\008\000\008\000\
\008\000\008\000\008\000\008\000\008\000\008\000\008\000\008\000\
\008\000\008\000\008\000\008\000\008\000\008\000\008\000"

let yycheck = "\003\000\
\002\000\034\000\138\000\002\000\002\000\002\000\177\000\146\000\
\003\000\008\000\008\000\008\000\127\001\191\000\032\000\033\000\
\004\000\104\000\000\000\056\001\000\000\092\002\080\001\010\000\
\250\000\067\001\021\001\077\000\057\001\197\001\002\001\066\000\
\151\000\152\000\008\001\014\001\000\000\173\000\177\000\089\000\
\126\001\074\000\128\001\008\001\030\001\039\002\048\001\230\000\
\066\000\025\001\019\001\002\000\005\000\155\001\076\002\023\001\
\025\001\025\001\008\001\014\001\036\001\035\001\017\001\019\001\
\014\001\019\001\002\000\019\001\062\002\025\001\101\001\025\001\
\022\001\025\001\116\001\111\000\019\001\185\000\077\000\077\000\
\077\000\116\000\025\001\000\000\171\000\134\000\194\000\116\001\
\018\001\208\000\063\002\093\001\018\001\018\001\100\001\101\001\
\022\001\052\001\129\001\101\000\021\001\089\000\018\001\107\000\
\212\000\018\001\018\001\111\000\210\001\131\002\146\000\097\001\
\107\000\014\001\250\000\021\001\017\001\014\001\255\000\092\002\
\036\001\018\001\110\000\129\001\018\001\022\001\077\000\176\000\
\022\001\108\001\025\001\022\001\018\001\024\001\170\000\030\001\
\154\000\014\001\133\001\030\001\018\001\036\001\146\000\112\001\
\041\001\075\001\027\001\146\000\146\000\146\000\185\000\146\000\
\131\001\108\001\112\001\052\001\191\000\037\001\132\001\194\000\
\154\000\114\000\075\001\213\000\214\000\048\001\170\000\132\001\
\014\001\142\002\139\001\017\001\190\000\177\000\223\000\133\001\
\131\001\212\000\177\000\177\000\177\000\134\000\177\000\139\001\
\255\002\139\001\111\001\139\001\003\003\177\000\184\002\112\001\
\241\000\025\001\212\000\018\001\139\001\075\001\151\000\152\000\
\112\002\081\001\097\001\197\002\036\001\192\000\112\001\108\001\
\018\001\040\001\093\001\108\001\133\001\248\000\213\000\213\000\
\213\000\098\001\070\001\091\000\092\000\111\001\018\001\176\000\
\055\001\027\002\022\001\133\001\200\001\021\001\131\001\230\000\
\230\000\230\000\131\001\239\000\021\001\023\002\226\000\025\002\
\239\000\113\000\239\000\237\002\232\000\233\000\020\001\104\000\
\236\000\029\001\030\001\032\002\025\002\223\001\002\001\208\000\
\104\000\208\000\115\000\002\001\019\001\002\001\036\001\214\000\
\019\001\095\002\025\001\130\001\048\001\111\001\223\000\123\001\
\208\000\005\001\201\001\202\001\035\001\140\001\025\001\136\000\
\035\001\029\001\030\001\135\001\115\001\029\001\030\001\000\000\
\241\000\036\001\142\001\070\001\176\000\019\001\074\001\019\001\
\028\001\181\000\014\002\085\002\048\001\041\001\115\001\215\002\
\111\001\048\001\048\001\048\001\070\001\048\001\023\001\019\001\
\052\001\093\001\171\000\018\001\095\001\025\001\025\001\022\001\
\112\001\034\001\060\001\171\000\133\001\000\000\074\001\112\001\
\059\001\036\001\211\001\212\001\070\001\095\001\074\001\075\001\
\025\001\085\001\041\001\053\002\010\001\133\001\012\001\223\001\
\123\001\093\001\085\001\036\001\133\001\052\001\093\001\093\001\
\093\001\134\001\093\001\108\001\135\001\095\001\019\001\099\001\
\244\000\123\001\014\001\142\001\025\001\079\002\032\002\153\002\
\199\001\039\000\136\001\255\000\000\001\135\001\014\001\003\001\
\004\001\014\001\018\001\141\001\014\001\018\001\113\001\018\001\
\018\001\022\001\025\001\057\000\021\001\129\001\035\001\023\001\
\025\001\025\001\173\001\065\000\035\001\036\001\101\001\027\001\
\018\001\071\000\005\003\018\001\112\001\006\001\007\001\008\001\
\009\001\010\001\011\001\012\001\013\001\014\001\015\001\016\001\
\017\001\018\001\019\001\020\001\021\001\022\001\023\001\024\001\
\025\001\023\001\129\001\025\001\018\001\053\002\146\002\139\001\
\014\001\130\001\030\002\130\001\011\003\012\003\014\001\040\001\
\036\002\014\001\018\001\140\001\017\001\140\001\088\001\020\001\
\040\001\024\002\130\001\112\001\200\001\018\001\055\001\079\002\
\018\001\200\001\035\001\200\001\140\001\036\001\176\002\055\001\
\039\003\041\001\019\001\042\002\108\001\044\002\098\001\108\001\
\025\001\025\001\108\001\019\001\052\001\014\001\139\001\193\002\
\154\000\025\001\035\001\058\002\232\001\000\000\018\001\088\001\
\220\001\091\000\092\000\131\001\224\001\232\001\131\001\020\001\
\088\001\131\001\126\001\127\001\128\001\217\002\014\001\099\002\
\019\001\017\001\019\001\030\002\020\001\032\002\025\001\113\000\
\025\001\036\002\115\001\020\001\040\002\000\000\177\002\193\000\
\020\001\013\002\014\002\115\001\019\001\031\002\013\002\014\002\
\013\002\014\002\025\001\014\001\108\001\019\001\017\001\019\001\
\018\001\075\002\059\002\025\001\022\001\025\001\024\001\019\001\
\026\001\027\001\028\001\022\002\040\002\025\001\177\002\034\001\
\176\002\112\001\036\002\131\001\046\002\018\001\045\002\045\002\
\045\002\020\001\019\001\018\001\021\001\019\001\023\001\022\001\
\025\001\193\002\011\001\025\001\034\001\035\001\031\001\009\001\
\099\002\034\001\035\001\036\001\037\001\038\001\039\001\211\001\
\212\001\014\001\041\001\070\001\017\001\019\001\014\001\020\001\
\098\002\017\001\014\001\025\001\020\001\052\001\199\001\089\001\
\019\001\018\001\021\001\019\001\023\001\105\001\025\001\199\001\
\204\002\025\001\124\001\125\001\031\001\019\001\114\001\034\001\
\035\001\036\001\037\001\038\001\039\001\040\001\041\001\106\001\
\116\002\018\001\126\001\127\001\128\001\019\001\122\002\123\002\
\019\001\116\002\022\001\025\001\054\001\014\001\025\001\122\002\
\123\002\018\001\060\001\119\002\120\002\121\002\019\001\019\001\
\140\002\018\001\000\000\018\001\070\001\025\001\146\002\112\001\
\019\001\140\002\035\001\146\002\005\002\146\002\025\001\021\001\
\041\001\035\001\019\001\154\002\154\002\154\002\035\001\000\000\
\025\001\020\001\019\001\052\001\251\002\095\001\168\002\024\002\
\025\001\204\002\139\001\034\001\035\001\177\002\019\001\025\001\
\024\002\130\002\177\002\177\002\177\002\112\001\177\002\019\001\
\030\001\042\002\204\002\044\002\025\001\177\002\036\001\121\001\
\076\002\022\001\042\002\024\001\044\002\026\001\018\001\019\001\
\030\001\058\002\022\001\180\002\181\002\019\001\063\002\019\001\
\139\001\186\002\058\002\095\002\101\001\217\002\218\002\063\002\
\220\002\019\001\217\002\108\001\217\002\041\001\112\001\218\002\
\212\002\220\002\112\001\019\001\232\002\140\001\019\001\111\001\
\052\001\025\001\019\001\092\002\025\001\232\002\021\001\019\001\
\129\001\018\001\131\001\245\002\092\002\025\001\103\002\131\002\
\019\001\024\001\021\001\018\001\023\001\019\001\025\001\103\002\
\019\001\141\002\246\002\025\001\031\001\108\001\025\001\034\001\
\035\001\036\001\037\001\038\001\016\003\019\001\018\003\036\001\
\020\003\140\001\019\001\025\001\019\001\016\003\035\001\018\003\
\019\001\020\003\021\001\019\001\023\001\142\002\025\001\014\001\
\000\000\025\001\019\001\018\001\031\001\023\001\142\002\034\001\
\035\001\036\001\037\001\038\001\039\001\040\001\041\001\042\001\
\043\001\019\001\054\003\055\003\035\001\036\001\021\001\025\001\
\060\003\035\001\041\001\054\003\055\003\036\001\018\001\089\001\
\035\001\060\003\025\001\180\002\181\002\052\001\018\001\023\001\
\035\001\186\002\014\001\014\001\180\002\181\002\020\001\036\001\
\035\001\019\001\186\002\019\001\018\001\112\001\050\001\051\001\
\052\001\053\001\054\001\055\001\056\001\206\002\001\000\002\000\
\003\000\004\000\005\000\023\001\030\002\018\001\206\002\243\002\
\025\001\019\001\036\002\052\001\053\001\054\001\055\001\056\001\
\139\001\021\001\019\001\014\001\014\001\112\001\101\001\023\001\
\082\001\005\003\019\001\036\001\112\001\108\001\021\001\019\001\
\082\001\025\001\036\001\021\001\000\000\036\001\019\001\008\001\
\023\001\018\001\251\002\019\001\133\001\125\001\036\001\009\001\
\139\001\036\001\129\001\251\002\131\001\000\000\021\001\035\001\
\014\001\036\001\036\001\000\000\018\001\019\001\019\001\112\001\
\022\001\021\001\019\001\025\001\005\001\006\001\007\001\008\001\
\112\001\112\001\021\001\036\001\056\003\014\001\021\001\112\001\
\017\001\018\001\019\001\020\001\021\001\022\001\023\001\024\001\
\025\001\026\001\027\001\028\001\029\001\030\001\031\001\035\001\
\033\001\034\001\035\001\036\001\037\001\038\001\039\001\040\001\
\041\001\042\001\043\001\044\001\045\001\046\001\047\001\048\001\
\049\001\050\001\051\001\052\001\053\001\054\001\055\001\056\001\
\057\001\058\001\059\001\060\001\061\001\062\001\063\001\064\001\
\065\001\066\001\067\001\068\001\069\001\070\001\071\001\072\001\
\073\001\074\001\075\001\076\001\077\001\078\001\079\001\019\001\
\112\001\082\001\112\001\112\001\002\000\000\000\108\001\088\001\
\087\001\218\000\112\001\138\000\130\002\213\001\102\001\245\002\
\097\001\047\002\099\001\100\001\101\001\056\003\103\001\104\001\
\105\001\210\002\164\000\205\000\121\001\131\001\071\001\112\001\
\082\002\114\001\000\000\199\002\005\003\139\001\123\001\065\002\
\207\000\130\001\204\002\094\002\102\002\126\001\127\001\128\001\
\129\001\206\002\140\001\169\000\133\001\005\001\006\001\007\001\
\008\001\074\001\139\001\160\002\040\002\177\002\014\001\138\002\
\255\255\017\001\018\001\019\001\020\001\021\001\022\001\023\001\
\024\001\025\001\026\001\027\001\028\001\029\001\030\001\031\001\
\255\255\033\001\034\001\035\001\036\001\037\001\038\001\039\001\
\040\001\041\001\042\001\043\001\044\001\045\001\046\001\047\001\
\048\001\049\001\050\001\051\001\052\001\053\001\054\001\055\001\
\056\001\057\001\058\001\059\001\060\001\061\001\062\001\063\001\
\064\001\065\001\066\001\067\001\068\001\069\001\070\001\071\001\
\072\001\073\001\074\001\075\001\076\001\077\001\078\001\079\001\
\255\255\255\255\082\001\255\255\255\255\255\255\255\255\255\255\
\088\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\097\001\255\255\099\001\100\001\101\001\255\255\103\001\
\104\001\105\001\255\255\255\255\000\000\255\255\255\255\255\255\
\112\001\255\255\114\001\255\255\255\255\255\255\255\255\019\001\
\255\255\021\001\255\255\023\001\255\255\025\001\126\001\127\001\
\128\001\129\001\255\255\255\255\255\255\133\001\034\001\035\001\
\036\001\014\001\255\255\139\001\017\001\018\001\019\001\255\255\
\021\001\022\001\023\001\255\255\025\001\255\255\000\000\255\255\
\029\001\030\001\031\001\255\255\255\255\034\001\035\001\036\001\
\037\001\038\001\039\001\040\001\041\001\042\001\043\001\044\001\
\045\001\046\001\047\001\048\001\049\001\050\001\051\001\052\001\
\053\001\054\001\055\001\056\001\057\001\058\001\059\001\060\001\
\061\001\062\001\063\001\064\001\065\001\066\001\067\001\068\001\
\069\001\070\001\071\001\072\001\073\001\074\001\075\001\076\001\
\077\001\078\001\079\001\048\001\049\001\050\001\051\001\052\001\
\053\001\054\001\055\001\056\001\112\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\099\001\255\255\
\101\001\255\255\103\001\104\001\255\255\255\255\000\000\108\001\
\019\001\255\255\021\001\112\001\023\001\255\255\025\001\139\001\
\255\255\255\255\255\255\255\255\031\001\255\255\255\255\034\001\
\035\001\036\001\037\001\255\255\129\001\255\255\131\001\255\255\
\014\001\255\255\255\255\017\001\018\001\019\001\139\001\021\001\
\022\001\023\001\255\255\025\001\255\255\000\000\255\255\029\001\
\030\001\031\001\255\255\255\255\034\001\035\001\036\001\037\001\
\038\001\039\001\040\001\041\001\042\001\043\001\044\001\045\001\
\046\001\047\001\048\001\049\001\050\001\051\001\052\001\053\001\
\054\001\055\001\056\001\057\001\058\001\059\001\060\001\061\001\
\062\001\063\001\064\001\065\001\066\001\067\001\068\001\069\001\
\070\001\071\001\072\001\073\001\074\001\075\001\076\001\077\001\
\078\001\079\001\255\255\255\255\255\255\112\001\042\001\043\001\
\044\001\045\001\046\001\047\001\048\001\049\001\050\001\051\001\
\052\001\053\001\054\001\055\001\056\001\099\001\255\255\101\001\
\255\255\103\001\104\001\255\255\255\255\000\000\108\001\255\255\
\139\001\255\255\112\001\041\001\042\001\043\001\044\001\045\001\
\046\001\047\001\048\001\049\001\050\001\051\001\052\001\053\001\
\054\001\055\001\056\001\129\001\008\001\131\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\139\001\018\001\019\001\
\255\255\021\001\022\001\023\001\024\001\025\001\026\001\027\001\
\028\001\029\001\030\001\031\001\000\000\255\255\034\001\035\001\
\036\001\037\001\038\001\039\001\040\001\041\001\042\001\043\001\
\044\001\045\001\046\001\047\001\048\001\049\001\050\001\051\001\
\052\001\053\001\054\001\055\001\056\001\255\255\255\255\255\255\
\018\001\019\001\255\255\021\001\022\001\023\001\024\001\025\001\
\026\001\027\001\028\001\029\001\030\001\031\001\255\255\255\255\
\034\001\035\001\036\001\037\001\038\001\039\001\040\001\041\001\
\042\001\043\001\044\001\045\001\046\001\047\001\048\001\049\001\
\050\001\051\001\052\001\053\001\054\001\055\001\056\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\000\000\112\001\040\001\041\001\042\001\
\043\001\044\001\045\001\046\001\047\001\048\001\049\001\050\001\
\051\001\052\001\053\001\054\001\055\001\056\001\008\001\255\255\
\132\001\255\255\255\255\255\255\255\255\255\255\255\255\139\001\
\018\001\019\001\255\255\021\001\022\001\023\001\024\001\025\001\
\026\001\027\001\028\001\029\001\030\001\031\001\112\001\000\000\
\034\001\035\001\036\001\037\001\038\001\039\001\040\001\041\001\
\042\001\043\001\044\001\045\001\046\001\047\001\048\001\049\001\
\050\001\051\001\052\001\053\001\054\001\055\001\056\001\018\001\
\019\001\139\001\021\001\022\001\023\001\024\001\025\001\026\001\
\027\001\028\001\029\001\030\001\031\001\000\000\255\255\034\001\
\035\001\036\001\037\001\038\001\039\001\040\001\041\001\042\001\
\043\001\044\001\045\001\046\001\047\001\048\001\049\001\050\001\
\051\001\052\001\053\001\054\001\055\001\056\001\044\001\045\001\
\046\001\047\001\048\001\049\001\050\001\051\001\052\001\053\001\
\054\001\055\001\056\001\255\255\255\255\255\255\112\001\000\000\
\039\001\040\001\041\001\042\001\043\001\044\001\045\001\046\001\
\047\001\048\001\049\001\050\001\051\001\052\001\053\001\054\001\
\055\001\056\001\132\001\255\255\255\255\255\255\255\255\255\255\
\019\001\139\001\021\001\022\001\023\001\255\255\025\001\255\255\
\255\255\255\255\029\001\030\001\031\001\112\001\255\255\034\001\
\035\001\036\001\037\001\038\001\039\001\040\001\041\001\042\001\
\043\001\044\001\045\001\046\001\047\001\048\001\049\001\050\001\
\051\001\052\001\053\001\054\001\055\001\056\001\255\255\255\255\
\139\001\255\255\255\255\255\255\255\255\255\255\255\255\019\001\
\255\255\021\001\255\255\023\001\255\255\025\001\000\000\255\255\
\255\255\029\001\030\001\031\001\255\255\255\255\034\001\035\001\
\036\001\037\001\038\001\039\001\040\001\041\001\042\001\043\001\
\044\001\045\001\046\001\047\001\048\001\049\001\050\001\051\001\
\052\001\053\001\054\001\055\001\056\001\255\255\255\255\000\000\
\031\001\255\255\255\255\255\255\255\255\112\001\037\001\038\001\
\039\001\040\001\041\001\042\001\043\001\044\001\045\001\046\001\
\047\001\048\001\049\001\050\001\051\001\052\001\053\001\054\001\
\055\001\056\001\255\255\255\255\255\255\255\255\255\255\255\255\
\139\001\255\255\255\255\255\255\255\255\255\255\019\001\255\255\
\021\001\255\255\023\001\255\255\025\001\000\000\255\255\255\255\
\029\001\030\001\031\001\255\255\112\001\034\001\035\001\036\001\
\037\001\038\001\039\001\040\001\041\001\042\001\043\001\044\001\
\045\001\046\001\047\001\048\001\049\001\050\001\051\001\052\001\
\053\001\054\001\055\001\056\001\255\255\255\255\000\000\139\001\
\255\255\255\255\019\001\255\255\021\001\255\255\023\001\255\255\
\025\001\255\255\255\255\255\255\029\001\030\001\031\001\255\255\
\255\255\034\001\035\001\036\001\037\001\038\001\039\001\040\001\
\041\001\042\001\043\001\044\001\045\001\046\001\047\001\048\001\
\049\001\050\001\051\001\052\001\053\001\054\001\055\001\056\001\
\019\001\255\255\021\001\255\255\023\001\000\000\025\001\255\255\
\255\255\255\255\255\255\112\001\031\001\255\255\255\255\034\001\
\035\001\036\001\037\001\038\001\039\001\040\001\041\001\042\001\
\043\001\044\001\045\001\046\001\047\001\048\001\049\001\050\001\
\051\001\052\001\053\001\054\001\055\001\056\001\139\001\255\255\
\000\000\255\255\019\001\255\255\021\001\255\255\023\001\255\255\
\025\001\255\255\255\255\255\255\029\001\030\001\031\001\112\001\
\255\255\034\001\035\001\036\001\037\001\038\001\039\001\040\001\
\041\001\042\001\043\001\044\001\045\001\046\001\047\001\048\001\
\049\001\050\001\051\001\052\001\053\001\054\001\055\001\056\001\
\255\255\255\255\139\001\255\255\000\000\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\112\001\006\001\007\001\
\008\001\009\001\010\001\011\001\012\001\013\001\014\001\015\001\
\016\001\017\001\018\001\019\001\020\001\021\001\022\001\023\001\
\024\001\025\001\255\255\255\255\255\255\255\255\255\255\255\255\
\139\001\019\001\000\000\021\001\255\255\023\001\255\255\025\001\
\255\255\255\255\255\255\255\255\255\255\031\001\255\255\112\001\
\034\001\035\001\036\001\037\001\038\001\039\001\040\001\041\001\
\042\001\043\001\044\001\045\001\046\001\047\001\048\001\049\001\
\050\001\051\001\019\001\255\255\021\001\255\255\023\001\255\255\
\025\001\255\255\139\001\000\000\255\255\255\255\031\001\255\255\
\255\255\034\001\035\001\036\001\037\001\038\001\039\001\040\001\
\041\001\042\001\043\001\044\001\045\001\046\001\047\001\048\001\
\049\001\050\001\051\001\255\255\255\255\255\255\255\255\000\000\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\019\001\255\255\021\001\255\255\023\001\255\255\025\001\255\255\
\255\255\255\255\255\255\255\255\031\001\255\255\112\001\034\001\
\035\001\036\001\037\001\038\001\039\001\040\001\041\001\042\001\
\043\001\044\001\045\001\046\001\047\001\048\001\049\001\000\000\
\255\255\019\001\255\255\021\001\255\255\023\001\255\255\025\001\
\255\255\139\001\255\255\255\255\255\255\031\001\000\000\112\001\
\034\001\035\001\036\001\037\001\038\001\039\001\040\001\041\001\
\042\001\043\001\044\001\045\001\046\001\047\001\048\001\049\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\139\001\255\255\255\255\255\255\255\255\255\255\
\019\001\255\255\021\001\255\255\023\001\255\255\025\001\255\255\
\255\255\255\255\255\255\255\255\031\001\112\001\255\255\034\001\
\035\001\036\001\037\001\038\001\039\001\040\001\041\001\042\001\
\043\001\044\001\045\001\046\001\047\001\255\255\255\255\255\255\
\255\255\255\255\255\255\019\001\255\255\021\001\255\255\023\001\
\139\001\025\001\255\255\255\255\255\255\255\255\112\001\031\001\
\000\000\255\255\034\001\035\001\036\001\037\001\038\001\039\001\
\040\001\041\001\042\001\043\001\044\001\045\001\046\001\047\001\
\255\255\255\255\255\255\255\255\005\000\255\255\255\255\255\255\
\255\255\139\001\255\255\255\255\255\255\255\255\255\255\019\001\
\255\255\021\001\255\255\023\001\255\255\025\001\255\255\255\255\
\255\255\255\255\255\255\031\001\255\255\112\001\034\001\035\001\
\036\001\037\001\038\001\039\001\040\001\041\001\042\001\043\001\
\044\001\045\001\046\001\047\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\019\001\255\255\021\001\
\139\001\023\001\255\255\025\001\255\255\255\255\255\255\255\255\
\112\001\031\001\255\255\255\255\034\001\035\001\036\001\037\001\
\038\001\039\001\040\001\041\001\042\001\043\001\044\001\045\001\
\046\001\047\001\159\000\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\139\001\255\255\255\255\019\001\255\255\
\021\001\255\255\023\001\255\255\025\001\255\255\255\255\255\255\
\255\255\255\255\031\001\255\255\112\001\034\001\035\001\036\001\
\037\001\038\001\039\001\040\001\041\001\042\001\043\001\000\000\
\255\255\255\255\019\001\255\255\021\001\255\255\023\001\255\255\
\025\001\255\255\255\255\255\255\255\255\134\000\031\001\139\001\
\255\255\034\001\035\001\036\001\037\001\038\001\039\001\040\001\
\255\255\255\255\112\001\255\255\255\255\255\255\151\000\152\000\
\255\255\255\255\255\255\255\255\255\255\014\001\255\255\255\255\
\255\255\018\001\019\001\255\255\255\255\022\001\255\255\244\000\
\025\001\255\255\255\255\255\255\014\001\139\001\255\255\176\000\
\018\001\019\001\255\000\255\255\022\001\255\255\255\255\255\255\
\255\255\255\255\255\255\112\001\255\255\255\255\255\255\255\255\
\193\000\035\001\036\001\000\000\255\255\255\255\255\255\041\001\
\255\255\255\255\255\255\255\255\255\255\255\255\027\001\208\000\
\255\255\255\255\052\001\255\255\255\255\255\255\139\001\112\001\
\255\255\255\255\255\255\255\255\255\255\255\255\223\000\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\057\001\255\255\255\255\255\255\
\241\000\255\255\139\001\255\255\255\255\005\001\006\001\007\001\
\008\001\009\001\255\255\108\001\255\255\013\001\014\001\112\001\
\016\001\017\001\018\001\101\001\020\001\021\001\255\255\255\255\
\255\255\255\255\108\001\027\001\028\001\000\000\255\255\255\255\
\032\001\033\001\131\001\255\255\036\001\098\001\038\001\255\255\
\255\255\041\001\139\001\255\255\255\255\255\255\255\255\129\001\
\255\255\131\001\050\001\051\001\052\001\255\255\255\255\116\001\
\255\255\057\001\058\001\059\001\060\001\061\001\062\001\063\001\
\064\001\065\001\066\001\067\001\068\001\069\001\070\001\071\001\
\072\001\073\001\074\001\075\001\076\001\077\001\078\001\079\001\
\080\001\081\001\255\255\083\001\084\001\085\001\086\001\087\001\
\088\001\089\001\090\001\091\001\092\001\093\001\094\001\095\001\
\096\001\255\255\255\255\099\001\100\001\255\255\014\001\103\001\
\104\001\105\001\018\001\255\255\108\001\255\255\022\001\255\255\
\112\001\255\255\114\001\255\255\116\001\117\001\118\001\119\001\
\120\001\121\001\122\001\123\001\036\001\125\001\126\001\127\001\
\128\001\041\001\130\001\131\001\132\001\133\001\255\255\135\001\
\121\001\255\255\255\255\014\001\052\001\255\255\255\255\018\001\
\255\255\130\001\255\255\255\255\014\001\014\001\211\001\212\001\
\018\001\018\001\019\001\140\001\022\001\022\001\255\255\255\255\
\255\255\036\001\255\255\255\255\255\255\255\255\041\001\255\255\
\255\255\255\255\035\001\036\001\255\255\255\255\255\255\041\001\
\041\001\052\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\052\001\052\001\255\255\101\001\255\255\255\255\
\255\255\255\255\255\255\255\255\108\001\255\255\255\255\255\255\
\255\255\255\255\014\001\255\255\255\255\255\255\018\001\019\001\
\255\255\255\255\022\001\255\255\255\255\255\255\255\255\255\255\
\255\255\129\001\255\255\131\001\025\002\255\255\255\255\255\255\
\029\002\014\001\101\001\016\001\017\001\041\001\255\255\255\255\
\255\255\108\001\255\255\101\001\101\001\255\255\255\255\255\255\
\052\001\255\255\108\001\108\001\255\255\255\255\255\255\036\001\
\255\255\255\255\255\255\255\255\255\255\255\255\129\001\255\255\
\131\001\255\255\255\255\255\255\255\255\255\255\255\255\129\001\
\129\001\131\001\131\001\255\255\057\001\058\001\059\001\060\001\
\061\001\062\001\063\001\064\001\065\001\066\001\067\001\068\001\
\069\001\070\001\071\001\072\001\073\001\074\001\075\001\076\001\
\077\001\078\001\079\001\255\255\255\255\255\255\255\255\255\255\
\108\001\255\255\255\255\255\255\255\255\016\001\017\001\255\255\
\255\255\255\255\255\255\255\255\255\255\098\001\099\001\100\001\
\255\255\255\255\103\001\104\001\105\001\255\255\255\255\131\001\
\255\255\255\255\255\255\255\255\255\255\114\001\255\255\116\001\
\117\001\118\001\119\001\120\001\121\001\122\001\255\255\255\255\
\255\255\126\001\127\001\128\001\255\255\255\255\057\001\058\001\
\059\001\060\001\061\001\062\001\063\001\064\001\065\001\066\001\
\067\001\068\001\069\001\070\001\071\001\072\001\073\001\074\001\
\075\001\076\001\077\001\078\001\079\001\255\255\255\255\255\255\
\005\001\006\001\007\001\008\001\009\001\255\255\255\255\255\255\
\013\001\014\001\015\001\255\255\017\001\018\001\019\001\098\001\
\099\001\255\255\255\255\255\255\103\001\104\001\027\001\028\001\
\255\255\255\255\255\255\032\001\033\001\255\255\255\255\255\255\
\255\255\038\001\255\255\255\255\041\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\050\001\051\001\052\001\
\255\255\255\255\255\255\255\255\057\001\058\001\059\001\060\001\
\061\001\062\001\063\001\064\001\065\001\066\001\067\001\068\001\
\069\001\070\001\071\001\072\001\073\001\074\001\075\001\076\001\
\077\001\078\001\079\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\093\001\094\001\095\001\096\001\255\255\255\255\099\001\255\255\
\101\001\255\255\103\001\104\001\255\255\255\255\255\255\108\001\
\255\255\255\255\005\001\006\001\007\001\008\001\009\001\255\255\
\255\255\255\255\013\001\014\001\015\001\255\255\017\001\018\001\
\019\001\255\255\255\255\255\255\129\001\255\255\131\001\132\001\
\027\001\028\001\255\255\255\255\255\255\032\001\033\001\140\001\
\255\255\255\255\255\255\038\001\255\255\255\255\041\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\050\001\
\051\001\052\001\255\255\255\255\255\255\255\255\057\001\058\001\
\059\001\060\001\061\001\062\001\063\001\064\001\065\001\066\001\
\067\001\068\001\069\001\070\001\071\001\072\001\073\001\074\001\
\075\001\076\001\077\001\078\001\079\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\093\001\094\001\095\001\096\001\255\255\255\255\
\099\001\255\255\101\001\255\255\103\001\104\001\255\255\255\255\
\255\255\108\001\255\255\255\255\005\001\006\001\007\001\008\001\
\009\001\255\255\255\255\255\255\013\001\014\001\015\001\255\255\
\017\001\018\001\019\001\255\255\255\255\255\255\129\001\255\255\
\131\001\132\001\027\001\028\001\255\255\255\255\255\255\032\001\
\033\001\140\001\255\255\255\255\255\255\038\001\255\255\255\255\
\041\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\050\001\051\001\052\001\255\255\255\255\255\255\255\255\
\057\001\058\001\059\001\060\001\061\001\062\001\063\001\064\001\
\065\001\066\001\067\001\068\001\069\001\070\001\071\001\072\001\
\073\001\074\001\075\001\076\001\077\001\078\001\079\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\093\001\094\001\095\001\096\001\
\255\255\255\255\099\001\255\255\101\001\255\255\103\001\104\001\
\255\255\255\255\255\255\108\001\255\255\255\255\005\001\006\001\
\007\001\008\001\009\001\255\255\255\255\255\255\013\001\014\001\
\015\001\255\255\017\001\018\001\019\001\255\255\255\255\255\255\
\129\001\255\255\131\001\132\001\027\001\028\001\255\255\255\255\
\255\255\032\001\033\001\140\001\255\255\255\255\255\255\038\001\
\255\255\255\255\041\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\050\001\051\001\052\001\255\255\255\255\
\255\255\255\255\057\001\058\001\059\001\060\001\061\001\062\001\
\063\001\064\001\065\001\066\001\067\001\068\001\069\001\070\001\
\071\001\072\001\073\001\074\001\075\001\076\001\077\001\078\001\
\079\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\093\001\094\001\
\095\001\096\001\255\255\255\255\099\001\255\255\101\001\255\255\
\103\001\104\001\255\255\255\255\255\255\108\001\255\255\255\255\
\005\001\006\001\007\001\008\001\009\001\255\255\255\255\255\255\
\013\001\014\001\015\001\255\255\017\001\018\001\019\001\255\255\
\255\255\255\255\129\001\255\255\131\001\132\001\027\001\028\001\
\255\255\255\255\255\255\032\001\033\001\140\001\255\255\255\255\
\255\255\038\001\255\255\255\255\041\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\050\001\051\001\052\001\
\255\255\255\255\255\255\255\255\057\001\058\001\059\001\060\001\
\061\001\062\001\063\001\064\001\065\001\066\001\067\001\068\001\
\069\001\070\001\071\001\072\001\073\001\074\001\075\001\076\001\
\077\001\078\001\079\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\093\001\094\001\095\001\096\001\255\255\255\255\099\001\255\255\
\101\001\255\255\103\001\104\001\255\255\255\255\255\255\108\001\
\255\255\255\255\005\001\006\001\007\001\008\001\009\001\255\255\
\255\255\255\255\013\001\014\001\015\001\255\255\017\001\018\001\
\255\255\255\255\255\255\255\255\129\001\255\255\131\001\132\001\
\027\001\028\001\255\255\255\255\255\255\032\001\033\001\140\001\
\255\255\255\255\255\255\038\001\255\255\255\255\041\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\050\001\
\051\001\052\001\255\255\255\255\255\255\255\255\057\001\058\001\
\059\001\060\001\061\001\062\001\063\001\064\001\065\001\066\001\
\067\001\068\001\069\001\070\001\071\001\072\001\073\001\074\001\
\075\001\076\001\077\001\078\001\079\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\093\001\094\001\095\001\096\001\255\255\255\255\
\099\001\255\255\101\001\255\255\103\001\104\001\255\255\255\255\
\255\255\108\001\255\255\255\255\005\001\006\001\007\001\008\001\
\009\001\255\255\255\255\255\255\013\001\014\001\015\001\255\255\
\017\001\018\001\255\255\255\255\255\255\255\255\129\001\255\255\
\131\001\132\001\027\001\028\001\255\255\255\255\255\255\032\001\
\033\001\140\001\255\255\255\255\255\255\038\001\255\255\255\255\
\041\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\050\001\051\001\052\001\255\255\255\255\255\255\255\255\
\057\001\058\001\059\001\060\001\061\001\062\001\063\001\064\001\
\065\001\066\001\067\001\068\001\069\001\070\001\071\001\072\001\
\073\001\074\001\075\001\076\001\077\001\078\001\079\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\093\001\094\001\095\001\096\001\
\255\255\255\255\099\001\255\255\101\001\255\255\103\001\104\001\
\255\255\255\255\255\255\108\001\255\255\255\255\005\001\006\001\
\007\001\008\001\009\001\255\255\255\255\255\255\013\001\014\001\
\255\255\016\001\017\001\018\001\255\255\020\001\255\255\255\255\
\129\001\255\255\131\001\132\001\027\001\028\001\255\255\255\255\
\255\255\032\001\033\001\140\001\255\255\036\001\255\255\038\001\
\255\255\255\255\041\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\050\001\051\001\052\001\255\255\255\255\
\255\255\255\255\057\001\058\001\059\001\060\001\061\001\062\001\
\063\001\064\001\065\001\066\001\067\001\068\001\069\001\070\001\
\071\001\072\001\073\001\074\001\075\001\076\001\077\001\078\001\
\079\001\080\001\081\001\255\255\083\001\084\001\085\001\086\001\
\087\001\088\001\089\001\090\001\091\001\092\001\093\001\094\001\
\095\001\096\001\255\255\255\255\099\001\100\001\255\255\255\255\
\103\001\104\001\105\001\255\255\255\255\108\001\109\001\110\001\
\255\255\255\255\255\255\114\001\255\255\116\001\117\001\118\001\
\119\001\120\001\121\001\122\001\123\001\255\255\255\255\126\001\
\127\001\128\001\129\001\130\001\131\001\132\001\255\255\255\255\
\135\001\005\001\006\001\007\001\008\001\009\001\255\255\255\255\
\255\255\013\001\014\001\255\255\016\001\017\001\018\001\255\255\
\020\001\255\255\255\255\255\255\255\255\255\255\255\255\027\001\
\028\001\255\255\255\255\255\255\032\001\033\001\255\255\255\255\
\036\001\255\255\038\001\255\255\255\255\041\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\050\001\051\001\
\052\001\255\255\255\255\255\255\255\255\057\001\058\001\059\001\
\060\001\061\001\062\001\063\001\064\001\065\001\066\001\067\001\
\068\001\069\001\070\001\071\001\072\001\073\001\074\001\075\001\
\076\001\077\001\078\001\079\001\080\001\081\001\255\255\083\001\
\084\001\085\001\086\001\087\001\088\001\089\001\090\001\091\001\
\092\001\093\001\094\001\095\001\096\001\255\255\255\255\099\001\
\100\001\255\255\255\255\103\001\104\001\105\001\255\255\255\255\
\108\001\255\255\110\001\255\255\255\255\255\255\114\001\255\255\
\116\001\117\001\118\001\119\001\120\001\121\001\122\001\123\001\
\255\255\255\255\126\001\127\001\128\001\129\001\130\001\131\001\
\132\001\255\255\255\255\135\001\005\001\006\001\007\001\008\001\
\009\001\255\255\255\255\255\255\013\001\014\001\255\255\016\001\
\017\001\018\001\255\255\020\001\255\255\255\255\255\255\255\255\
\255\255\255\255\027\001\028\001\255\255\255\255\255\255\032\001\
\033\001\255\255\255\255\036\001\255\255\038\001\255\255\255\255\
\041\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\050\001\051\001\052\001\255\255\255\255\255\255\255\255\
\057\001\058\001\059\001\060\001\061\001\062\001\063\001\064\001\
\065\001\066\001\067\001\068\001\069\001\070\001\071\001\072\001\
\073\001\074\001\075\001\076\001\077\001\078\001\079\001\080\001\
\081\001\255\255\083\001\084\001\085\001\086\001\087\001\088\001\
\089\001\090\001\091\001\092\001\093\001\094\001\095\001\096\001\
\255\255\255\255\099\001\100\001\255\255\255\255\103\001\104\001\
\105\001\255\255\255\255\108\001\255\255\255\255\255\255\112\001\
\255\255\114\001\255\255\116\001\117\001\118\001\119\001\120\001\
\121\001\122\001\123\001\255\255\255\255\126\001\127\001\128\001\
\255\255\130\001\131\001\132\001\133\001\255\255\135\001\005\001\
\006\001\007\001\008\001\009\001\255\255\255\255\255\255\013\001\
\014\001\255\255\016\001\017\001\018\001\255\255\020\001\255\255\
\255\255\255\255\255\255\255\255\255\255\027\001\028\001\255\255\
\255\255\255\255\032\001\033\001\255\255\255\255\036\001\255\255\
\038\001\255\255\255\255\041\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\050\001\051\001\052\001\255\255\
\255\255\255\255\255\255\057\001\058\001\059\001\060\001\061\001\
\062\001\063\001\064\001\065\001\066\001\067\001\068\001\069\001\
\070\001\071\001\072\001\073\001\074\001\075\001\076\001\077\001\
\078\001\079\001\080\001\081\001\255\255\083\001\084\001\085\001\
\086\001\087\001\088\001\089\001\090\001\091\001\092\001\093\001\
\094\001\095\001\096\001\255\255\255\255\099\001\100\001\255\255\
\255\255\103\001\104\001\105\001\255\255\255\255\108\001\255\255\
\255\255\255\255\112\001\255\255\114\001\255\255\116\001\117\001\
\118\001\119\001\120\001\121\001\122\001\123\001\255\255\255\255\
\126\001\127\001\128\001\255\255\130\001\131\001\132\001\133\001\
\255\255\135\001\005\001\006\001\007\001\008\001\009\001\255\255\
\255\255\255\255\013\001\014\001\255\255\016\001\017\001\018\001\
\255\255\020\001\255\255\255\255\255\255\255\255\255\255\255\255\
\027\001\028\001\255\255\255\255\255\255\032\001\033\001\255\255\
\255\255\036\001\255\255\038\001\255\255\255\255\041\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\050\001\
\051\001\052\001\255\255\255\255\255\255\255\255\057\001\058\001\
\059\001\060\001\061\001\062\001\063\001\064\001\065\001\066\001\
\067\001\068\001\069\001\070\001\071\001\072\001\073\001\074\001\
\075\001\076\001\077\001\078\001\079\001\080\001\081\001\255\255\
\083\001\084\001\085\001\086\001\087\001\088\001\089\001\090\001\
\091\001\092\001\093\001\094\001\095\001\096\001\255\255\255\255\
\099\001\100\001\255\255\255\255\103\001\104\001\105\001\255\255\
\255\255\108\001\255\255\255\255\255\255\112\001\255\255\114\001\
\255\255\116\001\117\001\118\001\119\001\120\001\121\001\122\001\
\123\001\255\255\255\255\126\001\127\001\128\001\255\255\130\001\
\131\001\132\001\133\001\255\255\135\001\005\001\006\001\007\001\
\008\001\009\001\255\255\255\255\255\255\013\001\014\001\255\255\
\016\001\017\001\018\001\255\255\020\001\255\255\255\255\255\255\
\255\255\255\255\255\255\027\001\028\001\255\255\255\255\255\255\
\032\001\033\001\255\255\255\255\036\001\255\255\038\001\255\255\
\255\255\041\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\050\001\051\001\052\001\255\255\255\255\255\255\
\255\255\057\001\058\001\059\001\060\001\061\001\062\001\063\001\
\064\001\065\001\066\001\067\001\068\001\069\001\070\001\071\001\
\072\001\073\001\074\001\075\001\076\001\077\001\078\001\079\001\
\080\001\081\001\255\255\083\001\084\001\085\001\086\001\087\001\
\088\001\089\001\090\001\091\001\092\001\093\001\094\001\095\001\
\096\001\255\255\255\255\099\001\100\001\255\255\255\255\103\001\
\104\001\105\001\255\255\255\255\108\001\255\255\255\255\255\255\
\255\255\255\255\114\001\255\255\116\001\117\001\118\001\119\001\
\120\001\121\001\122\001\123\001\255\255\255\255\126\001\127\001\
\128\001\255\255\130\001\131\001\132\001\255\255\255\255\135\001\
\005\001\006\001\007\001\008\001\009\001\255\255\255\255\255\255\
\013\001\014\001\255\255\255\255\017\001\018\001\255\255\020\001\
\255\255\255\255\255\255\255\255\255\255\255\255\027\001\028\001\
\255\255\255\255\255\255\032\001\033\001\255\255\255\255\036\001\
\255\255\038\001\255\255\255\255\041\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\050\001\051\001\052\001\
\255\255\255\255\255\255\255\255\057\001\058\001\059\001\060\001\
\061\001\062\001\063\001\064\001\065\001\066\001\067\001\068\001\
\069\001\070\001\071\001\072\001\073\001\074\001\075\001\076\001\
\077\001\078\001\079\001\080\001\081\001\255\255\083\001\084\001\
\085\001\086\001\087\001\088\001\089\001\090\001\091\001\092\001\
\093\001\094\001\095\001\096\001\255\255\255\255\099\001\100\001\
\255\255\255\255\103\001\104\001\255\255\255\255\255\255\108\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\123\001\255\255\
\005\001\006\001\007\001\008\001\009\001\130\001\131\001\132\001\
\013\001\014\001\135\001\255\255\017\001\018\001\014\001\020\001\
\255\255\255\255\018\001\255\255\255\255\255\255\027\001\028\001\
\255\255\255\255\255\255\032\001\033\001\255\255\255\255\036\001\
\255\255\038\001\255\255\255\255\041\001\255\255\255\255\255\255\
\255\255\041\001\255\255\255\255\255\255\050\001\051\001\052\001\
\255\255\255\255\255\255\255\255\052\001\038\001\039\001\040\001\
\041\001\042\001\043\001\044\001\045\001\046\001\047\001\048\001\
\049\001\050\001\051\001\052\001\053\001\054\001\055\001\056\001\
\255\255\255\255\255\255\080\001\081\001\255\255\083\001\084\001\
\085\001\086\001\087\001\088\001\089\001\090\001\091\001\092\001\
\093\001\094\001\095\001\096\001\255\255\255\255\255\255\100\001\
\255\255\255\255\255\255\255\255\255\255\101\001\255\255\108\001\
\255\255\255\255\255\255\255\255\108\001\255\255\255\255\005\001\
\006\001\007\001\008\001\009\001\255\255\255\255\123\001\013\001\
\014\001\255\255\255\255\017\001\018\001\130\001\131\001\132\001\
\255\255\129\001\135\001\131\001\255\255\027\001\028\001\255\255\
\255\255\255\255\032\001\033\001\255\255\255\255\036\001\255\255\
\038\001\255\255\255\255\041\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\050\001\051\001\052\001\255\255\
\255\255\255\255\255\255\057\001\058\001\059\001\060\001\061\001\
\062\001\063\001\064\001\065\001\066\001\067\001\068\001\069\001\
\070\001\071\001\072\001\073\001\074\001\075\001\076\001\077\001\
\078\001\079\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\093\001\
\094\001\095\001\096\001\255\255\255\255\099\001\255\255\255\255\
\255\255\103\001\104\001\255\255\255\255\255\255\108\001\255\255\
\255\255\005\001\006\001\007\001\008\001\009\001\255\255\255\255\
\255\255\013\001\014\001\255\255\255\255\017\001\018\001\255\255\
\255\255\255\255\255\255\255\255\255\255\131\001\132\001\027\001\
\028\001\255\255\255\255\255\255\032\001\033\001\255\255\255\255\
\255\255\255\255\038\001\255\255\255\255\041\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\050\001\051\001\
\052\001\255\255\255\255\255\255\255\255\057\001\058\001\059\001\
\060\001\061\001\062\001\063\001\064\001\065\001\066\001\067\001\
\068\001\255\255\255\255\255\255\255\255\255\255\074\001\075\001\
\076\001\077\001\078\001\079\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\093\001\094\001\095\001\096\001\255\255\255\255\099\001\
\255\255\255\255\255\255\255\255\104\001\255\255\255\255\255\255\
\108\001\255\255\255\255\005\001\006\001\007\001\008\001\009\001\
\255\255\255\255\255\255\013\001\014\001\255\255\255\255\017\001\
\018\001\255\255\020\001\021\001\022\001\255\255\024\001\131\001\
\132\001\027\001\028\001\255\255\255\255\255\255\032\001\033\001\
\255\255\255\255\255\255\255\255\038\001\255\255\255\255\041\001\
\255\255\255\255\255\255\005\001\006\001\007\001\008\001\009\001\
\050\001\051\001\052\001\013\001\014\001\255\255\255\255\017\001\
\018\001\255\255\020\001\021\001\022\001\255\255\024\001\255\255\
\255\255\027\001\028\001\255\255\255\255\255\255\032\001\033\001\
\255\255\255\255\255\255\255\255\038\001\255\255\255\255\041\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\050\001\051\001\052\001\093\001\094\001\095\001\096\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\108\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\131\001\132\001\093\001\094\001\095\001\096\001\005\001\
\006\001\007\001\008\001\009\001\255\255\255\255\255\255\013\001\
\014\001\255\255\108\001\017\001\018\001\255\255\020\001\255\255\
\022\001\255\255\024\001\255\255\255\255\027\001\028\001\255\255\
\255\255\255\255\032\001\033\001\255\255\255\255\255\255\255\255\
\038\001\131\001\132\001\041\001\255\255\255\255\255\255\005\001\
\006\001\007\001\008\001\009\001\050\001\051\001\052\001\013\001\
\014\001\255\255\255\255\255\255\018\001\255\255\020\001\255\255\
\255\255\255\255\255\255\255\255\255\255\027\001\028\001\255\255\
\255\255\255\255\032\001\033\001\255\255\255\255\255\255\255\255\
\038\001\255\255\255\255\041\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\050\001\051\001\052\001\093\001\
\094\001\095\001\096\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\108\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\131\001\132\001\093\001\
\094\001\095\001\096\001\005\001\006\001\007\001\008\001\009\001\
\255\255\255\255\255\255\013\001\014\001\255\255\108\001\255\255\
\018\001\255\255\255\255\255\255\255\255\023\001\255\255\255\255\
\255\255\027\001\028\001\255\255\255\255\255\255\032\001\033\001\
\255\255\255\255\255\255\255\255\038\001\131\001\132\001\041\001\
\255\255\255\255\255\255\005\001\006\001\007\001\008\001\009\001\
\050\001\051\001\052\001\013\001\014\001\255\255\255\255\255\255\
\018\001\255\255\255\255\255\255\255\255\023\001\255\255\255\255\
\255\255\027\001\028\001\255\255\255\255\255\255\032\001\033\001\
\255\255\255\255\255\255\255\255\038\001\255\255\255\255\041\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\050\001\051\001\052\001\093\001\094\001\095\001\096\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\108\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\131\001\132\001\093\001\094\001\095\001\096\001\005\001\
\006\001\007\001\008\001\009\001\255\255\255\255\255\255\013\001\
\014\001\255\255\108\001\255\255\018\001\255\255\020\001\255\255\
\255\255\255\255\255\255\255\255\255\255\027\001\028\001\255\255\
\255\255\255\255\032\001\033\001\255\255\255\255\255\255\255\255\
\038\001\131\001\132\001\041\001\255\255\255\255\255\255\005\001\
\006\001\007\001\008\001\009\001\050\001\051\001\052\001\013\001\
\014\001\255\255\255\255\255\255\018\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\027\001\028\001\255\255\
\255\255\255\255\032\001\033\001\255\255\255\255\036\001\255\255\
\038\001\255\255\255\255\041\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\050\001\051\001\052\001\093\001\
\094\001\095\001\096\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\108\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\131\001\132\001\093\001\
\094\001\095\001\096\001\005\001\006\001\007\001\008\001\009\001\
\255\255\255\255\255\255\013\001\014\001\255\255\108\001\255\255\
\018\001\255\255\020\001\255\255\255\255\255\255\255\255\255\255\
\255\255\027\001\028\001\255\255\255\255\255\255\032\001\033\001\
\255\255\255\255\255\255\255\255\038\001\131\001\132\001\041\001\
\255\255\255\255\255\255\005\001\006\001\007\001\008\001\009\001\
\050\001\051\001\052\001\013\001\014\001\255\255\255\255\255\255\
\018\001\255\255\255\255\255\255\255\255\023\001\255\255\255\255\
\255\255\027\001\028\001\255\255\255\255\255\255\032\001\033\001\
\255\255\255\255\255\255\255\255\038\001\255\255\255\255\041\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\050\001\051\001\052\001\093\001\094\001\095\001\096\001\255\255\
\255\255\014\001\255\255\255\255\255\255\018\001\019\001\255\255\
\255\255\022\001\108\001\255\255\025\001\255\255\255\255\255\255\
\255\255\255\255\005\001\006\001\007\001\008\001\009\001\036\001\
\255\255\255\255\013\001\014\001\041\001\255\255\255\255\018\001\
\019\001\131\001\132\001\093\001\094\001\095\001\096\001\052\001\
\027\001\028\001\255\255\255\255\255\255\032\001\033\001\255\255\
\255\255\255\255\108\001\038\001\255\255\255\255\041\001\255\255\
\255\255\255\255\005\001\006\001\007\001\008\001\009\001\050\001\
\051\001\052\001\013\001\014\001\255\255\255\255\255\255\018\001\
\019\001\131\001\132\001\255\255\255\255\255\255\255\255\255\255\
\027\001\028\001\255\255\255\255\255\255\032\001\033\001\255\255\
\101\001\255\255\255\255\038\001\255\255\255\255\041\001\108\001\
\255\255\255\255\255\255\112\001\255\255\255\255\255\255\050\001\
\051\001\052\001\093\001\094\001\095\001\096\001\255\255\255\255\
\255\255\255\255\255\255\255\255\129\001\255\255\131\001\255\255\
\255\255\108\001\255\255\255\255\255\255\255\255\139\001\255\255\
\255\255\005\001\006\001\007\001\008\001\009\001\255\255\255\255\
\255\255\013\001\014\001\255\255\255\255\255\255\018\001\255\255\
\131\001\132\001\093\001\094\001\095\001\096\001\014\001\027\001\
\028\001\017\001\018\001\255\255\032\001\033\001\255\255\255\255\
\255\255\108\001\038\001\255\255\255\255\041\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\050\001\051\001\
\052\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\131\001\132\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\057\001\058\001\059\001\060\001\061\001\062\001\063\001\
\064\001\065\001\066\001\067\001\068\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\076\001\077\001\078\001\079\001\
\255\255\093\001\094\001\095\001\096\001\255\255\014\001\015\001\
\255\255\017\001\018\001\019\001\020\001\255\255\022\001\255\255\
\108\001\025\001\255\255\255\255\255\255\255\255\030\001\255\255\
\104\001\255\255\255\255\035\001\036\001\255\255\255\255\255\255\
\255\255\041\001\255\255\255\255\255\255\255\255\255\255\131\001\
\132\001\255\255\255\255\255\255\052\001\255\255\255\255\255\255\
\255\255\057\001\058\001\059\001\060\001\061\001\062\001\063\001\
\064\001\065\001\066\001\067\001\068\001\069\001\070\001\071\001\
\072\001\073\001\074\001\075\001\076\001\077\001\078\001\079\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\097\001\255\255\099\001\255\255\255\255\255\255\103\001\
\104\001\105\001\255\255\014\001\108\001\255\255\017\001\018\001\
\019\001\255\255\114\001\022\001\255\255\255\255\025\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\126\001\127\001\
\128\001\036\001\255\255\131\001\255\255\133\001\041\001\255\255\
\255\255\255\255\255\255\139\001\255\255\255\255\255\255\255\255\
\255\255\052\001\255\255\255\255\255\255\255\255\057\001\058\001\
\059\001\060\001\061\001\062\001\063\001\064\001\065\001\066\001\
\067\001\068\001\069\001\070\001\071\001\072\001\073\001\074\001\
\075\001\076\001\077\001\078\001\079\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\099\001\255\255\101\001\255\255\103\001\104\001\255\255\014\001\
\255\255\108\001\017\001\018\001\019\001\112\001\255\255\022\001\
\255\255\255\255\025\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\036\001\129\001\255\255\
\131\001\255\255\041\001\255\255\255\255\255\255\255\255\255\255\
\139\001\255\255\255\255\255\255\255\255\052\001\255\255\255\255\
\255\255\255\255\057\001\058\001\059\001\060\001\061\001\062\001\
\063\001\064\001\065\001\066\001\067\001\068\001\069\001\070\001\
\071\001\072\001\073\001\074\001\075\001\076\001\077\001\078\001\
\079\001\014\001\255\255\255\255\255\255\018\001\019\001\255\255\
\255\255\022\001\014\001\255\255\025\001\255\255\018\001\019\001\
\255\255\255\255\022\001\255\255\099\001\025\001\101\001\036\001\
\103\001\104\001\255\255\255\255\041\001\108\001\255\255\255\255\
\036\001\112\001\255\255\255\255\014\001\041\001\255\255\052\001\
\018\001\019\001\255\255\255\255\022\001\255\255\255\255\025\001\
\052\001\255\255\129\001\255\255\131\001\255\255\255\255\255\255\
\255\255\255\255\036\001\255\255\139\001\255\255\255\255\041\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\052\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\101\001\255\255\255\255\255\255\255\255\255\255\255\255\108\001\
\255\255\101\001\255\255\112\001\255\255\255\255\255\255\255\255\
\108\001\255\255\255\255\255\255\112\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\129\001\255\255\131\001\255\255\
\255\255\255\255\255\255\101\001\255\255\129\001\139\001\131\001\
\255\255\017\001\108\001\019\001\020\001\255\255\112\001\139\001\
\255\255\025\001\255\255\255\255\255\255\255\255\030\001\255\255\
\255\255\255\255\255\255\035\001\036\001\255\255\255\255\129\001\
\255\255\131\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\139\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\057\001\058\001\059\001\060\001\061\001\062\001\063\001\
\064\001\065\001\066\001\067\001\068\001\069\001\070\001\071\001\
\072\001\073\001\074\001\075\001\076\001\077\001\078\001\079\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\097\001\255\255\099\001\100\001\101\001\255\255\103\001\
\104\001\105\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\114\001\255\255\255\255\017\001\255\255\019\001\
\020\001\255\255\255\255\255\255\255\255\025\001\126\001\127\001\
\128\001\129\001\030\001\255\255\255\255\133\001\255\255\035\001\
\036\001\255\255\255\255\139\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\057\001\058\001\059\001\
\060\001\061\001\062\001\063\001\064\001\065\001\066\001\067\001\
\068\001\069\001\070\001\071\001\072\001\073\001\074\001\075\001\
\076\001\077\001\078\001\079\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\097\001\255\255\099\001\
\100\001\101\001\255\255\103\001\104\001\105\001\255\255\255\255\
\014\001\255\255\255\255\017\001\018\001\255\255\114\001\255\255\
\022\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\126\001\127\001\128\001\129\001\036\001\255\255\
\255\255\133\001\255\255\041\001\255\255\255\255\255\255\139\001\
\255\255\255\255\255\255\255\255\255\255\255\255\052\001\255\255\
\255\255\255\255\255\255\057\001\058\001\059\001\060\001\061\001\
\062\001\063\001\064\001\065\001\066\001\067\001\068\001\069\001\
\070\001\071\001\072\001\073\001\074\001\075\001\076\001\077\001\
\078\001\079\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\014\001\255\255\255\255\017\001\018\001\099\001\255\255\101\001\
\022\001\103\001\104\001\255\255\255\255\255\255\108\001\255\255\
\255\255\255\255\112\001\255\255\255\255\035\001\036\001\255\255\
\255\255\255\255\255\255\041\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\129\001\255\255\131\001\052\001\133\001\
\255\255\255\255\136\001\057\001\058\001\059\001\060\001\061\001\
\062\001\063\001\064\001\065\001\066\001\067\001\068\001\069\001\
\070\001\071\001\072\001\073\001\074\001\075\001\076\001\077\001\
\078\001\079\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\017\001\255\255\
\255\255\020\001\255\255\255\255\255\255\099\001\025\001\101\001\
\255\255\103\001\104\001\030\001\255\255\255\255\108\001\255\255\
\255\255\036\001\112\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\129\001\255\255\131\001\057\001\058\001\
\059\001\060\001\061\001\062\001\063\001\064\001\065\001\066\001\
\067\001\068\001\069\001\070\001\071\001\072\001\073\001\074\001\
\075\001\076\001\077\001\078\001\079\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\097\001\017\001\
\099\001\255\255\020\001\255\255\103\001\104\001\105\001\025\001\
\255\255\255\255\255\255\255\255\030\001\255\255\255\255\114\001\
\255\255\255\255\036\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\126\001\127\001\128\001\255\255\255\255\
\255\255\255\255\133\001\255\255\255\255\255\255\255\255\057\001\
\058\001\059\001\060\001\061\001\062\001\063\001\064\001\065\001\
\066\001\067\001\068\001\069\001\070\001\071\001\072\001\073\001\
\074\001\075\001\076\001\077\001\078\001\079\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\097\001\
\017\001\099\001\255\255\020\001\255\255\103\001\104\001\105\001\
\025\001\255\255\255\255\255\255\255\255\030\001\255\255\255\255\
\114\001\255\255\255\255\036\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\126\001\127\001\128\001\255\255\
\255\255\255\255\255\255\133\001\255\255\255\255\255\255\255\255\
\057\001\058\001\059\001\060\001\061\001\062\001\063\001\064\001\
\065\001\066\001\067\001\068\001\069\001\070\001\071\001\072\001\
\073\001\074\001\075\001\076\001\077\001\078\001\079\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\014\001\255\255\255\255\017\001\255\255\255\255\
\097\001\255\255\099\001\255\255\255\255\255\255\103\001\104\001\
\105\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\036\001\114\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\126\001\127\001\128\001\
\255\255\255\255\255\255\255\255\133\001\057\001\058\001\059\001\
\060\001\061\001\062\001\063\001\064\001\065\001\066\001\067\001\
\068\001\255\255\255\255\255\255\255\255\255\255\074\001\075\001\
\076\001\077\001\078\001\079\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\015\001\255\255\017\001\255\255\019\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\099\001\
\255\255\255\255\255\255\255\255\104\001\105\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\114\001\255\255\
\116\001\117\001\118\001\119\001\120\001\121\001\122\001\255\255\
\255\255\255\255\126\001\127\001\128\001\057\001\058\001\059\001\
\060\001\061\001\062\001\063\001\064\001\065\001\066\001\067\001\
\068\001\069\001\070\001\071\001\072\001\073\001\074\001\075\001\
\076\001\077\001\078\001\079\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\015\001\255\255\017\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\099\001\
\255\255\101\001\255\255\103\001\104\001\255\255\255\255\034\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\129\001\057\001\058\001\
\059\001\060\001\061\001\062\001\063\001\064\001\065\001\066\001\
\067\001\068\001\069\001\070\001\071\001\072\001\073\001\074\001\
\075\001\076\001\077\001\078\001\079\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\015\001\255\255\017\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\099\001\255\255\101\001\255\255\103\001\104\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\129\001\057\001\
\058\001\059\001\060\001\061\001\062\001\063\001\064\001\065\001\
\066\001\067\001\068\001\069\001\070\001\071\001\072\001\073\001\
\074\001\075\001\076\001\077\001\078\001\079\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\015\001\255\255\
\017\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\099\001\255\255\101\001\255\255\103\001\104\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\129\001\
\057\001\058\001\059\001\060\001\061\001\062\001\063\001\064\001\
\065\001\066\001\067\001\068\001\069\001\070\001\071\001\072\001\
\073\001\074\001\075\001\076\001\077\001\078\001\079\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\017\001\255\255\255\255\020\001\255\255\255\255\255\255\
\255\255\255\255\099\001\255\255\101\001\255\255\103\001\104\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\129\001\057\001\058\001\059\001\060\001\061\001\062\001\063\001\
\064\001\065\001\066\001\067\001\068\001\069\001\070\001\071\001\
\072\001\073\001\074\001\075\001\076\001\077\001\078\001\079\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\099\001\255\255\255\255\255\255\103\001\
\104\001\105\001\255\255\255\255\255\255\255\255\255\255\255\255\
\018\001\255\255\114\001\255\255\022\001\255\255\024\001\025\001\
\026\001\027\001\028\001\029\001\030\001\031\001\126\001\127\001\
\128\001\035\001\036\001\037\001\038\001\039\001\040\001\041\001\
\042\001\043\001\044\001\045\001\046\001\047\001\048\001\049\001\
\050\001\051\001\052\001\053\001\054\001\055\001\056\001\018\001\
\255\255\255\255\255\255\022\001\255\255\024\001\025\001\026\001\
\027\001\028\001\029\001\030\001\031\001\255\255\255\255\255\255\
\035\001\036\001\037\001\038\001\039\001\040\001\041\001\042\001\
\043\001\044\001\045\001\046\001\047\001\048\001\049\001\050\001\
\051\001\052\001\053\001\054\001\055\001\056\001\014\001\255\255\
\255\255\017\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\112\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\015\001\255\255\
\017\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\057\001\058\001\059\001\060\001\061\001\062\001\063\001\
\064\001\065\001\066\001\067\001\068\001\112\001\255\255\255\255\
\255\255\255\255\255\255\255\255\076\001\077\001\078\001\079\001\
\057\001\058\001\059\001\060\001\061\001\062\001\063\001\064\001\
\065\001\066\001\067\001\068\001\069\001\070\001\071\001\072\001\
\073\001\074\001\075\001\076\001\077\001\078\001\079\001\255\255\
\104\001\016\001\017\001\255\255\255\255\255\255\021\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\099\001\255\255\255\255\255\255\103\001\104\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\057\001\058\001\059\001\060\001\061\001\062\001\
\063\001\064\001\065\001\066\001\067\001\068\001\069\001\070\001\
\071\001\072\001\073\001\074\001\075\001\076\001\077\001\078\001\
\079\001\016\001\017\001\255\255\255\255\255\255\021\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\098\001\099\001\255\255\255\255\255\255\
\103\001\104\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\057\001\058\001\059\001\060\001\061\001\062\001\
\063\001\064\001\065\001\066\001\067\001\068\001\069\001\070\001\
\071\001\072\001\073\001\074\001\075\001\076\001\077\001\078\001\
\079\001\017\001\255\255\255\255\020\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\098\001\099\001\255\255\255\255\255\255\
\103\001\104\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\057\001\058\001\059\001\060\001\061\001\062\001\063\001\
\064\001\065\001\066\001\067\001\068\001\069\001\070\001\071\001\
\072\001\073\001\074\001\075\001\076\001\077\001\078\001\079\001\
\017\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\099\001\255\255\255\255\255\255\103\001\
\104\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\057\001\058\001\059\001\060\001\061\001\062\001\063\001\064\001\
\065\001\066\001\067\001\068\001\069\001\070\001\071\001\072\001\
\073\001\074\001\075\001\076\001\077\001\078\001\079\001\017\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\099\001\255\255\255\255\255\255\103\001\104\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\057\001\
\058\001\059\001\060\001\061\001\062\001\063\001\064\001\065\001\
\066\001\067\001\068\001\017\001\255\255\255\255\255\255\255\255\
\074\001\075\001\076\001\077\001\078\001\079\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\099\001\255\255\255\255\255\255\255\255\104\001\255\255\
\255\255\255\255\255\255\057\001\058\001\059\001\060\001\061\001\
\062\001\063\001\064\001\065\001\066\001\067\001\068\001\255\255\
\255\255\255\255\255\255\255\255\074\001\075\001\076\001\077\001\
\078\001\079\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\005\001\
\006\001\007\001\008\001\255\255\255\255\099\001\255\255\255\255\
\014\001\255\255\104\001\017\001\018\001\019\001\020\001\021\001\
\255\255\255\255\255\255\025\001\255\255\027\001\028\001\029\001\
\030\001\031\001\255\255\033\001\255\255\035\001\036\001\037\001\
\038\001\039\001\040\001\041\001\042\001\043\001\044\001\045\001\
\046\001\047\001\048\001\049\001\050\001\051\001\052\001\053\001\
\054\001\055\001\056\001\255\255\255\255\255\255\255\255\005\001\
\006\001\007\001\008\001\255\255\255\255\255\255\255\255\255\255\
\014\001\255\255\255\255\017\001\018\001\019\001\020\001\021\001\
\255\255\255\255\255\255\025\001\082\001\027\001\028\001\029\001\
\030\001\031\001\088\001\033\001\255\255\035\001\036\001\037\001\
\038\001\039\001\040\001\041\001\042\001\043\001\044\001\045\001\
\046\001\047\001\048\001\049\001\050\001\051\001\052\001\053\001\
\054\001\055\001\056\001\255\255\255\255\255\255\255\255\005\001\
\006\001\007\001\008\001\255\255\255\255\255\255\255\255\255\255\
\014\001\255\255\255\255\017\001\018\001\019\001\020\001\021\001\
\255\255\255\255\255\255\025\001\082\001\027\001\028\001\029\001\
\030\001\031\001\088\001\033\001\255\255\035\001\255\255\037\001\
\038\001\039\001\040\001\041\001\042\001\043\001\044\001\045\001\
\046\001\047\001\048\001\049\001\050\001\051\001\052\001\053\001\
\054\001\055\001\056\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\018\001\255\255\255\255\021\001\022\001\255\255\024\001\025\001\
\026\001\027\001\028\001\255\255\082\001\031\001\255\255\255\255\
\255\255\035\001\088\001\037\001\038\001\039\001\040\001\041\001\
\042\001\043\001\044\001\045\001\046\001\047\001\048\001\049\001\
\050\001\051\001\052\001\053\001\054\001\055\001\056\001"

let yynames_const = "\
  "

let yynames_block = "\
  TUnknown\000\
  TCommentSpace\000\
  TCommentNewline\000\
  TComment\000\
  TInt\000\
  TFloat\000\
  TChar\000\
  TString\000\
  TQuote\000\
  TPct\000\
  TFormat\000\
  TSubString\000\
  TDecimal\000\
  TIdent\000\
  TKRParam\000\
  Tconstructorname\000\
  TypedefIdent\000\
  TOPar\000\
  TCPar\000\
  TOBrace\000\
  TCBrace\000\
  TOCro\000\
  TCCro\000\
  TDot\000\
  TComma\000\
  TPtrOp\000\
  TInc\000\
  TDec\000\
  TAssign\000\
  TEq\000\
  TWhy\000\
  TTilde\000\
  TBang\000\
  TEllipsis\000\
  TDotDot\000\
  TPtVirg\000\
  TOrLog\000\
  TAndLog\000\
  TOr\000\
  TXor\000\
  TAnd\000\
  TEqEq\000\
  TNotEq\000\
  TInf\000\
  TSup\000\
  TInfEq\000\
  TSupEq\000\
  TShl\000\
  TShr\000\
  TPlus\000\
  TMinus\000\
  TMul\000\
  TDiv\000\
  TMod\000\
  TMax\000\
  TMin\000\
  Tchar\000\
  Tshort\000\
  Tint\000\
  Tdouble\000\
  Tfloat\000\
  Tlong\000\
  Tunsigned\000\
  Tsigned\000\
  Tvoid\000\
  Tsize_t\000\
  Tssize_t\000\
  Tptrdiff_t\000\
  Tauto\000\
  Tregister\000\
  Textern\000\
  Tstatic\000\
  Ttypedef\000\
  Tconst\000\
  Tvolatile\000\
  Tstruct\000\
  Tunion\000\
  Tenum\000\
  Tdecimal\000\
  Texec\000\
  Tbreak\000\
  Telse\000\
  Tswitch\000\
  Tcase\000\
  Tcontinue\000\
  Tfor\000\
  Tdo\000\
  Tif\000\
  Twhile\000\
  Treturn\000\
  Tgoto\000\
  Tdefault\000\
  Tsizeof\000\
  Tnew\000\
  Tdelete\000\
  Tdefined\000\
  TOParCplusplusInit\000\
  Tnamespace\000\
  Trestrict\000\
  Tasm\000\
  Tattribute\000\
  TattributeNoarg\000\
  Tinline\000\
  Ttypeof\000\
  TDefine\000\
  TDefParamVariadic\000\
  TCppEscapedNewline\000\
  TCppConcatOp\000\
  TOParDefine\000\
  TOBraceDefineInit\000\
  TIdentDefine\000\
  TDefEOL\000\
  TInclude\000\
  TIncludeStart\000\
  TIncludeFilename\000\
  TIfdef\000\
  TIfdefelif\000\
  TIfdefelse\000\
  TEndif\000\
  TIfdefBool\000\
  TIfdefMisc\000\
  TIfdefVersion\000\
  TUifdef\000\
  TUelseif\000\
  TUendif\000\
  TUndef\000\
  TPragma\000\
  TCppDirectiveOther\000\
  TMacroAttr\000\
  TMacroStmt\000\
  TMacroIdentBuilder\000\
  TMacroString\000\
  TMacroDecl\000\
  TMacroDeclConst\000\
  TMacroIterator\000\
  TMacroAttrStorage\000\
  TCommentSkipTagStart\000\
  TCommentSkipTagEnd\000\
  TCParEOL\000\
  TAction\000\
  TCommentMisc\000\
  TCommentCpp\000\
  EOF\000\
  "

let yyact = [|
  (fun _ -> failwith "parser")
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'translation_unit) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 663 "parser_c.mly"
                          ( _1 )
# 3312 "parser_c.ml"
               : Ast_c.program))
; (fun __caml_parser_env ->
    Obj.repr(
# 667 "parser_c.mly"
     ( [] )
# 3318 "parser_c.ml"
               : 'translation_unit))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'translation_unit) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'external_declaration) in
    Obj.repr(
# 669 "parser_c.mly"
     ( !LP._lexer_hint.context_stack <- [LP.InTopLevel]; _1 @ [_2] )
# 3326 "parser_c.ml"
               : 'translation_unit))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : 'translation_unit) in
    let _2 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : string * Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : 'translation_unit) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 671 "parser_c.mly"
     ( !LP._lexer_hint.context_stack <- [LP.InTopLevel];
       _1 @ [Namespace (_5, [_2; snd _3; _4; _6])] )
# 3339 "parser_c.ml"
               : 'translation_unit))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 684 "parser_c.mly"
                ( _1 )
# 3346 "parser_c.ml"
               : 'ident))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 685 "parser_c.mly"
                ( _1 )
# 3353 "parser_c.ml"
               : 'ident))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 689 "parser_c.mly"
                ( _1 )
# 3360 "parser_c.ml"
               : 'identifier))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 698 "parser_c.mly"
     ( RegularName (mk_string_wrap _1) )
# 3367 "parser_c.ml"
               : 'identifier_cpp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'ident_extra_cpp) in
    Obj.repr(
# 699 "parser_c.mly"
                   ( _1 )
# 3374 "parser_c.ml"
               : 'identifier_cpp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 703 "parser_c.mly"
     ( RegularName (mk_string_wrap _1) )
# 3381 "parser_c.ml"
               : 'ident_cpp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 705 "parser_c.mly"
     ( RegularName (mk_string_wrap _1) )
# 3388 "parser_c.ml"
               : 'ident_cpp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'ident_extra_cpp) in
    Obj.repr(
# 706 "parser_c.mly"
                   ( _1 )
# 3395 "parser_c.ml"
               : 'ident_cpp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : string * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'identifier_cpp_list) in
    Obj.repr(
# 710 "parser_c.mly"
     (
       CppConcatenatedName (
         match _3 with
         | [] -> raise (Impossible 87)
         | (x,concatnull)::xs ->
             assert (concatnull = []);
             (mk_string_wrap _1, [])::(x,[_2])::xs
       )
   )
# 3412 "parser_c.ml"
               : 'ident_extra_cpp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 720 "parser_c.mly"
     ( CppVariadicName (fst _2, [_1; snd _2]) )
# 3420 "parser_c.ml"
               : 'ident_extra_cpp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : (string * Ast_c.info)) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'param_define_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 722 "parser_c.mly"
     ( CppIdentBuilder ((fst _1, [snd _1;_2;_4]), _3) )
# 3430 "parser_c.ml"
               : 'ident_extra_cpp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 725 "parser_c.mly"
          ( [mk_string_wrap _1, []] )
# 3437 "parser_c.ml"
               : 'identifier_cpp_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'identifier_cpp_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 726 "parser_c.mly"
                                           ( _1 @ [mk_string_wrap _3, [_2]] )
# 3446 "parser_c.ml"
               : 'identifier_cpp_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'assign_expr) in
    Obj.repr(
# 733 "parser_c.mly"
                           ( _1 )
# 3453 "parser_c.ml"
               : Ast_c.expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.expression) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'assign_expr) in
    Obj.repr(
# 734 "parser_c.mly"
                           ( mk_e (Sequence (_1,_3)) [_2] )
# 3462 "parser_c.ml"
               : Ast_c.expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cond_expr) in
    Obj.repr(
# 740 "parser_c.mly"
                                 ( _1 )
# 3469 "parser_c.ml"
               : 'assign_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'cast_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.assignOp) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'assign_expr) in
    Obj.repr(
# 741 "parser_c.mly"
                                 ( mk_e(Assignment (_1, _2, _3)) [])
# 3478 "parser_c.ml"
               : 'assign_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'cast_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'assign_expr) in
    Obj.repr(
# 742 "parser_c.mly"
                                 ( mk_e (Assignment (_1, (SimpleAssign, [_2]),_3)) [])
# 3487 "parser_c.ml"
               : 'assign_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 750 "parser_c.mly"
     ( _1 )
# 3494 "parser_c.ml"
               : 'cond_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'gcc_opt_expr) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'assign_expr) in
    Obj.repr(
# 752 "parser_c.mly"
     ( mk_e (CondExpr (_1,_3,_5)) [_2;_4] )
# 3505 "parser_c.ml"
               : 'cond_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cast_expr) in
    Obj.repr(
# 756 "parser_c.mly"
                                 ( _1 )
# 3512 "parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 757 "parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith Mul,[_2]), _3)) [] )
# 3521 "parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 758 "parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith Div, [_2]), _3)) [] )
# 3530 "parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 759 "parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith Min, [_2]), _3)) [] )
# 3539 "parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 760 "parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith Max, [_2]), _3)) [] )
# 3548 "parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 761 "parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith Mod, [_2]), _3)) [] )
# 3557 "parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 762 "parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith Plus, [_2]), _3)) [] )
# 3566 "parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 763 "parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith Minus, [_2]), _3)) [] )
# 3575 "parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 764 "parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith DecLeft, [_2]), _3)) [] )
# 3584 "parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 765 "parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith DecRight, [_2]), _3)) [] )
# 3593 "parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 766 "parser_c.mly"
                                 ( mk_e(Binary (_1, (Logical Inf, [_2]), _3)) [] )
# 3602 "parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 767 "parser_c.mly"
                                 ( mk_e(Binary (_1, (Logical Sup, [_2]), _3)) [] )
# 3611 "parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 768 "parser_c.mly"
                                 ( mk_e(Binary (_1, (Logical InfEq, [_2]), _3)) [] )
# 3620 "parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 769 "parser_c.mly"
                                 ( mk_e(Binary (_1, (Logical SupEq, [_2]), _3)) [] )
# 3629 "parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 770 "parser_c.mly"
                                 ( mk_e(Binary (_1, (Logical Eq, [_2]), _3)) [] )
# 3638 "parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 771 "parser_c.mly"
                                 ( mk_e(Binary (_1, (Logical NotEq, [_2]), _3)) [] )
# 3647 "parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 772 "parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith And, [_2]), _3)) [] )
# 3656 "parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 773 "parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith Or, [_2]), _3)) [] )
# 3665 "parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 774 "parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith Xor, [_2]), _3)) [] )
# 3674 "parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 775 "parser_c.mly"
                                 ( mk_e(Binary (_1, (Logical AndLog, [_2]), _3)) [] )
# 3683 "parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 776 "parser_c.mly"
                                 ( mk_e(Binary (_1, (Logical OrLog, [_2]), _3)) [] )
# 3692 "parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'unary_expr) in
    Obj.repr(
# 779 "parser_c.mly"
                                     ( _1 )
# 3699 "parser_c.ml"
               : 'cast_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'topar2) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.fullType) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'tcpar2) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'cast_expr) in
    Obj.repr(
# 780 "parser_c.mly"
                                     ( mk_e(Cast (_2, _4)) [_1;_3] )
# 3709 "parser_c.ml"
               : 'cast_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'postfix_expr) in
    Obj.repr(
# 783 "parser_c.mly"
                                   ( _1 )
# 3716 "parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'unary_expr) in
    Obj.repr(
# 784 "parser_c.mly"
                                   ( mk_e(Infix (_2, Inc))    [_1] )
# 3724 "parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'unary_expr) in
    Obj.repr(
# 785 "parser_c.mly"
                                   ( mk_e(Infix (_2, Dec))    [_1] )
# 3732 "parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'unary_op) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'cast_expr) in
    Obj.repr(
# 786 "parser_c.mly"
                                   ( mk_e(Unary (_2, fst _1)) [snd _1] )
# 3740 "parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'unary_expr) in
    Obj.repr(
# 787 "parser_c.mly"
                                   ( mk_e(SizeOfExpr (_2))    [_1] )
# 3748 "parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'topar2) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.fullType) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'tcpar2) in
    Obj.repr(
# 788 "parser_c.mly"
                                   ( mk_e(SizeOfType (_3))    [_1;_2;_4] )
# 3758 "parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'new_argument) in
    Obj.repr(
# 789 "parser_c.mly"
                                   ( mk_e(New (None, _2))     [_1] )
# 3766 "parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'argument_list_ne) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'new_argument) in
    Obj.repr(
# 790 "parser_c.mly"
                                                  ( mk_e(New (Some _3, _5))             [_1; _2; _4] )
# 3777 "parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'cast_expr) in
    Obj.repr(
# 791 "parser_c.mly"
                                   ( mk_e(Delete _2)          [_1] )
# 3785 "parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'identifier_cpp) in
    Obj.repr(
# 792 "parser_c.mly"
                                   ( mk_e(Defined _2)         [_1] )
# 3793 "parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'identifier_cpp) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 794 "parser_c.mly"
 ( mk_e(Defined _3) [_1;_2;_4] )
# 3803 "parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : string * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'argument_list_ne) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 798 "parser_c.mly"
     ( let fn = mk_e(Ident (RegularName (mk_string_wrap _1))) [] in
       Left (mk_e(FunCall (fn, _3)) [_2;_4]) )
# 3814 "parser_c.ml"
               : 'new_argument))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : string * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 801 "parser_c.mly"
     ( let fn = mk_e(Ident (RegularName (mk_string_wrap _1))) [] in
       Left(mk_e(FunCall (fn, [])) [_2;_3]) )
# 3824 "parser_c.ml"
               : 'new_argument))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : string * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'argument_list_ne) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 804 "parser_c.mly"
     ( let fn = mk_e(Ident (RegularName (mk_string_wrap _1))) [] in
       Left (mk_e(FunCall (fn, _3)) [_2;_4]) )
# 3835 "parser_c.ml"
               : 'new_argument))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : string * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 807 "parser_c.mly"
     ( let fn = mk_e(Ident (RegularName (mk_string_wrap _1))) [] in
       Left (mk_e(FunCall (fn, [])) [_2;_3]) )
# 3845 "parser_c.ml"
               : 'new_argument))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'type_spec) in
    Obj.repr(
# 810 "parser_c.mly"
     ( let ty = addTypeD (_1,nullDecl) in
       let ((returnType,hasreg), iihasreg) = fixDeclSpecForParam ty in
       Right (ArgType { p_namei = None; p_type = returnType;
			p_register = hasreg, iihasreg;
		      } )
     )
# 3857 "parser_c.ml"
               : 'new_argument))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'new_argument) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.expression) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 817 "parser_c.mly"
     (
       match _1 with
	 Left(e) -> Left(mk_e(ArrayAccess (e, _3)) [_2;_4])
       | Right(ArgType(ty)) -> (* lots of hacks to make the right type *)
	   let fty = mk_ty (Array (Some _3, ty.Ast_c.p_type)) [_2;_4] in
	   let pty = { ty with p_type = fty } in
	   Right(ArgType pty)
       | _ -> raise (Impossible 88)
     )
# 3875 "parser_c.ml"
               : 'new_argument))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 828 "parser_c.mly"
          ( GetRef,     _1 )
# 3882 "parser_c.ml"
               : 'unary_op))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 829 "parser_c.mly"
          ( DeRef,      _1 )
# 3889 "parser_c.ml"
               : 'unary_op))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 830 "parser_c.mly"
          ( UnPlus,     _1 )
# 3896 "parser_c.ml"
               : 'unary_op))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 831 "parser_c.mly"
          ( UnMinus,    _1 )
# 3903 "parser_c.ml"
               : 'unary_op))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 832 "parser_c.mly"
          ( Tilde,      _1 )
# 3910 "parser_c.ml"
               : 'unary_op))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 833 "parser_c.mly"
          ( Not,        _1 )
# 3917 "parser_c.ml"
               : 'unary_op))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 837 "parser_c.mly"
           ( GetRefLabel, _1 )
# 3924 "parser_c.ml"
               : 'unary_op))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'primary_expr) in
    Obj.repr(
# 840 "parser_c.mly"
                              ( _1 )
# 3931 "parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'postfix_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.expression) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 842 "parser_c.mly"
     ( mk_e(ArrayAccess (_1, _3)) [_2;_4] )
# 3941 "parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'postfix_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'argument_list_ne) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 844 "parser_c.mly"
     ( mk_e(FunCall (_1, _3)) [_2;_4] )
# 3951 "parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'postfix_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 845 "parser_c.mly"
                              ( mk_e(FunCall (_1, [])) [_2;_3] )
# 3960 "parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'postfix_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'ident_cpp) in
    Obj.repr(
# 846 "parser_c.mly"
                                 ( mk_e(RecordAccess   (_1,_3)) [_2] )
# 3969 "parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'postfix_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'ident_cpp) in
    Obj.repr(
# 847 "parser_c.mly"
                                 ( mk_e(RecordPtAccess (_1,_3)) [_2] )
# 3978 "parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'postfix_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 848 "parser_c.mly"
                              ( mk_e(Postfix (_1, Inc)) [_2] )
# 3986 "parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'postfix_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 849 "parser_c.mly"
                              ( mk_e(Postfix (_1, Dec)) [_2] )
# 3994 "parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : 'topar2) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.fullType) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'tcpar2) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 853 "parser_c.mly"
     ( mk_e(Constructor (_2, (InitList [], [_4;_5]))) [_1;_3] )
# 4005 "parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 6 : 'topar2) in
    let _2 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.fullType) in
    let _3 = (Parsing.peek_val __caml_parser_env 4 : 'tcpar2) in
    let _4 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 2 : 'initialize_list) in
    let _6 = (Parsing.peek_val __caml_parser_env 1 : 'gcc_comma_opt_struct) in
    let _7 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 855 "parser_c.mly"
     ( mk_e(Constructor (_2, (InitList (List.rev _5),[_4;_7] @ _6))) [_1;_3] )
# 4018 "parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'identifier_cpp) in
    Obj.repr(
# 859 "parser_c.mly"
                   ( mk_e(Ident  (_1)) [] )
# 4025 "parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * (Ast_c.sign * Ast_c.base)) * Ast_c.info) in
    Obj.repr(
# 861 "parser_c.mly"
    ( let (str,(sign,base)) = fst _1 in
      mk_e(Constant (Int (str,Si(sign,base)))) [snd _1] )
# 4033 "parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.floatType) * Ast_c.info) in
    Obj.repr(
# 863 "parser_c.mly"
           ( mk_e(Constant (Float  (fst _1))) [snd _1] )
# 4040 "parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.isWchar) * Ast_c.info) in
    Obj.repr(
# 864 "parser_c.mly"
           ( mk_e(Constant (String (fst _1))) [snd _1] )
# 4047 "parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : (string * Ast_c.isWchar) * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'string_fragments) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.isWchar) * Ast_c.info) in
    Obj.repr(
# 866 "parser_c.mly"
     ( let ((fullstring,isW),lqinfo) = _1 in
       let (_,rqinfo) = _3 in
       mk_e (Ast_c.StringConstant(_2, fullstring, isW)) [lqinfo;rqinfo] )
# 4058 "parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.isWchar) * Ast_c.info) in
    Obj.repr(
# 869 "parser_c.mly"
           ( mk_e(Constant (Char   (fst _1))) [snd _1] )
# 4065 "parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * string (*n*) * string (*p*)) * Ast_c.info) in
    Obj.repr(
# 870 "parser_c.mly"
            ( let (a,b,c) = fst _1 in
              mk_e(Constant (DecimalConst (a,b,c))) [snd _1] )
# 4073 "parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.expression) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 872 "parser_c.mly"
                    ( mk_e(ParenExpr (_2)) [_1;_3] )
# 4082 "parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.info)) in
    Obj.repr(
# 875 "parser_c.mly"
                ( mk_e(Constant (MultiString [fst _1])) [snd _1] )
# 4089 "parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'string_elem) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'string_list) in
    Obj.repr(
# 877 "parser_c.mly"
     ( mk_e(Constant (MultiString ["TODO: MultiString"])) (_1 @ _2) )
# 4097 "parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'compound) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 880 "parser_c.mly"
                         ( mk_e(StatementExpr (_2)) [_1;_3] )
# 4106 "parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    Obj.repr(
# 883 "parser_c.mly"
               ( [] )
# 4112 "parser_c.ml"
               : 'string_fragments))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'string_fragment) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'string_fragments) in
    Obj.repr(
# 884 "parser_c.mly"
                                    ( _1 :: _2 )
# 4120 "parser_c.ml"
               : 'string_fragments))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'string_format) in
    Obj.repr(
# 887 "parser_c.mly"
                      ( Ast_c.FormatFragment(_2), [_1] )
# 4128 "parser_c.ml"
               : 'string_fragment))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 888 "parser_c.mly"
              ( Ast_c.ConstantFragment(fst _1), [snd _1] )
# 4135 "parser_c.ml"
               : 'string_fragment))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 891 "parser_c.mly"
           ( Ast_c.ConstantFormat(fst _1), [snd _1] )
# 4142 "parser_c.ml"
               : 'string_format))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'assign_expr) in
    Obj.repr(
# 900 "parser_c.mly"
               ( Left _1 )
# 4149 "parser_c.ml"
               : 'argument_ne))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'parameter_decl) in
    Obj.repr(
# 901 "parser_c.mly"
                  ( Right (ArgType _1)  )
# 4156 "parser_c.ml"
               : 'argument_ne))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'action_higherordermacro_ne) in
    Obj.repr(
# 902 "parser_c.mly"
                              ( Right (ArgAction _1) )
# 4163 "parser_c.ml"
               : 'argument_ne))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'assign_expr) in
    Obj.repr(
# 906 "parser_c.mly"
               ( Left _1 )
# 4170 "parser_c.ml"
               : 'argument))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'parameter_decl) in
    Obj.repr(
# 907 "parser_c.mly"
                  ( Right (ArgType _1)  )
# 4177 "parser_c.ml"
               : 'argument))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'action_higherordermacro) in
    Obj.repr(
# 909 "parser_c.mly"
                           ( Right (ArgAction _1) )
# 4184 "parser_c.ml"
               : 'argument))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'taction_list_ne) in
    Obj.repr(
# 913 "parser_c.mly"
     ( if _1=[]
       then ActMisc [Ast_c.fakeInfo()]
       else ActMisc _1
     )
# 4194 "parser_c.ml"
               : 'action_higherordermacro_ne))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'taction_list) in
    Obj.repr(
# 921 "parser_c.mly"
     ( if _1=[]
       then ActMisc [Ast_c.fakeInfo()]
       else ActMisc _1
     )
# 4204 "parser_c.ml"
               : 'action_higherordermacro))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cond_expr) in
    Obj.repr(
# 932 "parser_c.mly"
                      ( _1  )
# 4211 "parser_c.ml"
               : 'const_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 935 "parser_c.mly"
              ( et "topar2" (); _1  )
# 4218 "parser_c.ml"
               : 'topar2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 936 "parser_c.mly"
              ( et "tcpar2" (); _1 (*TODO? et ? sure ? c pas dt plutot ? *) )
# 4225 "parser_c.ml"
               : 'tcpar2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'statement2) in
    Obj.repr(
# 944 "parser_c.mly"
                      ( mk_st (fst _1) (snd _1) )
# 4232 "parser_c.ml"
               : Ast_c.statement))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'labeled) in
    Obj.repr(
# 947 "parser_c.mly"
                   ( Labeled      (fst _1), snd _1 )
# 4239 "parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'compound) in
    Obj.repr(
# 948 "parser_c.mly"
                   ( Compound     (fst _1), snd _1 )
# 4246 "parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'expr_statement) in
    Obj.repr(
# 949 "parser_c.mly"
                   ( ExprStatement(fst _1), snd _1 )
# 4253 "parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'selection) in
    Obj.repr(
# 950 "parser_c.mly"
                   ( Selection    (fst _1), snd _1 @ [fakeInfo()] )
# 4260 "parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'iteration) in
    Obj.repr(
# 951 "parser_c.mly"
                   ( Iteration    (fst _1), snd _1 @ [fakeInfo()] )
# 4267 "parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'jump) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 952 "parser_c.mly"
                   ( Jump         (fst _1), snd _1 @ [_2] )
# 4275 "parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'asmbody) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 955 "parser_c.mly"
                                                ( Asm _3, [_1;_2;_4;_5] )
# 4286 "parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : 'asmbody) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 956 "parser_c.mly"
                                                ( Asm _4, [_1;_2;_3;_5;_6] )
# 4298 "parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.info)) in
    Obj.repr(
# 959 "parser_c.mly"
              ( MacroStmt, [snd _1] )
# 4305 "parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'identifier) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'exec_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 961 "parser_c.mly"
                                      ( Exec(_3), [_1;snd _2;_4] )
# 4315 "parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'ident_cpp) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'sw_stat_or_decl) in
    Obj.repr(
# 968 "parser_c.mly"
                                              ( Label (_1, _3),  [_2] )
# 4324 "parser_c.ml"
               : 'labeled))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'const_expr) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'sw_stat_or_decl) in
    Obj.repr(
# 969 "parser_c.mly"
                                              ( Case (_2, _4),       [_1; _3] )
# 4334 "parser_c.ml"
               : 'labeled))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 4 : 'const_expr) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : 'const_expr) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : 'sw_stat_or_decl) in
    Obj.repr(
# 971 "parser_c.mly"
     ( CaseRange (_2, _4, _6), [_1;_3;_5] )
# 4346 "parser_c.ml"
               : 'labeled))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'sw_stat_or_decl) in
    Obj.repr(
# 972 "parser_c.mly"
                                         ( Default _3,             [_1; _2] )
# 4355 "parser_c.ml"
               : 'labeled))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl) in
    Obj.repr(
# 975 "parser_c.mly"
             ( mk_st (Decl (_1 Ast_c.LocalDecl)) Ast_c.noii )
# 4362 "parser_c.ml"
               : 'sw_stat_or_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 976 "parser_c.mly"
             ( _1 )
# 4369 "parser_c.ml"
               : 'sw_stat_or_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'ident_cpp) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 987 "parser_c.mly"
     ( Label (_1, (mk_st (ExprStatement None) Ast_c.noii)), [_2] )
# 4377 "parser_c.ml"
               : 'end_labeled))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'const_expr) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 989 "parser_c.mly"
     ( Case (_2, (mk_st (ExprStatement None) Ast_c.noii)), [_1;_3] )
# 4386 "parser_c.ml"
               : 'end_labeled))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 991 "parser_c.mly"
     ( Default (mk_st (ExprStatement None) Ast_c.noii),    [_1; _2] )
# 4394 "parser_c.ml"
               : 'end_labeled))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'tobrace) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'compound2) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'tcbrace) in
    Obj.repr(
# 997 "parser_c.mly"
                                    ( _2, [_1; _3]  )
# 4403 "parser_c.ml"
               : 'compound))
; (fun __caml_parser_env ->
    Obj.repr(
# 1009 "parser_c.mly"
                     ( ([]) )
# 4409 "parser_c.ml"
               : 'compound2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'stat_or_decl_list) in
    Obj.repr(
# 1010 "parser_c.mly"
                     ( _1 )
# 4416 "parser_c.ml"
               : 'compound2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'stat_or_decl) in
    Obj.repr(
# 1014 "parser_c.mly"
                                  ( [_1] )
# 4423 "parser_c.ml"
               : 'stat_or_decl_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'end_labeled) in
    Obj.repr(
# 1016 "parser_c.mly"
                ( [StmtElem (mk_st (Labeled  (fst _1)) (snd _1))] )
# 4430 "parser_c.ml"
               : 'stat_or_decl_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'stat_or_decl) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'stat_or_decl_list) in
    Obj.repr(
# 1018 "parser_c.mly"
                                  ( _1 :: _2 )
# 4438 "parser_c.ml"
               : 'stat_or_decl_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl) in
    Obj.repr(
# 1021 "parser_c.mly"
             ( StmtElem (mk_st (Decl (_1 Ast_c.LocalDecl)) Ast_c.noii) )
# 4445 "parser_c.ml"
               : 'stat_or_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1022 "parser_c.mly"
             ( StmtElem _1 )
# 4452 "parser_c.ml"
               : 'stat_or_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'function_definition) in
    Obj.repr(
# 1025 "parser_c.mly"
                       ( StmtElem (mk_st (NestedFunc _1) Ast_c.noii) )
# 4459 "parser_c.ml"
               : 'stat_or_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_directive) in
    Obj.repr(
# 1029 "parser_c.mly"
     ( CppDirectiveStmt _1 )
# 4466 "parser_c.ml"
               : 'stat_or_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_ifdef_directive) in
    Obj.repr(
# 1031 "parser_c.mly"
     ( IfdefStmt _1 )
# 4473 "parser_c.ml"
               : 'stat_or_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1035 "parser_c.mly"
                ( None,    [_1] )
# 4480 "parser_c.ml"
               : 'expr_statement))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.expression) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1036 "parser_c.mly"
                ( Some _1, [_2] )
# 4488 "parser_c.ml"
               : 'expr_statement))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.expression) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1040 "parser_c.mly"
     ( If (_3, _5, (mk_st (ExprStatement None) Ast_c.noii)),   [_1;_2;_4] )
# 4499 "parser_c.ml"
               : 'selection))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 6 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.expression) in
    let _4 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.statement) in
    let _6 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _7 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1042 "parser_c.mly"
     ( If (_3, _5, _7),  [_1;_2;_4;_6] )
# 4512 "parser_c.ml"
               : 'selection))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.expression) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1044 "parser_c.mly"
     ( Switch (_3,_5),   [_1;_2;_4]  )
# 4523 "parser_c.ml"
               : 'selection))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 8 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 7 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 6 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.expression) in
    let _5 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.statement) in
    let _7 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _8 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _9 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1047 "parser_c.mly"
     ( Ifdef_Ite (_4,_6,_9), [_1;_2;_3;_5;_7;_8] )
# 4538 "parser_c.ml"
               : 'selection))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 10 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 9 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 8 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 7 : Ast_c.expression) in
    let _5 = (Parsing.peek_val __caml_parser_env 6 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.statement) in
    let _7 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _8 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _9 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.statement) in
    let _10 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _11 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1050 "parser_c.mly"
     ( Ifdef_Ite2 (_4,_6,_9,_11), [_1;_2;_3;_5;_7;_8;_10] )
# 4555 "parser_c.ml"
               : 'selection))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.expression) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1054 "parser_c.mly"
     ( While (_3,_5),                [_1;_2;_4] )
# 4566 "parser_c.ml"
               : 'iteration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 6 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.statement) in
    let _3 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.expression) in
    let _6 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _7 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1056 "parser_c.mly"
     ( DoWhile (_2,_5),              [_1;_3;_4;_6;_7] )
# 4579 "parser_c.ml"
               : 'iteration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : 'expr_statement) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : 'expr_statement) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1058 "parser_c.mly"
     ( For (ForExp _3,_4,(None, []),_6),    [_1;_2;_5])
# 4591 "parser_c.ml"
               : 'iteration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 6 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 4 : 'expr_statement) in
    let _4 = (Parsing.peek_val __caml_parser_env 3 : 'expr_statement) in
    let _5 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.expression) in
    let _6 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _7 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1060 "parser_c.mly"
     ( For (ForExp _3,_4,(Some _5, []),_7), [_1;_2;_6] )
# 4604 "parser_c.ml"
               : 'iteration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : 'decl) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : 'expr_statement) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1063 "parser_c.mly"
     ( For (ForDecl (_3 Ast_c.LocalDecl),_4,(None, []),_6),    [_1;_2;_5])
# 4616 "parser_c.ml"
               : 'iteration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 6 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 4 : 'decl) in
    let _4 = (Parsing.peek_val __caml_parser_env 3 : 'expr_statement) in
    let _5 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.expression) in
    let _6 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _7 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1065 "parser_c.mly"
     ( For (ForDecl (_3 Ast_c.LocalDecl),_4,(Some _5, []),_7), [_1;_2;_6] )
# 4629 "parser_c.ml"
               : 'iteration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : (string * Ast_c.info)) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'argument_list_ne) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1068 "parser_c.mly"
     ( MacroIteration (fst _1, _3, _5), [snd _1;_2;_4] )
# 4640 "parser_c.ml"
               : 'iteration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : (string * Ast_c.info)) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1070 "parser_c.mly"
     ( MacroIteration (fst _1, [], _4), [snd _1;_2;_3] )
# 4650 "parser_c.ml"
               : 'iteration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'ident_cpp) in
    Obj.repr(
# 1074 "parser_c.mly"
                    ( Goto (_2),  [_1] )
# 4658 "parser_c.ml"
               : 'jump))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1075 "parser_c.mly"
                ( Continue,       [_1] )
# 4665 "parser_c.ml"
               : 'jump))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1076 "parser_c.mly"
                ( Break,          [_1] )
# 4672 "parser_c.ml"
               : 'jump))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1077 "parser_c.mly"
                ( Return,         [_1] )
# 4679 "parser_c.ml"
               : 'jump))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.expression) in
    Obj.repr(
# 1078 "parser_c.mly"
                ( ReturnExpr _2,  [_1] )
# 4687 "parser_c.ml"
               : 'jump))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.expression) in
    Obj.repr(
# 1079 "parser_c.mly"
                   ( GotoComputed _3, [_1;_2] )
# 4696 "parser_c.ml"
               : 'jump))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.isWchar) * Ast_c.info) in
    Obj.repr(
# 1087 "parser_c.mly"
           ( [snd _1] )
# 4703 "parser_c.ml"
               : 'string_elem))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.info)) in
    Obj.repr(
# 1089 "parser_c.mly"
                ( [snd _1] )
# 4710 "parser_c.ml"
               : 'string_elem))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'string_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'colon_asm_list) in
    Obj.repr(
# 1093 "parser_c.mly"
                               ( _1, _2 )
# 4718 "parser_c.ml"
               : 'asmbody))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'string_list) in
    Obj.repr(
# 1094 "parser_c.mly"
               ( _1, [] )
# 4725 "parser_c.ml"
               : 'asmbody))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'colon_option_list) in
    Obj.repr(
# 1097 "parser_c.mly"
                                     ( Colon _2, [_1]   )
# 4733 "parser_c.ml"
               : 'colon_asm))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.isWchar) * Ast_c.info) in
    Obj.repr(
# 1100 "parser_c.mly"
                                ( ColonMisc, [snd _1] )
# 4740 "parser_c.ml"
               : 'colon_option))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : (string * Ast_c.isWchar) * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'asm_expr) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1101 "parser_c.mly"
                                ( ColonExpr _3, [snd _1; _2;_4] )
# 4750 "parser_c.ml"
               : 'colon_option))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 6 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 5 : 'identifier) in
    let _3 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 3 : (string * Ast_c.isWchar) * Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 1 : 'asm_expr) in
    let _7 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1104 "parser_c.mly"
     ( ColonExpr _6, [_1;snd _2;_3;snd _4; _5; _7 ] )
# 4763 "parser_c.ml"
               : 'colon_option))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'identifier) in
    Obj.repr(
# 1105 "parser_c.mly"
                                    ( ColonMisc, [snd _1] )
# 4770 "parser_c.ml"
               : 'colon_option))
; (fun __caml_parser_env ->
    Obj.repr(
# 1106 "parser_c.mly"
                                    ( ColonMisc, [] )
# 4776 "parser_c.ml"
               : 'colon_option))
; (fun __caml_parser_env ->
    Obj.repr(
# 1110 "parser_c.mly"
                ( [] )
# 4782 "parser_c.ml"
               : 'exec_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'identifier_cpp) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'exec_ident) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'exec_list) in
    Obj.repr(
# 1112 "parser_c.mly"
      ( (ExecEval (_3 (mk_e (Ident _2) [])), [_1]) :: _4 )
# 4792 "parser_c.ml"
               : 'exec_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : string * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'exec_ident2) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'exec_list) in
    Obj.repr(
# 1114 "parser_c.mly"
      ( (ExecToken, [snd _1]) :: _2 @ _3 )
# 4801 "parser_c.ml"
               : 'exec_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'token) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'exec_list) in
    Obj.repr(
# 1115 "parser_c.mly"
                    ( (ExecToken, [_1]) :: _2 )
# 4809 "parser_c.ml"
               : 'exec_list))
; (fun __caml_parser_env ->
    Obj.repr(
# 1118 "parser_c.mly"
    ( function prev -> prev )
# 4815 "parser_c.ml"
               : 'exec_ident))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : string * Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'exec_ident) in
    Obj.repr(
# 1120 "parser_c.mly"
     ( function prev ->
       let fld = RegularName (mk_string_wrap _2) in
       _3 (mk_e(RecordAccess   (prev,fld)) [_1]) )
# 4826 "parser_c.ml"
               : 'exec_ident))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : string * Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'exec_ident) in
    Obj.repr(
# 1124 "parser_c.mly"
     ( function prev ->
       let fld = RegularName (mk_string_wrap _2) in
       _3 (mk_e(RecordPtAccess   (prev,fld)) [_1]) )
# 4837 "parser_c.ml"
               : 'exec_ident))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.expression) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'exec_ident) in
    Obj.repr(
# 1128 "parser_c.mly"
     ( function prev ->
       _4 (mk_e(ArrayAccess   (prev,_2)) [_1;_3]) )
# 4848 "parser_c.ml"
               : 'exec_ident))
; (fun __caml_parser_env ->
    Obj.repr(
# 1132 "parser_c.mly"
    ( [] )
# 4854 "parser_c.ml"
               : 'exec_ident2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : string * Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'exec_ident2) in
    Obj.repr(
# 1134 "parser_c.mly"
    ( (ExecToken, [_1]) :: (ExecToken, [snd _2]) :: _3 )
# 4863 "parser_c.ml"
               : 'exec_ident2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'assign_expr) in
    Obj.repr(
# 1136 "parser_c.mly"
                      ( _1 )
# 4870 "parser_c.ml"
               : 'asm_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1139 "parser_c.mly"
            ( _1 )
# 4877 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1140 "parser_c.mly"
            ( _1 )
# 4884 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1141 "parser_c.mly"
            ( _1 )
# 4891 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1142 "parser_c.mly"
            ( _1 )
# 4898 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1143 "parser_c.mly"
            ( _1 )
# 4905 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1144 "parser_c.mly"
            ( _1 )
# 4912 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1145 "parser_c.mly"
            ( _1 )
# 4919 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1146 "parser_c.mly"
            ( _1 )
# 4926 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1147 "parser_c.mly"
            ( _1 )
# 4933 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1148 "parser_c.mly"
            ( _1 )
# 4940 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.assignOp) in
    Obj.repr(
# 1149 "parser_c.mly"
            ( List.hd (snd _1) )
# 4947 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1151 "parser_c.mly"
            ( _1 )
# 4954 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1152 "parser_c.mly"
            ( _1 )
# 4961 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1153 "parser_c.mly"
            ( _1 )
# 4968 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1154 "parser_c.mly"
            ( _1 )
# 4975 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1155 "parser_c.mly"
            ( _1 )
# 4982 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1156 "parser_c.mly"
            ( _1 )
# 4989 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1158 "parser_c.mly"
            ( _1 )
# 4996 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1159 "parser_c.mly"
            ( _1 )
# 5003 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1160 "parser_c.mly"
            ( _1 )
# 5010 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1161 "parser_c.mly"
            ( _1 )
# 5017 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1162 "parser_c.mly"
            ( _1 )
# 5024 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1163 "parser_c.mly"
            ( _1 )
# 5031 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1164 "parser_c.mly"
            ( _1 )
# 5038 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1166 "parser_c.mly"
            ( _1 )
# 5045 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1167 "parser_c.mly"
            ( _1 )
# 5052 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1170 "parser_c.mly"
            ( _1 )
# 5059 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1171 "parser_c.mly"
            ( _1 )
# 5066 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1175 "parser_c.mly"
            ( _1 )
# 5073 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1176 "parser_c.mly"
            ( _1 )
# 5080 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1177 "parser_c.mly"
            ( _1 )
# 5087 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 1179 "parser_c.mly"
                 ( snd _1 )
# 5094 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1181 "parser_c.mly"
            ( _1 )
# 5101 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1182 "parser_c.mly"
            ( _1 )
# 5108 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * (Ast_c.sign * Ast_c.base)) * Ast_c.info) in
    Obj.repr(
# 1183 "parser_c.mly"
            ( snd _1 )
# 5115 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.floatType) * Ast_c.info) in
    Obj.repr(
# 1184 "parser_c.mly"
            ( snd _1 )
# 5122 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.isWchar) * Ast_c.info) in
    Obj.repr(
# 1185 "parser_c.mly"
            ( snd _1 )
# 5129 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.isWchar) * Ast_c.info) in
    Obj.repr(
# 1186 "parser_c.mly"
            ( snd _1 )
# 5136 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1197 "parser_c.mly"
                        ( Right3 (BaseType Void),            [_1] )
# 5143 "parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1198 "parser_c.mly"
                        ( Right3 (BaseType (IntType CChar)), [_1])
# 5150 "parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1199 "parser_c.mly"
                        ( Right3 (BaseType (IntType (Si (Signed,CInt)))), [_1])
# 5157 "parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1200 "parser_c.mly"
                        ( Right3 (BaseType (FloatType CFloat)),  [_1])
# 5164 "parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1201 "parser_c.mly"
                        ( Right3 (BaseType (FloatType CDouble)), [_1] )
# 5171 "parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1202 "parser_c.mly"
                        ( Right3 (BaseType SizeType),            [_1] )
# 5178 "parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1203 "parser_c.mly"
                        ( Right3 (BaseType SSizeType),           [_1] )
# 5185 "parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1204 "parser_c.mly"
                        ( Right3 (BaseType PtrDiffType),         [_1] )
# 5192 "parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1205 "parser_c.mly"
                        ( Middle3 Short,  [_1])
# 5199 "parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1206 "parser_c.mly"
                        ( Middle3 Long,   [_1])
# 5206 "parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1207 "parser_c.mly"
                        ( Left3 Signed,   [_1])
# 5213 "parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1208 "parser_c.mly"
                        ( Left3 UnSigned, [_1])
# 5220 "parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'struct_or_union_spec) in
    Obj.repr(
# 1209 "parser_c.mly"
                        ( Right3 (fst _1), snd _1 )
# 5227 "parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'enum_spec) in
    Obj.repr(
# 1210 "parser_c.mly"
                        ( Right3 (fst _1), snd _1 )
# 5234 "parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : 'const_expr) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : 'const_expr) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1212 "parser_c.mly"
     ( Right3 (Decimal(_3,Some _5)), [_1;_2;_4;_6] )
# 5246 "parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'const_expr) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1214 "parser_c.mly"
     ( Right3 (Decimal(_3,None)), [_1;_2;_4] )
# 5256 "parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 1230 "parser_c.mly"
     ( let name = RegularName (mk_string_wrap _1) in
       Right3 (TypeName (name, Ast_c.noTypedefDef())),[] )
# 5264 "parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'assign_expr) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1233 "parser_c.mly"
                                   ( Right3 (TypeOfExpr (_3)), [_1;_2;_4] )
# 5274 "parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.fullType) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1234 "parser_c.mly"
                                   ( Right3 (TypeOfType (_3)), [_1;_2;_4] )
# 5284 "parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'type_spec2) in
    Obj.repr(
# 1240 "parser_c.mly"
                         ( dt "type" (); _1   )
# 5291 "parser_c.ml"
               : 'type_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1247 "parser_c.mly"
             ( {const=true  ; volatile=false}, _1 )
# 5298 "parser_c.ml"
               : 'type_qualif))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1248 "parser_c.mly"
             ( {const=false ; volatile=true},  _1 )
# 5305 "parser_c.ml"
               : 'type_qualif))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1250 "parser_c.mly"
             ( (* TODO *) {const=false ; volatile=false},  _1 )
# 5312 "parser_c.ml"
               : 'type_qualif))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1258 "parser_c.mly"
                                    ( raise Todo )
# 5321 "parser_c.ml"
               : 'attribute))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.info)) in
    Obj.repr(
# 1260 "parser_c.mly"
              ( Attribute (fst _1), [snd _1] )
# 5328 "parser_c.ml"
               : 'attribute))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.info)) in
    Obj.repr(
# 1263 "parser_c.mly"
                     ( _1 )
# 5335 "parser_c.ml"
               : 'attribute_storage))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'type_qualif) in
    Obj.repr(
# 1266 "parser_c.mly"
               ( _1 )
# 5342 "parser_c.ml"
               : 'type_qualif_attr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.info)) in
    Obj.repr(
# 1268 "parser_c.mly"
              ( {const=true  ; volatile=false}, snd _1   )
# 5349 "parser_c.ml"
               : 'type_qualif_attr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'pointer) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'direct_d) in
    Obj.repr(
# 1283 "parser_c.mly"
                    ( (fst _2, fun x -> x +> _1 +> (snd _2)  ) )
# 5357 "parser_c.ml"
               : 'declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'direct_d) in
    Obj.repr(
# 1284 "parser_c.mly"
                    ( _1  )
# 5364 "parser_c.ml"
               : 'declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'tmul) in
    Obj.repr(
# 1288 "parser_c.mly"
                          ( fun x -> mk_ty (Pointer x) [_1] )
# 5371 "parser_c.ml"
               : 'pointer))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'tmul) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'pointer) in
    Obj.repr(
# 1289 "parser_c.mly"
                          ( fun x -> mk_ty (Pointer (_2 x)) [_1] )
# 5379 "parser_c.ml"
               : 'pointer))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'tmul) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'type_qualif_list) in
    Obj.repr(
# 1291 "parser_c.mly"
     ( fun x -> (_2.qualifD, mk_tybis (Pointer x) [_1]))
# 5387 "parser_c.ml"
               : 'pointer))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'tmul) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'type_qualif_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'pointer) in
    Obj.repr(
# 1293 "parser_c.mly"
     ( fun x -> (_2.qualifD, mk_tybis (Pointer (_3 x)) [_1]) )
# 5396 "parser_c.ml"
               : 'pointer))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1296 "parser_c.mly"
        ( _1 )
# 5403 "parser_c.ml"
               : 'tmul))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1298 "parser_c.mly"
     ( if !Flag.c_plus_plus
     then _1
     else
       let i = Ast_c.parse_info_of_info _1 in
       raise (Semantic("& not allowed in C types, try -c++ option", i)) )
# 5414 "parser_c.ml"
               : 'tmul))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'identifier_cpp) in
    Obj.repr(
# 1307 "parser_c.mly"
     ( (_1, fun x -> x) )
# 5421 "parser_c.ml"
               : 'direct_d))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'declarator) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1309 "parser_c.mly"
     ( (fst _2, fun x -> mk_ty (ParenType ((snd _2) x)) [_1;_3]) )
# 5430 "parser_c.ml"
               : 'direct_d))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'direct_d) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'tocro) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'tccro) in
    Obj.repr(
# 1311 "parser_c.mly"
     ( (fst _1,fun x->(snd _1) (mk_ty (Array (None,x)) [_2;_3])) )
# 5439 "parser_c.ml"
               : 'direct_d))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'direct_d) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'tocro) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'const_expr) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'tccro) in
    Obj.repr(
# 1313 "parser_c.mly"
     ( (fst _1,fun x->(snd _1) (mk_ty (Array (Some _3,x)) [_2;_4])) )
# 5449 "parser_c.ml"
               : 'direct_d))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'direct_d) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'topar) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'tcpar) in
    Obj.repr(
# 1315 "parser_c.mly"
     ( (fst _1,
       fun x->(snd _1)
         (mk_ty (FunctionType (x,(([],(false, []))))) [_2;_3]))
     )
# 5461 "parser_c.ml"
               : 'direct_d))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'direct_d) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'topar) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'parameter_type_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'tcpar) in
    Obj.repr(
# 1320 "parser_c.mly"
     ( (fst _1,fun x->(snd _1)
       (mk_ty (FunctionType (x, _3)) [_2;_4]))
     )
# 5473 "parser_c.ml"
               : 'direct_d))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1329 "parser_c.mly"
             ( et "tocro" ();_1 )
# 5480 "parser_c.ml"
               : 'tocro))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1330 "parser_c.mly"
             ( dt "tccro" ();_1 )
# 5487 "parser_c.ml"
               : 'tccro))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'pointer) in
    Obj.repr(
# 1334 "parser_c.mly"
                                      ( _1 )
# 5494 "parser_c.ml"
               : 'abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'direct_abstract_declarator) in
    Obj.repr(
# 1335 "parser_c.mly"
                                      ( _1 )
# 5501 "parser_c.ml"
               : 'abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'pointer) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'direct_abstract_declarator) in
    Obj.repr(
# 1336 "parser_c.mly"
                                      ( fun x -> x +> _2 +> _1 )
# 5509 "parser_c.ml"
               : 'abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'abstract_declarator) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1340 "parser_c.mly"
     ( fun x -> mk_ty (ParenType (_2 x)) [_1;_3] )
# 5518 "parser_c.ml"
               : 'direct_abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1343 "parser_c.mly"
     ( fun x -> mk_ty (Array (None, x)) [_1;_2] )
# 5526 "parser_c.ml"
               : 'direct_abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'const_expr) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1345 "parser_c.mly"
     ( fun x -> mk_ty (Array (Some _2, x)) [_1;_3] )
# 5535 "parser_c.ml"
               : 'direct_abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'direct_abstract_declarator) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1347 "parser_c.mly"
     ( fun x -> _1 (mk_ty (Array (None, x))  [_2;_3]) )
# 5544 "parser_c.ml"
               : 'direct_abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'direct_abstract_declarator) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'const_expr) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1349 "parser_c.mly"
     ( fun x -> _1 (mk_ty (Array (Some _3,x))  [_2;_4]) )
# 5554 "parser_c.ml"
               : 'direct_abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1351 "parser_c.mly"
     ( fun x -> mk_ty (FunctionType (x, ([], (false,  [])))) [_1;_2] )
# 5562 "parser_c.ml"
               : 'direct_abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'topar) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'parameter_type_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'tcpar) in
    Obj.repr(
# 1353 "parser_c.mly"
     ( fun x -> mk_ty (FunctionType (x, _2))  [_1;_3] )
# 5571 "parser_c.ml"
               : 'direct_abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'direct_abstract_declarator) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'topar) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'tcpar) in
    Obj.repr(
# 1364 "parser_c.mly"
     ( fun x -> _1 (mk_ty (FunctionType (x, (([], (false, []))))) [_2;_3]) )
# 5580 "parser_c.ml"
               : 'direct_abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'direct_abstract_declarator) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'topar) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'parameter_type_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'tcpar) in
    Obj.repr(
# 1366 "parser_c.mly"
     ( fun x -> _1 (mk_ty (FunctionType (x, _3)) [_2;_4]) )
# 5590 "parser_c.ml"
               : 'direct_abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'parameter_list) in
    Obj.repr(
# 1372 "parser_c.mly"
                                   ( (_1, (false, [])))
# 5597 "parser_c.ml"
               : 'parameter_type_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'parameter_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1373 "parser_c.mly"
                                   ( (_1, (true,  [_2;_3])) )
# 5606 "parser_c.ml"
               : 'parameter_type_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 1377 "parser_c.mly"
            (
     let name = RegularName (mk_string_wrap _1) in
     LP.add_ident (str_of_name name);
     { p_namei = Some name;
       p_type = mk_ty NoType [];
       p_register = (false, []);
     }
   )
# 5620 "parser_c.ml"
               : 'parameter_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'decl_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'declaratorp) in
    Obj.repr(
# 1386 "parser_c.mly"
     ( let ((returnType,hasreg),iihasreg) = fixDeclSpecForParam _1 in
       let (name, ftyp) = _2 in
       { p_namei = Some (name);
         p_type = ftyp returnType;
         p_register = (hasreg, iihasreg);
       }
     )
# 5634 "parser_c.ml"
               : 'parameter_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'decl_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'abstract_declaratorp) in
    Obj.repr(
# 1394 "parser_c.mly"
     ( let ((returnType,hasreg), iihasreg) = fixDeclSpecForParam _1 in
       { p_namei = None;
         p_type = _2 returnType;
         p_register = hasreg, iihasreg;
       }
     )
# 5647 "parser_c.ml"
               : 'parameter_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl_spec) in
    Obj.repr(
# 1401 "parser_c.mly"
     ( let ((returnType,hasreg), iihasreg) = fixDeclSpecForParam _1 in
       { p_namei = None;
         p_type = returnType;
         p_register = hasreg, iihasreg;
       }
     )
# 5659 "parser_c.ml"
               : 'parameter_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'parameter_decl2) in
    Obj.repr(
# 1413 "parser_c.mly"
                                ( et "param" ();  _1 )
# 5666 "parser_c.ml"
               : 'parameter_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'attributes) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'parameter_decl2) in
    Obj.repr(
# 1414 "parser_c.mly"
                              ( et "param" (); _2 )
# 5674 "parser_c.ml"
               : 'parameter_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'declarator) in
    Obj.repr(
# 1417 "parser_c.mly"
               ( LP.add_ident (str_of_name (fst _1)); _1 )
# 5681 "parser_c.ml"
               : 'declaratorp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'attributes) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'declarator) in
    Obj.repr(
# 1419 "parser_c.mly"
                           ( LP.add_ident (str_of_name (fst _2)); _2 )
# 5689 "parser_c.ml"
               : 'declaratorp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'declarator) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'attributes) in
    Obj.repr(
# 1420 "parser_c.mly"
                           ( LP.add_ident (str_of_name (fst _1)); _1 )
# 5697 "parser_c.ml"
               : 'declaratorp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'abstract_declarator) in
    Obj.repr(
# 1423 "parser_c.mly"
                       ( _1 )
# 5704 "parser_c.ml"
               : 'abstract_declaratorp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'attributes) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'abstract_declarator) in
    Obj.repr(
# 1425 "parser_c.mly"
                                  ( _2 )
# 5712 "parser_c.ml"
               : 'abstract_declaratorp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'type_spec) in
    Obj.repr(
# 1434 "parser_c.mly"
                                ( addTypeD (_1, nullDecl) )
# 5719 "parser_c.ml"
               : 'spec_qualif_list2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'type_qualif) in
    Obj.repr(
# 1435 "parser_c.mly"
                                ( {nullDecl with qualifD = (fst _1,[snd _1])})
# 5726 "parser_c.ml"
               : 'spec_qualif_list2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'type_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'spec_qualif_list) in
    Obj.repr(
# 1436 "parser_c.mly"
                                ( addTypeD (_1,_2)   )
# 5734 "parser_c.ml"
               : 'spec_qualif_list2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'type_qualif) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'spec_qualif_list) in
    Obj.repr(
# 1437 "parser_c.mly"
                                ( addQualifD (_1,_2) )
# 5742 "parser_c.ml"
               : 'spec_qualif_list2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'spec_qualif_list2) in
    Obj.repr(
# 1439 "parser_c.mly"
                                               (  dt "spec_qualif" (); _1 )
# 5749 "parser_c.ml"
               : 'spec_qualif_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'type_qualif_attr) in
    Obj.repr(
# 1444 "parser_c.mly"
                                     ( {nullDecl with qualifD = (fst _1,[snd _1])} )
# 5756 "parser_c.ml"
               : 'type_qualif_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'type_qualif_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'type_qualif_attr) in
    Obj.repr(
# 1445 "parser_c.mly"
                                     ( addQualifD (_2,_1) )
# 5764 "parser_c.ml"
               : 'type_qualif_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'spec_qualif_list) in
    Obj.repr(
# 1458 "parser_c.mly"
     ( let (returnType, _) = fixDeclSpecForDecl _1 in  returnType )
# 5771 "parser_c.ml"
               : Ast_c.fullType))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'spec_qualif_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'abstract_declaratort) in
    Obj.repr(
# 1460 "parser_c.mly"
     ( let (returnType, _) = fixDeclSpecForDecl _1 in _2 returnType )
# 5779 "parser_c.ml"
               : Ast_c.fullType))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'abstract_declarator) in
    Obj.repr(
# 1465 "parser_c.mly"
                       ( _1 )
# 5786 "parser_c.ml"
               : 'abstract_declaratort))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'attributes) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'abstract_declarator) in
    Obj.repr(
# 1467 "parser_c.mly"
                                  ( _2 )
# 5794 "parser_c.ml"
               : 'abstract_declaratort))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'decl_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1476 "parser_c.mly"
     ( function local ->
       let (returnType,storage) = fixDeclSpecForDecl _1 in
       let iistart = Ast_c.fakeInfo () in
       DeclList ([{v_namei = None; v_type = returnType;
                   v_storage = unwrap storage; v_local = local;
                   v_attr = Ast_c.noattr;
                   v_type_bis = ref None;
                },[]],
                (_2::iistart::snd storage))
     )
# 5811 "parser_c.ml"
               : 'decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'decl_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'init_declarator_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1487 "parser_c.mly"
     ( function local ->
       let (returnType,storage) = fixDeclSpecForDecl _1 in
       let iistart = Ast_c.fakeInfo () in
       DeclList (
         (_2 +> List.map (fun ((((name,f),attrs), ini), iivirg) ->
           let s = str_of_name name in
	   if fst (unwrap storage) = StoTypedef
	   then LP.add_typedef s;
           {v_namei = Some (name, ini);
            v_type = f returnType;
            v_storage = unwrap storage;
            v_local = local;
            v_attr = attrs;
            v_type_bis = ref None;
           },
           iivirg
         )
         ),  (_3::iistart::snd storage))
     )
# 5838 "parser_c.ml"
               : 'decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : 'storage_const_opt) in
    let _2 = (Parsing.peek_val __caml_parser_env 4 : (string * Ast_c.info)) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : 'argument_list) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1509 "parser_c.mly"
     ( function _ ->
       match _1 with
	 Some (sto,stoii) ->
	   MacroDecl
	     ((sto, fst _2, _4, true), (snd _2::_3::_5::_6::fakeInfo()::stoii))
       | None ->
	   MacroDecl
	     ((NoSto, fst _2, _4, true), [snd _2;_3;_5;_6;fakeInfo()]) )
# 5857 "parser_c.ml"
               : 'decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 7 : 'storage_const_opt) in
    let _2 = (Parsing.peek_val __caml_parser_env 6 : (string * Ast_c.info)) in
    let _3 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 4 : 'argument_list) in
    let _5 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 2 : 'teq) in
    let _7 = (Parsing.peek_val __caml_parser_env 1 : 'initialize) in
    let _8 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1520 "parser_c.mly"
     ( function _ ->
       match _1 with
	 Some (sto,stoii) ->
	   MacroDeclInit
	     ((sto, fst _2, _4, _7),
	      (snd _2::_3::_5::_6::_8::fakeInfo()::stoii))
       | None ->
	   MacroDeclInit
	     ((NoSto, fst _2, _4, _7), [snd _2;_3;_5;_6;_8;fakeInfo()]) )
# 5879 "parser_c.ml"
               : 'decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'storage_class_spec_nt) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1531 "parser_c.mly"
                                         ( Some (fst _1,[snd _1; _2]) )
# 5887 "parser_c.ml"
               : 'storage_const_opt))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'storage_class_spec_nt) in
    Obj.repr(
# 1532 "parser_c.mly"
                         ( Some (fst _1,[snd _1]) )
# 5894 "parser_c.ml"
               : 'storage_const_opt))
; (fun __caml_parser_env ->
    Obj.repr(
# 1533 "parser_c.mly"
                         ( None )
# 5900 "parser_c.ml"
               : 'storage_const_opt))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'storage_class_spec) in
    Obj.repr(
# 1537 "parser_c.mly"
                           ( {nullDecl with storageD = (fst _1, [snd _1]) } )
# 5907 "parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'type_spec) in
    Obj.repr(
# 1538 "parser_c.mly"
                           ( addTypeD (_1,nullDecl) )
# 5914 "parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'type_qualif) in
    Obj.repr(
# 1539 "parser_c.mly"
                           ( {nullDecl with qualifD  = (fst _1, [snd _1]) } )
# 5921 "parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1540 "parser_c.mly"
                           ( {nullDecl with inlineD = (true, [_1]) } )
# 5928 "parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'storage_class_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'decl_spec2) in
    Obj.repr(
# 1541 "parser_c.mly"
                                 ( addStorageD (_1, _2) )
# 5936 "parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'type_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'decl_spec2) in
    Obj.repr(
# 1542 "parser_c.mly"
                                 ( addTypeD    (_1, _2) )
# 5944 "parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'type_qualif) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'decl_spec2) in
    Obj.repr(
# 1543 "parser_c.mly"
                                 ( addQualifD  (_1, _2) )
# 5952 "parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'decl_spec2) in
    Obj.repr(
# 1544 "parser_c.mly"
                                 ( addInlineD ((true, _1), _2) )
# 5960 "parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1552 "parser_c.mly"
                ( Sto Static,  _1 )
# 5967 "parser_c.ml"
               : 'storage_class_spec_nt))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1553 "parser_c.mly"
                ( Sto Extern,  _1 )
# 5974 "parser_c.ml"
               : 'storage_class_spec_nt))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1554 "parser_c.mly"
                ( Sto Auto,    _1 )
# 5981 "parser_c.ml"
               : 'storage_class_spec_nt))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1555 "parser_c.mly"
                ( Sto Register,_1 )
# 5988 "parser_c.ml"
               : 'storage_class_spec_nt))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'storage_class_spec_nt) in
    Obj.repr(
# 1558 "parser_c.mly"
                         ( _1 )
# 5995 "parser_c.ml"
               : 'storage_class_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1559 "parser_c.mly"
                ( StoTypedef,  _1 )
# 6002 "parser_c.ml"
               : 'storage_class_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'storage_class_spec2) in
    Obj.repr(
# 1563 "parser_c.mly"
                       ( _1 )
# 6009 "parser_c.ml"
               : 'storage_class_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'storage_class_spec2) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'attribute_storage_list) in
    Obj.repr(
# 1564 "parser_c.mly"
                                              ( _1 (* TODO *) )
# 6017 "parser_c.ml"
               : 'storage_class_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl2) in
    Obj.repr(
# 1572 "parser_c.mly"
                         ( et "decl" (); _1 )
# 6024 "parser_c.ml"
               : 'decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl_spec2) in
    Obj.repr(
# 1573 "parser_c.mly"
                         ( dt "declspec" (); _1  )
# 6031 "parser_c.ml"
               : 'decl_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'declaratori) in
    Obj.repr(
# 1579 "parser_c.mly"
                                ( (_1, NoInit) )
# 6038 "parser_c.ml"
               : 'init_declarator2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'declaratori) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'teq) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'initialize) in
    Obj.repr(
# 1580 "parser_c.mly"
                                ( (_1, ValInit(_2, _3)) )
# 6047 "parser_c.ml"
               : 'init_declarator2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'declaratori) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'argument_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1583 "parser_c.mly"
     ( (_1, ConstrInit(_3,[_2;_4])) )
# 6057 "parser_c.ml"
               : 'init_declarator2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1589 "parser_c.mly"
          ( et "teq" (); _1 )
# 6064 "parser_c.ml"
               : 'teq))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'init_declarator2) in
    Obj.repr(
# 1591 "parser_c.mly"
                                   ( dt "init" (); _1 )
# 6071 "parser_c.ml"
               : 'init_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'declarator) in
    Obj.repr(
# 1599 "parser_c.mly"
                           ( LP.add_ident (str_of_name (fst _1)); _1, Ast_c.noattr )
# 6078 "parser_c.ml"
               : 'declaratori))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'declarator) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'gcc_asm_decl) in
    Obj.repr(
# 1601 "parser_c.mly"
                           ( LP.add_ident (str_of_name (fst _1)); _1, Ast_c.noattr )
# 6086 "parser_c.ml"
               : 'declaratori))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'attributes) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'declarator) in
    Obj.repr(
# 1603 "parser_c.mly"
                           ( LP.add_ident (str_of_name (fst _2)); _2, _1 )
# 6094 "parser_c.ml"
               : 'declaratori))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'declarator) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'attributes) in
    Obj.repr(
# 1604 "parser_c.mly"
                           ( LP.add_ident (str_of_name (fst _1)); _1, Ast_c.noattr (* TODO *) )
# 6102 "parser_c.ml"
               : 'declaratori))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'asmbody) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1609 "parser_c.mly"
                                         (  )
# 6112 "parser_c.ml"
               : 'gcc_asm_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : 'asmbody) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1610 "parser_c.mly"
                                        (  )
# 6123 "parser_c.ml"
               : 'gcc_asm_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'assign_expr) in
    Obj.repr(
# 1616 "parser_c.mly"
     ( InitExpr _1,                [] )
# 6130 "parser_c.ml"
               : 'initialize))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'tobrace_ini) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'initialize_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'gcc_comma_opt_struct) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'tcbrace_ini) in
    Obj.repr(
# 1618 "parser_c.mly"
     ( InitList (List.rev _2),     [_1;_4] @ _3 )
# 6140 "parser_c.ml"
               : 'initialize))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'tobrace_ini) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'tcbrace_ini) in
    Obj.repr(
# 1620 "parser_c.mly"
     ( InitList [],       [_1;_2] )
# 6148 "parser_c.ml"
               : 'initialize))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'initialize2) in
    Obj.repr(
# 1631 "parser_c.mly"
                                      ( [_1,   []] )
# 6155 "parser_c.ml"
               : 'initialize_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'initialize_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'initialize2) in
    Obj.repr(
# 1632 "parser_c.mly"
                                      ( (_3,  [_2])::_1 )
# 6164 "parser_c.ml"
               : 'initialize_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cond_expr) in
    Obj.repr(
# 1638 "parser_c.mly"
     ( InitExpr _1,   [] )
# 6171 "parser_c.ml"
               : 'initialize2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'tobrace_ini) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'initialize_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'gcc_comma_opt_struct) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'tcbrace_ini) in
    Obj.repr(
# 1640 "parser_c.mly"
     ( InitList (List.rev _2),   [_1;_4] @ _3 )
# 6181 "parser_c.ml"
               : 'initialize2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'tobrace_ini) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'tcbrace_ini) in
    Obj.repr(
# 1642 "parser_c.mly"
     ( InitList [],  [_1;_2]  )
# 6189 "parser_c.ml"
               : 'initialize2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'designator_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'initialize2) in
    Obj.repr(
# 1646 "parser_c.mly"
     ( InitDesignators (_1, _3), [_2] )
# 6198 "parser_c.ml"
               : 'initialize2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'ident) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'initialize2) in
    Obj.repr(
# 1650 "parser_c.mly"
     ( InitFieldOld (fst _1, _3),     [snd _1; _2] )
# 6207 "parser_c.ml"
               : 'initialize2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'ident) in
    Obj.repr(
# 1661 "parser_c.mly"
     ( DesignatorField (fst _2), [_1;snd _2] )
# 6215 "parser_c.ml"
               : 'designator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'const_expr) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1663 "parser_c.mly"
     ( DesignatorIndex (_2),  [_1;_3] )
# 6224 "parser_c.ml"
               : 'designator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : 'const_expr) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : 'const_expr) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1665 "parser_c.mly"
     ( DesignatorRange (_2, _4),  [_1;_3;_5] )
# 6235 "parser_c.ml"
               : 'designator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1673 "parser_c.mly"
          (  [_1] )
# 6242 "parser_c.ml"
               : 'gcc_comma_opt_struct))
; (fun __caml_parser_env ->
    Obj.repr(
# 1674 "parser_c.mly"
                    (  [Ast_c.fakeInfo() +> Ast_c.rewrap_str ","]  )
# 6248 "parser_c.ml"
               : 'gcc_comma_opt_struct))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : 'struct_or_union) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : 'ident) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'tobrace_struct) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : 'struct_decl_list_gcc) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'tcbrace_struct) in
    Obj.repr(
# 1689 "parser_c.mly"
     ( StructUnion (fst _1, Some (fst _2), _4),  [snd _1;snd _2;_3;_5]  )
# 6259 "parser_c.ml"
               : 's_or_u_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'struct_or_union) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'tobrace_struct) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'struct_decl_list_gcc) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'tcbrace_struct) in
    Obj.repr(
# 1691 "parser_c.mly"
     ( StructUnion (fst _1, None, _3), [snd _1;_2;_4] )
# 6269 "parser_c.ml"
               : 's_or_u_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'struct_or_union) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'ident) in
    Obj.repr(
# 1693 "parser_c.mly"
     ( StructUnionName (fst _1, fst _2), [snd _1;snd _2] )
# 6277 "parser_c.ml"
               : 's_or_u_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1696 "parser_c.mly"
             ( Struct, _1 )
# 6284 "parser_c.ml"
               : 'struct_or_union2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1697 "parser_c.mly"
             ( Union, _1 )
# 6291 "parser_c.ml"
               : 'struct_or_union2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'attributes) in
    Obj.repr(
# 1699 "parser_c.mly"
                        ( Struct, _1 (* TODO *) )
# 6299 "parser_c.ml"
               : 'struct_or_union2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'attributes) in
    Obj.repr(
# 1700 "parser_c.mly"
                        ( Union, _1  (* TODO *) )
# 6307 "parser_c.ml"
               : 'struct_or_union2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'field_declaration) in
    Obj.repr(
# 1705 "parser_c.mly"
                     ( DeclarationField _1 )
# 6314 "parser_c.ml"
               : 'struct_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1706 "parser_c.mly"
           ( EmptyField _1  )
# 6321 "parser_c.ml"
               : 'struct_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : 'identifier) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'argument_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1712 "parser_c.mly"
     ( MacroDeclField ((fst _1, _3), [snd _1;_2;_4;_5;fakeInfo()]) )
# 6332 "parser_c.ml"
               : 'struct_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_directive) in
    Obj.repr(
# 1716 "parser_c.mly"
     ( CppDirectiveStruct _1 )
# 6339 "parser_c.ml"
               : 'struct_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_ifdef_directive) in
    Obj.repr(
# 1718 "parser_c.mly"
     ( IfdefStruct _1 )
# 6346 "parser_c.ml"
               : 'struct_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'spec_qualif_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'struct_declarator_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1723 "parser_c.mly"
     (
       let (returnType,storage) = fixDeclSpecForDecl _1 in
       if fst (unwrap storage) <> NoSto
       then internal_error "parsing dont allow this";

       let iistart = Ast_c.fakeInfo () in (* for parallelism with DeclList *)
       FieldDeclList (_2 +> (List.map (fun (f, iivirg) ->
         f returnType, iivirg))
                         ,[_3;iistart])
         (* dont need to check if typedef or func initialised cos
          * grammar dont allow typedef nor initialiser in struct
          *)
     )
# 6367 "parser_c.ml"
               : 'field_declaration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'spec_qualif_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1738 "parser_c.mly"
     (
       (* gccext: allow empty elements if it is a structdef or enumdef *)
       let (returnType,storage) = fixDeclSpecForDecl _1 in
       if fst (unwrap storage) <> NoSto
       then internal_error "parsing dont allow this";

       let iistart = Ast_c.fakeInfo () in (* for parallelism with DeclList *)
       FieldDeclList ([(Simple (None, returnType)) , []], [_2;iistart])
     )
# 6383 "parser_c.ml"
               : 'field_declaration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'declaratorsd) in
    Obj.repr(
# 1754 "parser_c.mly"
     ( (fun x -> Simple   (Some (fst _1), (snd _1) x)) )
# 6390 "parser_c.ml"
               : 'struct_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'dotdot) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'const_expr2) in
    Obj.repr(
# 1756 "parser_c.mly"
     ( (fun x -> BitField (None, x, _1, _2)) )
# 6398 "parser_c.ml"
               : 'struct_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'declaratorsd) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'dotdot) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'const_expr2) in
    Obj.repr(
# 1758 "parser_c.mly"
     ( (fun x -> BitField (Some (fst _1), ((snd _1) x), _2, _3)) )
# 6407 "parser_c.ml"
               : 'struct_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'declarator) in
    Obj.repr(
# 1765 "parser_c.mly"
              ( (*also ? LP.add_ident (fst (fst $1)); *) _1 )
# 6414 "parser_c.ml"
               : 'declaratorsd))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'attributes) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'declarator) in
    Obj.repr(
# 1767 "parser_c.mly"
                           ( _2 )
# 6422 "parser_c.ml"
               : 'declaratorsd))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'declarator) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'attributes) in
    Obj.repr(
# 1768 "parser_c.mly"
                           ( _1 )
# 6430 "parser_c.ml"
               : 'declaratorsd))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 's_or_u_spec2) in
    Obj.repr(
# 1773 "parser_c.mly"
                                   ( dt "su" (); _1 )
# 6437 "parser_c.ml"
               : 'struct_or_union_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'struct_or_union2) in
    Obj.repr(
# 1774 "parser_c.mly"
                                  ( et "su" (); _1 )
# 6444 "parser_c.ml"
               : 'struct_or_union))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'struct_decl2) in
    Obj.repr(
# 1775 "parser_c.mly"
                           ( et "struct" (); _1 )
# 6451 "parser_c.ml"
               : 'struct_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1777 "parser_c.mly"
                 ( et "dotdot" (); _1 )
# 6458 "parser_c.ml"
               : 'dotdot))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'const_expr) in
    Obj.repr(
# 1778 "parser_c.mly"
                        ( dt "const_expr2" (); _1 )
# 6465 "parser_c.ml"
               : 'const_expr2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'struct_decl_list) in
    Obj.repr(
# 1781 "parser_c.mly"
                     ( _1 )
# 6472 "parser_c.ml"
               : 'struct_decl_list_gcc))
; (fun __caml_parser_env ->
    Obj.repr(
# 1782 "parser_c.mly"
                         ( [] )
# 6478 "parser_c.ml"
               : 'struct_decl_list_gcc))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : 'tobrace_enum) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'enumerator_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : 'gcc_comma_opt_struct) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'tcbrace_enum) in
    Obj.repr(
# 1790 "parser_c.mly"
     ( Enum (None,    _3),           [_1;_2;_5] @ _4 )
# 6489 "parser_c.ml"
               : 'enum_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 4 : 'ident) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : 'tobrace_enum) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : 'enumerator_list) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : 'gcc_comma_opt_struct) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : 'tcbrace_enum) in
    Obj.repr(
# 1792 "parser_c.mly"
     ( Enum (Some (fst _2), _4),     [_1; snd _2; _3;_6] @ _5 )
# 6501 "parser_c.ml"
               : 'enum_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'ident) in
    Obj.repr(
# 1794 "parser_c.mly"
     ( EnumName (fst _2),       [_1; snd _2] )
# 6509 "parser_c.ml"
               : 'enum_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'idente) in
    Obj.repr(
# 1797 "parser_c.mly"
                          ( _1, None     )
# 6516 "parser_c.ml"
               : 'enumerator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'idente) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'const_expr) in
    Obj.repr(
# 1798 "parser_c.mly"
                          ( _1, Some (_2, _3) )
# 6525 "parser_c.ml"
               : 'enumerator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'ident_cpp) in
    Obj.repr(
# 1805 "parser_c.mly"
                  ( LP.add_ident (str_of_name _1); _1 )
# 6532 "parser_c.ml"
               : 'idente))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'function_def) in
    Obj.repr(
# 1812 "parser_c.mly"
                                     ( fixFunc _1 )
# 6539 "parser_c.ml"
               : 'function_definition))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl) in
    Obj.repr(
# 1815 "parser_c.mly"
                  ( [_1 Ast_c.LocalDecl]   )
# 6546 "parser_c.ml"
               : 'decl_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'decl_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'decl) in
    Obj.repr(
# 1816 "parser_c.mly"
                  ( _1 @ [_2 Ast_c.LocalDecl] )
# 6554 "parser_c.ml"
               : 'decl_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_directive) in
    Obj.repr(
# 1820 "parser_c.mly"
                                    ( )
# 6561 "parser_c.ml"
               : 'cpp_directive_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'cpp_directive_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_directive) in
    Obj.repr(
# 1821 "parser_c.mly"
                                    ( )
# 6569 "parser_c.ml"
               : 'cpp_directive_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'start_fun) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'compound) in
    Obj.repr(
# 1824 "parser_c.mly"
                           ( LP.del_scope(); (_1, _2, None) )
# 6577 "parser_c.ml"
               : 'function_def))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'start_fun) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'cpp_directive_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'compound) in
    Obj.repr(
# 1825 "parser_c.mly"
                                         ( LP.del_scope(); (_1, _3, None) )
# 6586 "parser_c.ml"
               : 'function_def))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'start_fun) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'decl_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'compound) in
    Obj.repr(
# 1826 "parser_c.mly"
                                     (
     (* TODO: undo the typedef added ? *)
     LP.del_scope();
     (_1, _3, Some _2)
   )
# 6599 "parser_c.ml"
               : 'function_def))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'start_fun2) in
    Obj.repr(
# 1833 "parser_c.mly"
  ( LP.new_scope();
    fix_add_params_ident _1;
    (* toreput? !LP._lexer_hint.toplevel <- false;  *)
    _1
  )
# 6610 "parser_c.ml"
               : 'start_fun))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'decl_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'declaratorfd) in
    Obj.repr(
# 1840 "parser_c.mly"
     ( let (returnType,storage) = fixDeclSpecForFuncDef _1 in
       let (id, attrs) = _2 in
       (fst id, fixOldCDecl ((snd id) returnType) , storage, attrs)
     )
# 6621 "parser_c.ml"
               : 'start_fun2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'ctor_dtor) in
    Obj.repr(
# 1844 "parser_c.mly"
               ( _1 )
# 6628 "parser_c.ml"
               : 'start_fun2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : string * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'topar) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'tcpar) in
    Obj.repr(
# 1847 "parser_c.mly"
                                (
     let id = RegularName (mk_string_wrap _1) in
     let ret = mk_ty NoType [] in
     let ty = mk_ty (FunctionType (ret, (([], (false, []))))) [_2;_3] in
     let storage = ((NoSto,false),[]) in
     let attrs = [] in
     (id, ty, storage, attrs) )
# 6643 "parser_c.ml"
               : 'ctor_dtor))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : string * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'topar) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'parameter_type_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'tcpar) in
    Obj.repr(
# 1854 "parser_c.mly"
                                                    (
     let id = RegularName (mk_string_wrap _1) in
     let ret = mk_ty NoType [] in
     let ty = mk_ty (FunctionType (ret, _3)) [_2;_4] in
     let storage = ((NoSto,false),[]) in
     let attrs = [] in
     (id, ty, storage, attrs) )
# 6659 "parser_c.ml"
               : 'ctor_dtor))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'declarator) in
    Obj.repr(
# 1875 "parser_c.mly"
              ( et "declaratorfd" (); _1, Ast_c.noattr )
# 6666 "parser_c.ml"
               : 'declaratorfd))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'attributes) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'declarator) in
    Obj.repr(
# 1877 "parser_c.mly"
                           ( et "declaratorfd" (); _2, _1 )
# 6674 "parser_c.ml"
               : 'declaratorfd))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'declarator) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'attributes) in
    Obj.repr(
# 1878 "parser_c.mly"
                           ( et "declaratorfd" (); _1, Ast_c.noattr )
# 6682 "parser_c.ml"
               : 'declaratorfd))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : (Ast_c.info * bool ref)) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.info)) in
    Obj.repr(
# 1888 "parser_c.mly"
     (
       let (i1, in_ifdef) = _1 in
       let (s, i2) = _2 in

       (* redo some lexing work :( *)
       let inc_file =
         match () with
         | _ when s =~ "^\"\\(.*\\)\"$" ->
             Local (Common.split "/" (matched1 s))
         | _ when s =~ "^\\<\\(.*\\)\\>$" ->
             NonLocal (Common.split "/" (matched1 s))
         | _ ->
             Weird s
       in
       Include { i_include = (inc_file, [i1;i2]);
                 i_rel_pos = Ast_c.noRelPos();
                 i_is_in_ifdef = !in_ifdef;
                 i_content = Ast_c.noi_content;
       }
     )
# 6709 "parser_c.ml"
               : 'cpp_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : (string * Ast_c.info)) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'define_val) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1910 "parser_c.mly"
     ( Define ((fst _2, [_1; snd _2;_4]), (DefineVar, _3)) )
# 6719 "parser_c.ml"
               : 'cpp_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 6 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 5 : (string * Ast_c.info)) in
    let _3 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 3 : 'param_define_list) in
    let _5 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 1 : 'define_val) in
    let _7 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1917 "parser_c.mly"
     ( Define
         ((fst _2, [_1; snd _2; _7]),
           (DefineFunc (_4, [_3;_5]), _6))
     )
# 6735 "parser_c.ml"
               : 'cpp_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : (string * Ast_c.info)) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1923 "parser_c.mly"
     ( Define((fst _2, [_1; snd _2; _3]), (Undef,DefineEmpty)) )
# 6744 "parser_c.ml"
               : 'cpp_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : (string * Ast_c.info)) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'pragmainfo) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1926 "parser_c.mly"
     ( Pragma((fst _2, [_1; snd _2; _4]), _3) )
# 6754 "parser_c.ml"
               : 'cpp_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1928 "parser_c.mly"
                      ( OtherDirective ([_1]) )
# 6761 "parser_c.ml"
               : 'cpp_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'argument_list_ne) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1931 "parser_c.mly"
                                ( (PragmaTuple (_2, [_1;_3])) )
# 6770 "parser_c.ml"
               : 'pragmainfo))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1932 "parser_c.mly"
               ( PragmaTuple ([], [_1;_2]) )
# 6778 "parser_c.ml"
               : 'pragmainfo))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'ident_define_list_ne) in
    Obj.repr(
# 1933 "parser_c.mly"
                        ( PragmaIdList _1 )
# 6785 "parser_c.ml"
               : 'pragmainfo))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.expression) in
    Obj.repr(
# 1939 "parser_c.mly"
             ( DefineExpr _1 )
# 6792 "parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1940 "parser_c.mly"
             ( DefineStmt _1 )
# 6799 "parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl) in
    Obj.repr(
# 1941 "parser_c.mly"
             ( DefineStmt (mk_st (Decl (_1 Ast_c.NotLocalDecl)) Ast_c.noii) )
# 6806 "parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl_spec) in
    Obj.repr(
# 1951 "parser_c.mly"
     ( let returnType = fixDeclSpecForMacro _1 in
       DefineType returnType
     )
# 6815 "parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'decl_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'abstract_declarator) in
    Obj.repr(
# 1955 "parser_c.mly"
     ( let returnType = fixDeclSpecForMacro _1 in
       let typ = _2 returnType in
       DefineType typ
     )
# 6826 "parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'stat_or_decl) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'stat_or_decl_list) in
    Obj.repr(
# 1967 "parser_c.mly"
     ( DefineMulti
	 (List.map
	    (function
		StmtElem e -> e
	      | _ -> failwith "unexpected statement for DefineMulti")
	    (_1 :: _2)) )
# 6839 "parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'function_definition) in
    Obj.repr(
# 1981 "parser_c.mly"
                       ( DefineFunction _1 )
# 6846 "parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : 'initialize_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'gcc_comma_opt_struct) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'comma_opt) in
    Obj.repr(
# 1984 "parser_c.mly"
    ( DefineInit (InitList (List.rev _2), [_1;_4] @ _3 @ _5)  )
# 6857 "parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.statement) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.expression) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1988 "parser_c.mly"
     (
       (* TOREPUT
       if fst $5 <> "0"
       then pr2 "WEIRD: in macro and have not a while(0)";
       *)
       DefineDoWhileZero ((_2,_5),   [_1;_3;_4;_6])
     )
# 6875 "parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'asmbody) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1996 "parser_c.mly"
                                         ( DefineTodo )
# 6885 "parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : 'asmbody) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1997 "parser_c.mly"
                                         ( DefineTodo )
# 6896 "parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.info)) in
    Obj.repr(
# 2000 "parser_c.mly"
              ( DefineTodo )
# 6903 "parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    Obj.repr(
# 2002 "parser_c.mly"
                   ( DefineEmpty )
# 6909 "parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 2008 "parser_c.mly"
                        ( mk_string_wrap _1 )
# 6916 "parser_c.ml"
               : 'param_define))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 2009 "parser_c.mly"
                        ( mk_string_wrap _1 )
# 6923 "parser_c.ml"
               : 'param_define))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.info)) in
    Obj.repr(
# 2010 "parser_c.mly"
                        ( mk_string_wrap _1 )
# 6930 "parser_c.ml"
               : 'param_define))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2011 "parser_c.mly"
                        ( "...", [_1] )
# 6937 "parser_c.ml"
               : 'param_define))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2013 "parser_c.mly"
                        ( "register", [_1] )
# 6944 "parser_c.ml"
               : 'param_define))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (Ast_c.ifdef_guard * (int * int) option ref * Ast_c.info)) in
    Obj.repr(
# 2020 "parser_c.mly"
     ( let (cond,tag,ii) = _1 in
       IfdefDirective ((Ifdef cond, IfdefTag (Common.some !tag)),  [ii]) )
# 6952 "parser_c.ml"
               : 'cpp_ifdef_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : ((int * int) option ref * Ast_c.info)) in
    Obj.repr(
# 2023 "parser_c.mly"
     ( let (tag,ii) = _1 in
       IfdefDirective ((IfdefElse, IfdefTag (Common.some !tag)), [ii]) )
# 6960 "parser_c.ml"
               : 'cpp_ifdef_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (Ast_c.ifdef_guard * (int * int) option ref * Ast_c.info)) in
    Obj.repr(
# 2026 "parser_c.mly"
     ( let (cond,tag,ii) = _1 in
       IfdefDirective ((IfdefElseif cond, IfdefTag (Common.some !tag)), [ii]) )
# 6968 "parser_c.ml"
               : 'cpp_ifdef_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : ((int * int) option ref * Ast_c.info)) in
    Obj.repr(
# 2029 "parser_c.mly"
     ( let (tag,ii) = _1 in
       IfdefDirective ((IfdefEndif, IfdefTag (Common.some !tag)), [ii]) )
# 6976 "parser_c.ml"
               : 'cpp_ifdef_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (bool * (int * int) option ref * Ast_c.info)) in
    Obj.repr(
# 2033 "parser_c.mly"
     ( let (_b, tag,ii) = _1 in
       IfdefDirective ((Ifdef Gnone, IfdefTag (Common.some !tag)), [ii]) )
# 6984 "parser_c.ml"
               : 'cpp_ifdef_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (bool * (int * int) option ref * Ast_c.info)) in
    Obj.repr(
# 2036 "parser_c.mly"
     ( let (_b, tag,ii) = _1 in
       IfdefDirective ((Ifdef Gnone, IfdefTag (Common.some !tag)), [ii]) )
# 6992 "parser_c.ml"
               : 'cpp_ifdef_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (bool * (int * int) option ref * Ast_c.info)) in
    Obj.repr(
# 2039 "parser_c.mly"
     ( let (_b, tag,ii) = _1 in
       IfdefDirective ((Ifdef Gnone, IfdefTag (Common.some !tag)), [ii]) )
# 7000 "parser_c.ml"
               : 'cpp_ifdef_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : 'identifier) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'argument_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2050 "parser_c.mly"
     (
       if args_are_params _3
       then
	 (* if all args are params, assume it is a prototype of a function
	    with no return type *)
	 let parameters = args_to_params _3 None in
	 let paramlist = (parameters, (false, [])) in (* no varargs *)
	 let id = RegularName (mk_string_wrap _1) in
	 let ret =
	   warning "type defaults to 'int'"
	     (mk_ty defaultInt [fakeInfo fake_pi]) in
	 let ty =
	   fixOldCDecl (mk_ty (FunctionType (ret, paramlist)) [_2;_4]) in
	 let attrs = Ast_c.noattr in
	 let sto = (NoSto, false), [] in
	 let iistart = Ast_c.fakeInfo () in
	 Declaration(
	 DeclList ([{v_namei = Some (id,NoInit); v_type = ty;
                      v_storage = unwrap sto; v_local = NotLocalDecl;
                      v_attr = attrs; v_type_bis = ref None;
                    },[]],
                   (_5::iistart::snd sto)))
       else
	 Declaration
	   (MacroDecl((NoSto, fst _1, _3, true), [snd _1;_2;_4;_5;fakeInfo()]))
           (* old: MacroTop (fst $1, $3,    [snd $1;$2;$4;$5])  *)
     )
# 7037 "parser_c.ml"
               : 'cpp_other))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : 'identifier) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'argument_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'compound) in
    Obj.repr(
# 2080 "parser_c.mly"
                                                 (
   let parameters = args_to_params _3 (Some (snd _1)) in
   let paramlist = (parameters, (false, [])) in (* no varargs *)
   let fninfo =
     let id = RegularName (mk_string_wrap _1) in
     let ret =
       warning "type defaults to 'int'"
	 (mk_ty defaultInt [fakeInfo fake_pi]) in
     let ty = mk_ty (FunctionType (ret, paramlist)) [_2;_4] in
     let attrs = Ast_c.noattr in
     let sto = (NoSto, false), [] in
     (id, fixOldCDecl ty, sto, attrs) in
   let fundef = fixFunc (fninfo, _5, None) in
   Definition fundef
 )
# 7062 "parser_c.ml"
               : 'cpp_other))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'identifier) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'argument_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2098 "parser_c.mly"
     ( Declaration
	 (MacroDecl ((NoSto, fst _1, _3, false), [snd _1;_2;_4;fakeInfo()])) )
# 7073 "parser_c.ml"
               : 'cpp_other))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'identifier) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2102 "parser_c.mly"
                      ( EmptyDef [snd _1;_2] )
# 7081 "parser_c.ml"
               : 'cpp_other))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'function_definition) in
    Obj.repr(
# 2111 "parser_c.mly"
                                     ( Definition _1 )
# 7088 "parser_c.ml"
               : 'external_declaration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl) in
    Obj.repr(
# 2112 "parser_c.mly"
                                     ( Declaration (_1 Ast_c.NotLocalDecl) )
# 7095 "parser_c.ml"
               : 'external_declaration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : string * Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : 'translation_unit) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2117 "parser_c.mly"
     ( !LP._lexer_hint.context_stack <- [LP.InTopLevel];
       Namespace (_4, [_1; snd _2; _3; _5]) )
# 7107 "parser_c.ml"
               : Ast_c.toplevel))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'external_declaration) in
    Obj.repr(
# 2120 "parser_c.mly"
                                                ( _1 )
# 7114 "parser_c.ml"
               : Ast_c.toplevel))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_directive) in
    Obj.repr(
# 2124 "parser_c.mly"
     ( CppTop _1 )
# 7121 "parser_c.ml"
               : Ast_c.toplevel))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_other) in
    Obj.repr(
# 2126 "parser_c.mly"
     ( _1 )
# 7128 "parser_c.ml"
               : Ast_c.toplevel))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_ifdef_directive) in
    Obj.repr(
# 2128 "parser_c.mly"
     ( IfdefTop _1 )
# 7135 "parser_c.ml"
               : Ast_c.toplevel))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'asmbody) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2131 "parser_c.mly"
                                                ( EmptyDef [_1;_2;_4;_5] )
# 7146 "parser_c.ml"
               : Ast_c.toplevel))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2138 "parser_c.mly"
              ( EmptyDef [_1] )
# 7153 "parser_c.ml"
               : Ast_c.toplevel))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2141 "parser_c.mly"
              ( FinalDef _1 )
# 7160 "parser_c.ml"
               : Ast_c.toplevel))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2150 "parser_c.mly"
                  ( LP.push_context LP.InFunction; LP.new_scope (); _1 )
# 7167 "parser_c.ml"
               : 'tobrace))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2151 "parser_c.mly"
                  ( LP.pop_context();              LP.del_scope (); _1 )
# 7174 "parser_c.ml"
               : 'tcbrace))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2153 "parser_c.mly"
                      ( LP.push_context LP.InEnum; _1 )
# 7181 "parser_c.ml"
               : 'tobrace_enum))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2154 "parser_c.mly"
                      ( LP.pop_context (); _1 )
# 7188 "parser_c.ml"
               : 'tcbrace_enum))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2156 "parser_c.mly"
                     ( LP.push_context LP.InInitializer; _1 )
# 7195 "parser_c.ml"
               : 'tobrace_ini))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2157 "parser_c.mly"
                     ( LP.pop_context (); _1 )
# 7202 "parser_c.ml"
               : 'tcbrace_ini))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2159 "parser_c.mly"
                        ( LP.push_context LP.InStruct; _1)
# 7209 "parser_c.ml"
               : 'tobrace_struct))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2160 "parser_c.mly"
                        ( LP.pop_context (); _1 )
# 7216 "parser_c.ml"
               : 'tcbrace_struct))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2166 "parser_c.mly"
     ( LP.new_scope ();et "topar" ();
       LP.push_context LP.InParameter;
       _1
     )
# 7226 "parser_c.ml"
               : 'topar))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2171 "parser_c.mly"
     ( LP.del_scope ();dt "tcpar" ();
       LP.pop_context ();
       _1
     )
# 7236 "parser_c.ml"
               : 'tcpar))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'string_elem) in
    Obj.repr(
# 2210 "parser_c.mly"
               ( _1 )
# 7243 "parser_c.ml"
               : 'string_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'string_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'string_elem) in
    Obj.repr(
# 2211 "parser_c.mly"
                           ( _1 @ _2 )
# 7251 "parser_c.ml"
               : 'string_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'colon_asm) in
    Obj.repr(
# 2214 "parser_c.mly"
             ( [_1] )
# 7258 "parser_c.ml"
               : 'colon_asm_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'colon_asm_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'colon_asm) in
    Obj.repr(
# 2215 "parser_c.mly"
                             ( _1 @ [_2] )
# 7266 "parser_c.ml"
               : 'colon_asm_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'colon_option) in
    Obj.repr(
# 2218 "parser_c.mly"
                ( [_1, []] )
# 7273 "parser_c.ml"
               : 'colon_option_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'colon_option_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'colon_option) in
    Obj.repr(
# 2219 "parser_c.mly"
                                         ( _1 @ [_3, [_2]] )
# 7282 "parser_c.ml"
               : 'colon_option_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'argument_ne) in
    Obj.repr(
# 2223 "parser_c.mly"
                                         ( [_1, []] )
# 7289 "parser_c.ml"
               : 'argument_list_ne))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'argument_list_ne) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'argument) in
    Obj.repr(
# 2224 "parser_c.mly"
                                    ( _1 @ [_3,    [_2]] )
# 7298 "parser_c.ml"
               : 'argument_list_ne))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'argument) in
    Obj.repr(
# 2227 "parser_c.mly"
                                      ( [_1, []] )
# 7305 "parser_c.ml"
               : 'argument_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'argument_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'argument) in
    Obj.repr(
# 2228 "parser_c.mly"
                                 ( _1 @ [_3,    [_2]] )
# 7314 "parser_c.ml"
               : 'argument_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.info)) in
    Obj.repr(
# 2238 "parser_c.mly"
                             ( [RegularName (mk_string_wrap _1), []] )
# 7321 "parser_c.ml"
               : 'ident_define_list_ne))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'ident_define_list_ne) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.info)) in
    Obj.repr(
# 2240 "parser_c.mly"
     ( _1 @ [RegularName (mk_string_wrap _2), []] )
# 7329 "parser_c.ml"
               : 'ident_define_list_ne))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'struct_decl) in
    Obj.repr(
# 2244 "parser_c.mly"
                                 ( [_1] )
# 7336 "parser_c.ml"
               : 'struct_decl_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'struct_decl_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'struct_decl) in
    Obj.repr(
# 2245 "parser_c.mly"
                                 ( _1 @ [_2] )
# 7344 "parser_c.ml"
               : 'struct_decl_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'struct_declarator) in
    Obj.repr(
# 2249 "parser_c.mly"
                                                   ( [_1,           []] )
# 7351 "parser_c.ml"
               : 'struct_declarator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'struct_declarator_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'struct_declarator) in
    Obj.repr(
# 2250 "parser_c.mly"
                                                   ( _1 @ [_3,     [_2]] )
# 7360 "parser_c.ml"
               : 'struct_declarator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'enumerator) in
    Obj.repr(
# 2254 "parser_c.mly"
                                     ( [_1,          []]   )
# 7367 "parser_c.ml"
               : 'enumerator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'enumerator_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'enumerator) in
    Obj.repr(
# 2255 "parser_c.mly"
                                     ( _1 @ [_3,    [_2]] )
# 7376 "parser_c.ml"
               : 'enumerator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'init_declarator) in
    Obj.repr(
# 2259 "parser_c.mly"
                                               ( [_1,   []] )
# 7383 "parser_c.ml"
               : 'init_declarator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'init_declarator_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'init_declarator) in
    Obj.repr(
# 2260 "parser_c.mly"
                                               ( _1 @ [_3,     [_2]] )
# 7392 "parser_c.ml"
               : 'init_declarator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'parameter_decl) in
    Obj.repr(
# 2264 "parser_c.mly"
                                        ( [_1, []] )
# 7399 "parser_c.ml"
               : 'parameter_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'parameter_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'parameter_decl) in
    Obj.repr(
# 2265 "parser_c.mly"
                                        ( _1 @ [_3,  [_2]] )
# 7408 "parser_c.ml"
               : 'parameter_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2268 "parser_c.mly"
                           ( [_1] )
# 7415 "parser_c.ml"
               : 'taction_list_ne))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'taction_list_ne) in
    Obj.repr(
# 2269 "parser_c.mly"
                           ( _1 :: _2 )
# 7423 "parser_c.ml"
               : 'taction_list_ne))
; (fun __caml_parser_env ->
    Obj.repr(
# 2277 "parser_c.mly"
                        ( [] )
# 7429 "parser_c.ml"
               : 'taction_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'taction_list) in
    Obj.repr(
# 2278 "parser_c.mly"
                        ( _1 :: _2 )
# 7437 "parser_c.ml"
               : 'taction_list))
; (fun __caml_parser_env ->
    Obj.repr(
# 2281 "parser_c.mly"
                   ( [] )
# 7443 "parser_c.ml"
               : 'param_define_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'param_define) in
    Obj.repr(
# 2282 "parser_c.mly"
                                          ( [_1, []] )
# 7450 "parser_c.ml"
               : 'param_define_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'param_define_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'param_define) in
    Obj.repr(
# 2283 "parser_c.mly"
                                          ( _1 @ [_3, [_2]] )
# 7459 "parser_c.ml"
               : 'param_define_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'designator) in
    Obj.repr(
# 2286 "parser_c.mly"
              ( [_1] )
# 7466 "parser_c.ml"
               : 'designator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'designator_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'designator) in
    Obj.repr(
# 2287 "parser_c.mly"
                              ( _1 @ [_2] )
# 7474 "parser_c.ml"
               : 'designator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'attribute) in
    Obj.repr(
# 2290 "parser_c.mly"
             ( [_1] )
# 7481 "parser_c.ml"
               : 'attribute_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'attribute_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'attribute) in
    Obj.repr(
# 2291 "parser_c.mly"
                            ( _1 @ [_2] )
# 7489 "parser_c.ml"
               : 'attribute_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'attribute_storage) in
    Obj.repr(
# 2294 "parser_c.mly"
                     ( [_1] )
# 7496 "parser_c.ml"
               : 'attribute_storage_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'attribute_storage_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'attribute_storage) in
    Obj.repr(
# 2295 "parser_c.mly"
                                            ( _1 @ [_2] )
# 7504 "parser_c.ml"
               : 'attribute_storage_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'attribute_list) in
    Obj.repr(
# 2298 "parser_c.mly"
                           ( _1 )
# 7511 "parser_c.ml"
               : 'attributes))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2301 "parser_c.mly"
          (  [_1] )
# 7518 "parser_c.ml"
               : 'comma_opt))
; (fun __caml_parser_env ->
    Obj.repr(
# 2302 "parser_c.mly"
                    (  []  )
# 7524 "parser_c.ml"
               : 'comma_opt))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.expression) in
    Obj.repr(
# 2311 "parser_c.mly"
               ( Some _1 )
# 7531 "parser_c.ml"
               : 'gcc_opt_expr))
; (fun __caml_parser_env ->
    Obj.repr(
# 2312 "parser_c.mly"
                   ( None  )
# 7537 "parser_c.ml"
               : 'gcc_opt_expr))
(* Entry main *)
; (fun __caml_parser_env -> raise (Parsing.YYexit (Parsing.peek_val __caml_parser_env 0)))
(* Entry celem *)
; (fun __caml_parser_env -> raise (Parsing.YYexit (Parsing.peek_val __caml_parser_env 0)))
(* Entry statement *)
; (fun __caml_parser_env -> raise (Parsing.YYexit (Parsing.peek_val __caml_parser_env 0)))
(* Entry expr *)
; (fun __caml_parser_env -> raise (Parsing.YYexit (Parsing.peek_val __caml_parser_env 0)))
(* Entry type_name *)
; (fun __caml_parser_env -> raise (Parsing.YYexit (Parsing.peek_val __caml_parser_env 0)))
|]
let yytables =
  { Parsing.actions=yyact;
    Parsing.transl_const=yytransl_const;
    Parsing.transl_block=yytransl_block;
    Parsing.lhs=yylhs;
    Parsing.len=yylen;
    Parsing.defred=yydefred;
    Parsing.dgoto=yydgoto;
    Parsing.sindex=yysindex;
    Parsing.rindex=yyrindex;
    Parsing.gindex=yygindex;
    Parsing.tablesize=yytablesize;
    Parsing.table=yytable;
    Parsing.check=yycheck;
    Parsing.error_function=parse_error;
    Parsing.names_const=yynames_const;
    Parsing.names_block=yynames_block }
let main (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
   (Parsing.yyparse yytables 1 lexfun lexbuf : Ast_c.program)
let celem (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
   (Parsing.yyparse yytables 2 lexfun lexbuf : Ast_c.toplevel)
let statement (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
   (Parsing.yyparse yytables 3 lexfun lexbuf : Ast_c.statement)
let expr (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
   (Parsing.yyparse yytables 4 lexfun lexbuf : Ast_c.expression)
let type_name (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
   (Parsing.yyparse yytables 5 lexfun lexbuf : Ast_c.fullType)
